' ========================================================================================
' Test Alignment
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display Off
#Debug Error Off
#Optimize Size
#Option Version5
#Register All
#Tools Off
#If %Def( %PB_CC32 )
#Console Off
#EndIf

%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

%SCALEX = 200
%SCALEY = 200
$$TITLE = "Test Alignment"

Global figure, container As ID2D1PathGeometry
Global borderBrush, fillBrush As ID2D1SolidColorBrush

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+80,%SCALEY+80, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Sub AppCreateDeviceIndependentResources()
	Local localSink As ID2D1GeometrySink
	Local rc As RECT
	Local hr As Long

	GetClientRect( win.hwnd, rc)

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Sub
	If Not IsInterface( helper, ID2D1Helper ) Then Exit Sub

	hr = factory.CreatePathGeometry( figure )
	If FAILED( hr ) Then Exit Sub

	hr = figure.Open( localSink )
	If FAILED( hr ) Then Exit Sub

	Local rrx, rry As Single
	Local center As D2D1_POINT_2F
	Local boxSize As D2D1_SIZE_F
	rrx = 2! / CSng( rc.width )
	rry = 2! / CSng( rc.height )
	boxSize.width = 10! / CSng( rc.width )
	boxSize.height = 10! / CSng( rc.height )
	BoxFigureAdd_c2d localSink, rrx, rry, center, boxSize

	localSink.Close
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	BrushSolidColorNew_c2d borderBrush, renderTarget, helper, 255, 128, 128, 192
	BrushSolidColorNew_c2d fillBrush,   renderTarget, helper, 255, 192, 192, 255
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	borderBrush = Nothing
	fillBrush = Nothing
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform As D2D1_MATRIX_3X2_F
	Local rc As RECT
	GetClientRect(hwnd, rc)
	Local padding, w, h As Single

	AppCreateDeviceIndependentResources

	w = 10! / CSng( rc.width )
	h = 10! / CSng( rc.height )
	padding = 1
	rc.width -= padding*2!   ' For Padding only
	rc.height -= padding*2!  ' For Padding only

	MatrixAlignTopLeft_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignTopCenter_c2d( transform, w, h  )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignTopRight_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignCenterLeft_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignCenterCenter_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignCenterRight_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )


	MatrixAlignBottomLeft_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignBottomCenter_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	MatrixAlignBottomRight_c2d( transform, w, h )
	MatrixScaleAdd_c2d( transform, rc.width, rc.height )
	MatrixTranslateAdd_c2d( transform, padding, padding ) ' For Padding only
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )

	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
