' ========================================================================================
' Test Chart Routines
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display On
#Debug Error On
#Optimize Size
#Option Version5
#Register All
#Tools Off
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

$$TITLE = "Test Chart Routines"
%SCALEX = 400
%SCALEY = 400
%ANIMATION = 1

Global anchor, divisions, legendBox, container, dot As ID2D1PathGeometry
Global symbols() As ID2D1TransformedGeometry
Global divisionBrush, anchorBrush As ID2D1SolidColorBrush
Global pal As iPalette_c2d
Global legendFormat, subTitleFormat, titleFormat, yFormat, xFormat As IDWriteTextFormat
Global vTextHeight, yDiv, xDiv, vMax, vMin, vZero As Single
Global started, rotateStart, scaleStart, skewStart As Single
Global animateRotate, animateScale, animateSkew As Long

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	started = Timer
	FrameworkRun $$TITLE + " -R, -S, -K", %SCALEX+220, %SCALEY+120, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Function MyCallback( ByVal i As Long, params As ChartSymbolParams ) As Long
	Select Case params.j
		Case 1: params.symbolRender = CodePtr( ChartSymbol_LineFigureAdd_c2d ): params.isArea = -1
		Case 2: params.symbolRender = CodePtr( ChartSymbol_BarFigureAdd_c2d ): params.isArea = 0: params.width = 20! / %SCALEX
		Case 3: params.symbolRender = CodePtr( ChartSymbol_SpikeFigureAdd_c2d ): params.isArea = 0
	End Select
End Function

Sub AppCreateDeviceIndependentResources()
	Local isHorizontal As Long
	Local zeroX, zeroY As Single
	Local xValues(), yValues(), xPct(), yPct() As Single
	Local params As ChartSymbolParams
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local mn, mx As Long
	Local oCount, cCount, iStep As Long
	Local syms() As ID2D1PathGeometry

	Local rc As D2D1_RECT_F

	CirclePathNew_c2d dot, factory, helper
	TransformPath_c2d dot,    factory, 0,0, 6, 6

	rc.Left = -(%SCALEX / 2!)
	rc.Top = -(%SCALEY / 2!)
	rc.Right =  rc.Left + %SCALEX
	rc.Bottom = rc.Top + %SCALEY
	factory.CreateRectangleGeometry( rc, container )


	PaletteFromFileNew_c2d( pal, helper, factory, "dark", 255 )

	'================================================================
	'User responsibility
	mn = 0: mx = 100
	'mn = -25: mx = 100
	'lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 1
	lb1 = 1: ub1 = 10: lb2 = 1: ub2 = 3

	' Provide data
	ReDim yValues(lb1 To ub1, lb2 To ub2), xValues(lb1 To ub1, lb2 To ub2)
	For i=lb1 To ub1
		For j = lb2 To ub2
			yValues(i,j) = Rnd( mn, mx ) : '+ j*50
			xValues(i,j) = (i-lb1)
		Next
	Next

	params.roundTo        = 25      ' ................... Value to round max values away from zero to.
	params.display.width  = %SCALEX ' ................... Intended rendering width (size scaling will be done from)
	params.display.height = %SCALEY ' ................... Intended rendering height
	params.size           = 12  ' ................... Symbol size
	params.barPadding     = 2   ' ................... space between adjacent bars
	params.groupPadding   = 10  ' ................... space betwwen groups of bars
	params.isArea = -1          ' ................... <>0 if drawing area for: HLine, Step, Line, or Spline
	params.vLayout = %ChartVLayoutType.StackedValue ' Normal, StackedValue, StackedPercent
	params.symbolCallback = CodePtr( MyCallback )

	' Choose a symbol renderer (point is default if none chosen)
	'params.symbolRender = CodePtr( ChartSymbol_HLineFigure )
	'params.symbolRender = CodePtr( ChartSymbol_BarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_StepFigureAdd_c2d )
	params.symbolRender = CodePtr( ChartSymbol_LineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_CircleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_DashFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_DiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowDiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowHexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowSquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStar4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PlusFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PointFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_SquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_Star4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_StarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TickFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_XFigureAdd_c2d )

	ChartSetup_c2d xValues(), yValues(), xPct(), yPct(), params ' Create values to render and setup internal parameter values.
	'================================================================
	vZero = yValues(1,1)
	vZero = yPct(1,1)

	vMax = params.yBounds.vmax
	vMin = params.yBounds.vmin
	vZero = params.zero
	' Uncomment one of the following to test creating a single path

	ChartSymbolPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolSeriesPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolGroupPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params

	lb1 = LBound( symbols(), 1 )
	ub1 = UBound( symbols(), 1 )
	lb2 = LBound( symbols(), 2 )
	ub2 = UBound( symbols(), 2 )
	Local transform As D2D_MATRIX_3X2_F

	isHorizontal = 0
	TransformSimple_c2d transform, 0, 0, %SCALEX, %SCALEY

	For i=lb1 To ub1
		For j=lb2 To ub2
			If IsInterface( symbols(i,j), ID2D1PathGeometry ) Then
				If isHorizontal Then ChartToHorizontal_c2d symbols(i,j), factory
				factory.CreateTransformedGeometry( symbols(i,j), transform, symbols(i,j) )
			Else
				j=j
			End If
		Next
	Next

	zeroX = 0
	zeroY = (.5 - params.zero)
	xDiv = (ub1-lb1+1)
	yDiv = 10

	ChartXYGridPathNew_c2d anchor,    factory, -1, zeroX, zeroY,    0,    0, isHorizontal
	ChartXYGridPathNew_c2d divisions, factory,  0, zeroX, zeroY, xDiv, yDiv, isHorizontal

	TransformPath_c2d anchor,    factory, 0,0, %SCALEX,%SCALEY
	TransformPath_c2d divisions, factory, 0,0, %SCALEX,%SCALEY

	vTextHeight = Min( Min(15!, CSng(%SCALEY) / (yDiv*1.8) ), CSng( %SCALEX) / (xDiv*1.5!)  )
	TextFormatNew_c2d yFormat, writeFactory, "Segoe UI", vTextHeight
	yFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_TRAILING )

	TextFormatNew_c2d xFormat, writeFactory, "Segoe UI", vTextHeight
	xFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_LEADING )

	TextFormatNew_c2d titleFormat, writeFactory, "Segoe UI", 30, %DWRITE_FONT_WEIGHT_BOLD
	titleFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_CENTER )

	TextFormatNew_c2d subTitleFormat, writeFactory, "Segoe UI", 15, %DWRITE_FONT_WEIGHT_NORMAL, %DWRITE_FONT_STYLE_ITALIC
	subTitleFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_CENTER )

	TextFormatNew_c2d legendFormat, writeFactory, "Segoe UI", vTextHeight
	legendFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_LEADING )

	BoxPathNew_c2d legendBox, factory
	TransformPath_c2d legendBox, factory, vTextHeight*.7, vTextHeight*.7, vTextHeight, vTextHeight
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	Local brushProperties As D2D1_BRUSH_PROPERTIES
	Local drender As iDirectRender

	brushProperties.opacity = 1.0
	brushProperties.transform = helper.IdentityMatrix()

	BrushSolidColorNew_c2d( divisionBrush, renderTarget, helper, 255, 128, 128, 192 )
	BrushSolidColorNew_c2d( anchorBrush, renderTarget, helper, 255, 192, 192, 255 )

	drender = pal
	If IsObject( drender ) Then drender.CreateDeviceResources(renderTarget)
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	Local drender As iDirectRender
	divisionBrush = Nothing
	anchorBrush = Nothing
	drender = pal
	If IsObject( drender ) Then drender.DiscardDeviceResources()
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform, working As D2D1_MATRIX_3X2_F
	Local disp As ID2D1Geometry
	Local br As ID2D1SolidColorBrush
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local rc As RECT
	Local titlerc As D2D1_RECT_F
	Local zero, pct, yStep, x, y, v, cx, cy, textHeight  As Single
	Local trc As D2D1_RECT_F
	Local msg As WStringZ * 100

	GetClientRect(hwnd, rc)
	Local titleHeight, valueWidth, legendWidth, seriesHeight As Single
	Local controlWidth, controlHeight As Single
	Local legendCount, seriesCount As Long
	Local chartTitle, chartSubTitle As WString

	Local titleFontHeight, subTitleFontHeight As Single
	Local legendLabels(), seriesLabels() As WString

	transform = helper.MatrixTranslation( rc.width/2, rc.height/2 )
	renderTarget.SetTransform( transform )
	renderTarget.DrawGeometry( container, anchorBrush, .5! )

	' Basic user supplied values
	chartTitle = "ACME Unlimited"
	chartSubTitle = "Division Profit (millions)"
	titleFontHeight = 30!
	subTitleFontHeight = 15!
	legendCount = UBound( symbols(), 2 )-LBound( symbols(), 2 ) + 1
	seriesCount = UBound( symbols(), 1 ) - LBound( symbols(), 1 ) + 1
	ReDim legendLabels( legendCount-1 ), seriesLabels( seriesCount-1 )
	For i = 0 To legendCount-1
		legendLabels(i) = "Division " + Chr$(65+i)
	Next
	For i = 0 To seriesCount-1
		seriesLabels(i) = "Item " + Chr$(65+i)
	Next
	controlHeight = %SCALEY
	controlWidth = %SCALEX

	'========================================================================
	textHeight = vTextHeight

	legendWidth = ChartLegendWidth_c2d( legendLabels(), textHeight, legendFormat, writeFactory )
	valueWidth = ChartValueWidth_c2d( vMax, vMin, textHeight, yFormat, writeFactory )
	seriesHeight = ChartSeriesHeight_c2d( seriesLabels(), textHeight, xFormat, writeFactory )
	titleHeight = ChartTitleHeight_c2d( titleFontHeight, subTitleFontHeight )

	Local centerX, centerY, chartWidth, chartHeight, chartLeft, chartTop, chartRight, chartBottom As Single
	chartWidth = controlWidth - legendWidth - valueWidth - 4 - 4
	chartHeight = controlHeight - seriesHeight - titleHeight - 4 - 4
	centerX = (legendWidth - valueWidth) / 2
	centerY = 0
	chartLeft = -centerX - chartWidth / 2!
	chartRight = chartLeft + chartWidth
	chartTop = -centerY - chartHeight / 2!
	chartBottom = chartTop + chartHeight

	zero = chartTop - (1-(.5-vZero)) * chartHeight

	Local center As D2D1_POINT_2F
	Local angle As Single
	MatrixIdentity_c2d transform
	If animateRotate Then
		angle = (Timer - rotateStart)*30
		MatrixTranslateAdd_c2d transform, -centerX, (titleHeight - seriesHeight)/2
		MatrixRotate_c2d transform, angle, center
	End If
	If animateScale Then
		angle = (Timer - scaleStart + 3.1415)*10
		angle = (1 + Sin( angle / 20 )) / 2
		MatrixScaleAdd_c2d transform, angle, angle
	End If
	If animateSkew Then
		angle = (Timer - skewStart - 3.1415)*10
		angle = (1 + Sin( angle / 20 )) *20
		MatrixSkewAdd_c2d transform, angle, angle
	End If
	MatrixTranslateAdd_c2d transform, rc.width/2, rc.height/2

	titlerc.left = rc.left
	titlerc.right = rc.right
	titlerc.bottom = rc.height/2 - %SCALEY/2 - 20 - 10
	titlerc.top = titlerc.bottom - 30

	ChartTitleRender_c2d chartLeft, chartTop, chartWidth, chartTitle, chartSubTitle, titleFontHeight, subTitleFontHeight, transform

	' Draw chart
	lb1 = LBound( symbols(), 1 )
	ub1 = UBound( symbols(), 1 )
	lb2 = LBound( symbols(), 2 )
	ub2 = UBound( symbols(), 2 )

	MatrixScale_c2d( working, chartWidth / controlWidth, chartHeight / controlHeight ) ' Scale it to the space that's left
	MatrixTranslateAdd_c2d( working, -centerX, -centerY )                              ' move it's center to the new center
	MatrixMultiply_c2d( working, working, transform )                                  ' Add in whatever the world transform is
	renderTarget.SetTransform( working )

	For j=lb2 To ub2
		For i = lb1 To ub1
			pal.GetBrush( (j-lb2), br )
			disp = symbols( i, j )
			renderTarget.FillGeometry( disp, br )
			renderTarget.DrawGeometry( disp, anchorBrush, 0.5! )
		Next
	Next

	' Draw Grid
	renderTarget.DrawGeometry( divisions, divisionBrush, .5! )

	' Draw Anchor
	renderTarget.DrawGeometry( anchor,    anchorBrush, 3! )

	renderTarget.SetTransform( helper.IdentityMatrix() )

	ChartValuesRender_c2d yDiv, chartLeft, chartTop, zero, vMax, vMin, controlHeight, textHeight, yFormat, writeFactory, transform
	ChartSeriesRender_c2d seriesLabels(), xDiv, chartLeft, chartBottom, chartWidth, textHeight, xFormat, writeFactory, transform
	ChartLegendRender_c2d legendLabels(), chartRight, chartTop, textHeight, pal, transform

	MatrixTranslate_c2d transform, rc.width/2, rc.height/2
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( dot, anchorBrush )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
	Local title As WString
	' App specific events
	Select Case uMsg
		Case %WM_KeyDown
			If wParam=%VK_R Then
				animateRotate = Not animateRotate
				If animateRotate Then rotateStart = Timer
			End If
			If wParam=%VK_S Then
				animateScale = Not animateScale
				If animateScale Then scaleStart = Timer
			End If
			If wParam=%VK_K Then
				animateSkew = Not animateSkew
				If animateSkew Then skewStart = Timer
			End If

			title = $$TITLE + " "
			title += IIf$( animateRotate, "+", "-" )
			title += "R, "
			title += IIf$( animateScale, "+", "-" )
			title += "S, "
			title += IIf$( animateSkew, "+", "-" )
			title += "K"
			SetWindowText(hwnd, ByVal StrPtr(title))

			If animateRotate Or animateScale Or animateSkew Then
				SetTimer win.hWnd, %ANIMATION, 20, CodePtr( AppWindowProc ): ' Start animation timer 60 fps (1000/60)=16.6
			Else
				KillTimer win.hWnd, %ANIMATION
				InvalidateRect( hWnd, ByVal %NULL, 0 ): ' Redraw window
			End If

		Case %WM_Timer
			InvalidateRect( hWnd, ByVal %NULL, 0 ): ' Redraw window
			Function = -1
			Exit Function
	End Select
End Function

Function ChartLegendWidth_c2d( values() As WString, textHeight As Single, textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory ) As Single
	Local msg As WStringZ * 260
	Local textLayout As IDWriteTextLayout
	Local textMetrics As DWRITE_TEXT_METRICS
	Local w As Single
	Local i As Long

	w = 0!
	For i=LBound(values()) To UBound(values())
		msg = values(i)
		TextLayoutNew_c2d textLayout, writeFactory, textFormat, msg, 500, CLng(textHeight)
		textLayout.GetMetrics(textMetrics)
		w = Max( w!, 4! + textHeight! + 8 + textMetrics.width )
		textLayout = Nothing
	Next
	Function = w
End Function

Sub ChartLegendRender_c2d( legendLabels() As WString, chartRight As Single, chartTop As Single, textHeight As Single, pal As iPalette_c2d, transform As D2D1_MATRIX_3X2_F )
	Local working, working2 As D2D1_MATRIX_3X2_F
	Local y As Single
	Local i, lb, ub As Long
	Local trc As D2D1_RECT_F
	Local br As ID2D1SolidColorBrush
	Local msg As WStringZ * 260

	y = 0
	trc.Left = textHeight + 8
	trc.Right = 300!
	trc.top = 0
	trc.bottom = textHeight
	lb = LBound( legendLabels() )
	ub = UBound( legendLabels() )
	For i= lb To ub

		MatrixTranslate_c2d working, chartRight + 4, chartTop+y
		MatrixMultiply_c2d working, working, transform
		renderTarget.SetTransform( working )

		pal.GetBrush( (i-lb), br )
		renderTarget.FillGeometry( legendBox, br )
		renderTarget.DrawGeometry( legendBox, anchorBrush, .5 )

		msg = legendLabels(i)
		TextFormatRender_c2d renderTarget, msg, legendFormat, anchorBrush, trc
		y += textHeight*1.5
	Next
	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function ChartTitleHeight_c2d( mainHeight As Single, subHeight As Single ) As Single
	Function = mainHeight + 2.5! + subHeight + 8
End Function

Sub ChartTitleRender_c2d( ByVal chartLeft As Single, ByVal chartTop As Single, ByVal chartWidth As Single, chartTitle As WString, chartSubTitle As WString, ByVal titleHeight As Single, ByVal subTitleHeight As Single, transform As D2D1_MATRIX_3X2_F )
	Local msg As WStringZ * 260
	Local titlerc As D2D1_RECT_F
	Local chartTitleHeight As Single

	If chartSubTitle="" Then subTitleHeight = 0!
	If chartTitle = "" Then titleHeight = 0!

	chartTitleHeight = ChartTitleHeight_c2d( titleHeight, subTitleHeight )

	renderTarget.SetTransform( transform )

	titlerc.left = chartLeft
	titlerc.right = chartLeft+chartWidth
	titlerc.top = chartTop - chartTitleHeight
	titlerc.bottom = chartTop + titleHeight

	msg = chartTitle
	TextFormatRender_c2d( renderTarget, msg, titleFormat, anchorBrush, titlerc  )
	titlerc.top += titleHeight + 2.5
	titlerc.bottom = titleRc.top + subTitleHeight
	msg  = chartSubTitle
	TextFormatRender_c2d( renderTarget , msg, subTitleFormat, anchorBrush, titlerc )
End Sub

Function ChartValueWidth_c2d( vMax As Single, vMin As Single, textHeight As Single, textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory ) As Single
	Local msg As WStringZ * 260
	Local textLayout As IDWriteTextLayout
	Local textMetrics As DWRITE_TEXT_METRICS
	Local w As Single

	msg = Format$( vMax, "#,##0" )
	TextLayoutNew_c2d textLayout, writeFactory, textFormat, msg, 500, CLng(textHeight)
	textLayout.GetMetrics( textMetrics )
	w = textMetrics.width
	textLayout = Nothing

	msg = Format$( vMin, "#,##0" )
	TextLayoutNew_c2d textLayout, writeFactory, textFormat, msg, 500, CLng(textHeight)
	textLayout.GetMetrics( textMetrics )
	w = Max( w, textMetrics.width )
	textLayout = Nothing

	Function = w
End Function

Sub ChartValuesRender_c2d( yDivisions As Single, chartLeft As Single, chartTop As Single, zero As Single, vMax As Single, vMin As Single, controlHeight As Single, textHeight As Single, _
													textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory, transform As D2D1_MATRIX_3X2_F )
	Local msg As WStringZ * 260
	Local trc As D2D1_RECT_F
	Local textLayout As IDWriteTextLayout
	Local textMetrics As DWRITE_TEXT_METRICS
	Local w As Single
	Local height, y, v, vStep, yStep, pct As Single
	Local working As D2D1_MATRIX_3X2_F

	height = chartTop - zero
	yStep = height / yDivisions
	vStep = vMax / yDivisions
	v = chartTop - textHeight * .7
	trc.left = -300
	trc.right = 0
	trc.top = 0
	trc.bottom = textHeight
	For y = vMax To vMin Step -vStep
		MatrixTranslate_c2d working, chartLeft - 4, v
		MatrixMultiply_c2d working, working, transform
		renderTarget.SetTransform( working )
		msg = Format$( y, "#,##0" )
		TextFormatRender_c2d renderTarget, msg, textFormat, anchorBrush, trc
		v += yStep
	Next
End Sub

Function ChartSeriesHeight_c2d( labels() As WString, textHeight As Single, textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory ) As Single
	Local msg As WStringZ * 260
	Local textLayout As IDWriteTextLayout
	Local textMetrics As DWRITE_TEXT_METRICS
	Local h As Single
	Local m As D2D1_MATRIX_3X2_F
	Local origin, center As D2D1_POINT_2F
	Local i As Long
	Local angle As Single

	h = 0
	angle = Sin( degreesToRadians( -45 ) )
	For i = LBound( labels() ) To UBound( labels() )
		msg = labels(i)
		TextLayoutNew_c2d textLayout, writeFactory, textFormat, msg, 500, CLng(textHeight)
		textLayout.GetMetrics(textMetrics)
		h = Max( h, Abs(textMetrics.width * angle) )
		textLayout = Nothing
	Next
	Function = h
End Function

Sub ChartSeriesRender_c2d( seriesLabels() As WString, xDivisions As Single, chartLeft As Single, chartBottom As Single, chartWidth As Single, textHeight As Single, _
													textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory, transform As D2D1_MATRIX_3X2_F )
	Local working As D2D1_MATRIX_3X2_F
	Local xStep As Single
	Local msg As WStringZ * 260
	Local textLayout As IDWriteTextLayout
	Local i, lb, ub, o As Long
	Local textMetrics As DWRITE_TEXT_METRICS
	Local origin, center As D2D1_POINT_2F
	Local l, t As Single

	xStep = chartWidth / xDivisions
	lb =LBound( seriesLabels() )
	ub =UBound( seriesLabels() )

	For i = lb To ub
		msg = seriesLabels( i )
		o = i - lb
		TextLayoutNew_c2d textLayout, writeFactory, xFormat, msg, 500, CLng(textHeight)
		textLayout.GetMetrics(textMetrics)
		origin.x = textMetrics.width
		origin.y = textMetrics.height / 2.0
		MatrixTranslate_c2d working, (-textMetrics.width), (-textMetrics.height / 2.0)
		MatrixRotateAdd_c2d working, -45, center
		MatrixTranslateAdd_c2d working, chartLeft + xStep/2 + o*xStep, chartBottom+8
		MatrixMultiply_c2d working, working, transform
		renderTarget.SetTransform( working )
		TextLayoutRender_c2d renderTarget, textLayout, anchorBrush, center
	Next
End Sub
