' ========================================================================================
' Test Chart X/Y Grid Path
' See tests\path for actual tests
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display On
#Debug Error On
#Optimize Size
#Option Version5
#Register All
#Tools On
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

$$TITLE = "Test Chart X/Y Grid"
%SCALEX = 400
%SCALEY = 400

Global anchor, divisions, legendBox As ID2D1PathGeometry
Global symbols() As ID2D1TransformedGeometry
Global divisionBrush, anchorBrush As ID2D1SolidColorBrush
Global pal As iPalette_c2d
Global legendFormat, subTitleFormat, titleFormat, yFormat, xFormat As IDWriteTextFormat
Global vTextHeight, yDiv, xDiv, vMax, vMin, vZero As Single

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+220, %SCALEY+120, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Function MyCallback( ByVal i As Long, params As ChartSymbolParams ) As Long
	Select Case params.j
		Case 1: params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d ): params.isArea = -1
		Case 2: params.symbolRender = CodePtr( ChartSymbol_BarFigureAdd_c2d ): params.isArea = 0: params.width = 20! / %SCALEX
		Case 3: params.symbolRender = CodePtr( ChartSymbol_SpikeFigureAdd_c2d ): params.isArea = 0
	End Select
End Function

Sub AppCreateDeviceIndependentResources()
	Local isHorizontal As Long
	Local zeroX, zeroY As Single
	Local xValues(), yValues(), xPct(), yPct() As Single
	Local params As ChartSymbolParams
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local mn, mx As Long
	Local oCount, cCount, iStep As Long
	Local syms() As ID2D1PathGeometry

	PaletteFromFileNew_c2d( pal, helper, factory, "dark", 255 )

	'================================================================
	'User responsibility
	'mn = 0: mx = 100
	mn = -25: mx = 100
	'lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 1
	lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 3

	' Provide data
	ReDim yValues(lb1 To ub1, lb2 To ub2), xValues(lb1 To ub1, lb2 To ub2)
	For i=lb1 To ub1
		For j = lb2 To ub2
			yValues(i,j) = Rnd( mn, mx ) : '+ j*50
			xValues(i,j) = (i-lb1)
		Next
	Next

	params.roundTo        = 25      ' ................... Value to round max values away from zero to.
	params.display.width  = %SCALEX ' ................... Intended rendering width (size scaling will be done from)
	params.display.height = %SCALEY ' ................... Intended rendering height
	params.size           = 12  ' ................... Symbol size
	params.barPadding     = 2   ' ................... space between adjacent bars
	params.groupPadding   = 10  ' ................... space betwwen groups of bars
	'params.isArea = -1          ' ................... <>0 if drawing area for: HLine, Step, Line, or Spline
	'params.vLayout = %ChartVLayoutType.StackedValue ' Normal, StackedValue, StackedPercent
	'params.symbolCallback = CodePtr( MyCallback )

	' Choose a symbol renderer (point is default if none chosen)
	'params.symbolRender = CodePtr( ChartSymbol_HLineFigure )
	params.symbolRender = CodePtr( ChartSymbol_BarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_StepFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_LineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_CircleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_DashFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_DiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowDiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowHexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowSquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStar4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PlusFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_PointFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_SquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_Star4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_StarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TickFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_TriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartSymbol_XFigureAdd_c2d )

	ChartSetup_c2d xValues(), yValues(), xPct(), yPct(), params ' Create values to render and setup internal parameter values.
	'================================================================
	vZero = yValues(1,1)
	vZero = yPct(1,1)

	vMax = params.yBounds.vmax
	vMin = params.yBounds.vmin
	vZero = params.zero
	' Uncomment one of the following to test creating a single path

	ChartSymbolPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolSeriesPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolGroupPathsNew_c2d symbols(), factory, xValues(), yValues(), xPct(), yPct(), params

	lb1 = LBound( symbols(), 1 )
	ub1 = UBound( symbols(), 1 )
	lb2 = LBound( symbols(), 2 )
	ub2 = UBound( symbols(), 2 )
	Local transform As D2D_MATRIX_3X2_F

	isHorizontal = 0
	TransformSimple_c2d transform, 0, 0, %SCALEX, %SCALEY

	For i=lb1 To ub1
		For j=lb2 To ub2
			If IsInterface( symbols(i,j), ID2D1PathGeometry ) Then
				If isHorizontal Then ChartToHorizontal_c2d symbols(i,j), factory
				factory.CreateTransformedGeometry( symbols(i,j), transform, symbols(i,j) )
			Else
				j=j
			End If
		Next
	Next

	zeroX = 0
	zeroY = (.5 - params.zero)
	xDiv = (ub1-lb1+1)
	yDiv = 10

	ChartXYGridPathNew_c2d anchor,    factory, -1, zeroX, zeroY,    0,    0, isHorizontal
	ChartXYGridPathNew_c2d divisions, factory,  0, zeroX, zeroY, xDiv, yDiv, isHorizontal

	TransformPath_c2d anchor,    factory, 0,0, %SCALEX,%SCALEY
	TransformPath_c2d divisions, factory, 0,0, %SCALEX,%SCALEY

	vTextHeight = Min(15!, CSng(%SCALEY) / (10!*1.8) )
	TextFormatNew_c2d yFormat, writeFactory, "Segoe UI", vTextHeight
	yFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_TRAILING )

	TextFormatNew_c2d xFormat, writeFactory, "Segoe UI", vTextHeight
	xFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_LEADING )

	TextFormatNew_c2d titleFormat, writeFactory, "Segoe UI", 30, %DWRITE_FONT_WEIGHT_BOLD
	titleFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_CENTER )

	TextFormatNew_c2d subTitleFormat, writeFactory, "Segoe UI", 15, %DWRITE_FONT_WEIGHT_NORMAL, %DWRITE_FONT_STYLE_ITALIC
	subTitleFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_CENTER )

	TextFormatNew_c2d legendFormat, writeFactory, "Segoe UI", vTextHeight
	legendFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_LEADING )

	BoxPathNew_c2d legendBox, factory
	TransformPath_c2d legendBox, factory, vTextHeight*.7, vTextHeight*.7, vTextHeight, vTextHeight
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	Local brushProperties As D2D1_BRUSH_PROPERTIES
	Local drender As iDirectRender

	brushProperties.opacity = 1.0
	brushProperties.transform = helper.IdentityMatrix()

'  CreateSolidColorBrush( divisionBrush, renderTarget, helper, 255, 180, 160, 140 )
'  CreateSolidColorBrush( anchorBrush, renderTarget, helper, 255, 120, 100, 80 )

	BrushSolidColorNew_c2d divisionBrush, renderTarget, helper, 255, 128, 128, 192
	BrushSolidColorNew_c2d anchorBrush, renderTarget, helper, 255, 192, 192, 255

'  renderTarget.CreateSolidColorBrush( helper.ColorF( 128!/255!, 128!/255!, 192!/255!, 1.0 ), _
'                                            brushProperties, _
'                                            divisionBrush )

'  renderTarget.CreateSolidColorBrush( helper.ColorF( 192!/255!, 192!/255!, 255!/255!, 1.0 ), _
'                                            brushProperties, _
'                                            anchorBrush )
	drender = pal
	If IsObject( drender ) Then drender.CreateDeviceResources(renderTarget)
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	Local drender As iDirectRender
	divisionBrush = Nothing
	anchorBrush = Nothing
	drender = pal
	If IsObject( drender ) Then drender.DiscardDeviceResources()
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform As D2D1_MATRIX_3X2_F
	Local disp As ID2D1Geometry
	Local br As ID2D1SolidColorBrush
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local rc As RECT
	Local titlerc As D2D1_RECT_F
	GetClientRect(hwnd, rc)

	titlerc.left = rc.left
	titlerc.right = rc.right
	titlerc.bottom = rc.height/2 - %SCALEY/2 - 20 - 10
	titlerc.top = titlerc.bottom - 30

	TextFormatRender_c2d( renderTarget , "ACME Unlimited", titleFormat, anchorBrush, titlerc  )
	titlerc.top += 30 + 2.5
	titlerc.bottom = titleRc.top + 15
	TextFormatRender_c2d( renderTarget , "Division Profit (millions)", subTitleFormat, anchorBrush, titlerc )

	transform = helper.MatrixTranslation( rc.width/2, rc.height/2  )
	renderTarget.SetTransform( transform )


	' Draw chart
	lb1 = LBound( symbols(), 1 )
	ub1 = UBound( symbols(), 1 )
	lb2 = LBound( symbols(), 2 )
	ub2 = UBound( symbols(), 2 )

	For j=lb2 To ub2
		For i = lb1 To ub1
			If IsInterface( pal, iPalette_c2d ) Then
				'pal.GetBrush( (i-lb1)*(ub2-lb2+1)+(j-lb2), br )
				pal.GetBrush( (j-lb2), br )
				'pal.GetBrush( (i-lb1), br )
			Else
				i = i
			End If
			If Not IsInterface( br, ID2D1SolidColorBrush ) Then
				i = i
			End If
			If IsInterface( symbols( i, j ), ID2D1Geometry ) Then
				disp = symbols( i, j )
				renderTarget.FillGeometry( disp, br )
				'if j=1 then
					renderTarget.DrawGeometry( disp, anchorBrush, 0.5! )
				'Else
				'  renderTarget.DrawGeometry( disp, br, 0.5! )
				'End If
			Else
				i = i
			End If
		Next
	Next

	' Draw Grid
	renderTarget.DrawGeometry( divisions, divisionBrush, .5! )

	' Draw Anchor
	renderTarget.DrawGeometry( anchor,    anchorBrush, 3! )

	renderTarget.SetTransform( helper.IdentityMatrix() )

	Local zero, pct, yStep, x, y, v, cx, cy, textHeight  As Single
	Local trc As D2D1_RECT_F
	Local msg As WStringZ * 100
	cx = rc.width / 2!
	cy = rc.height / 2!

	zero = vZero * %SCALEY + cy
	pct = vZero + .5
	yStep = (pct * %SCALEY) / yDiv
	v = 0
	textHeight = vTextHeight
	trc.right = cx - %SCALEX/2 - 5
	trc.left = trc.right - 100
	For y = zero To cy - %SCALEY/2 Step -yStep
		trc.top = y - textHeight * .7
		trc.bottom = trc.top + textHeight
		msg = Format$( v, "#,##0" )
		TextFormatRender_c2d renderTarget, msg, yFormat, anchorBrush, trc
		v += (vMax / 10!)
	Next

	If vMin < 0 Then
		v = -(vMax / 10!)
		For y = zero+yStep To cy + %SCALEY/2 Step yStep
			trc.top = y - textHeight * .7
			trc.bottom = trc.top + textHeight
			msg = Format$( v, "#,##0" )
			TextFormatRender_c2d renderTarget, msg, yFormat, anchorBrush, trc
			v -= (vMax / 10!)
		Next
	End If


	y = cy + %SCALEY/2! + 5
	Local divW As Single
	divW = %SCALEX / xDiv
	x = cx - %SCALEX/2! + divW /2! - vTextHeight

	Local textLayout As IDWriteTextLayout
	Local m As D2D1_MATRIX_3X2_F
	Local origin, center As D2D1_POINT_2F
	Local textMetrics As DWRITE_TEXT_METRICS

	For i = 0 To xDiv-1
		msg = "Item " + Chr$( 65 + i )
		TextLayoutNew_c2d textLayout, writeFactory, xFormat, msg, 500, CLng(vTextHeight)
		textLayout.GetMetrics(textMetrics)
		origin.x = textMetrics.width
		origin.y = -textMetrics.height / 2.0
		MatrixRotate_c2d m, -45, origin
		MatrixTranslateAdd_c2d m, x-textMetrics.width, y
		renderTarget.SetTransform m
		TextLayoutRender_c2d renderTarget, textLayout, anchorBrush, center

		x += divW
	Next

	renderTarget.SetTransform( helper.IdentityMatrix() )
	trc.left = cx + %SCALEX/2! + 10! + vTextHeight*2!
	trc.right = trc.left + 300
	y = cy - %SCALEY/2 + 10

	For i=1 To 3
		trc.top = y
		trc.bottom = trc.top + textHeight

		MatrixTranslate_c2d m, trc.left - vTextHeight*1.5, trc.top
		renderTarget.SetTransform m

		pal.GetBrush( (i-1), br )
		renderTarget.FillGeometry( legendBox, br )
		renderTarget.DrawGeometry( legendBox, anchorBrush, .5 )

		renderTarget.SetTransform( helper.IdentityMatrix() )
		msg = "Division " + Chr$( 64 + i )
		TextFormatRender_c2d renderTarget, msg, legendFormat, anchorBrush, trc
		y += textHeight*1.5
	Next

End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
