' ========================================================================================
' Test Figures
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display Off
#Debug Error Off
#Optimize Size
#Option Version5
#Register All
#Tools Off
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

' Uncomment 1 of the following lines, compile, and run
' Note: each file often has multiple tests in it.

#Include "tests\figure\boxTest.inc"
'#include "tests\figure\chartLinesTest.inc"
'#include "tests\figure\chartRadarLinesTest.inc"
'#Include "tests\figure\chartRadarSymbolTest.inc"
'#include "tests\figure\chartSpiderLinesTest.inc"
'#Include "tests\figure\chartSymbolTest.inc"
'#include "tests\figure\circleTest.inc"
'#include "tests\figure\donutSliceTest.inc"
'#include "tests\figure\needleTest.inc"
'#include "tests\figure\pieTest.inc"
'#include "tests\figure\pillTest.inc"
'#Include "tests\figure\polygonTest.inc"
'#include "tests\figure\puzzleTest.inc"
'#Include "tests\figure\reticleArcTest.inc"
'#include "tests\figure\reticleTest.inc"
'#Include "tests\figure\tombstoneTest.inc"

#If Not %Def( %SCALEX )
%SCALEX = 200
#EndIf

#If Not %Def( %SCALEY )
%SCALEY = 200
#EndIf

#If Not %Def( $$TITLE )
$$TITLE = "Test"
#EndIf

Global figure, container As ID2D1PathGeometry
Global borderBrush, fillBrush As ID2D1SolidColorBrush

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+80,%SCALEY+80, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Sub AppCreateDeviceIndependentResources()
	Local localSink As ID2D1GeometrySink
	Local hr As Long
	Local rc As D2D1_RECT_F

	rc.Left = -(%SCALEX / 2!)
	rc.Top = -(%SCALEY / 2!)
	rc.Right =  rc.Left + %SCALEX
	rc.Bottom = rc.Top + %SCALEY
	factory.CreateRectangleGeometry( rc, container )

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Sub
	If Not IsInterface( helper, ID2D1Helper ) Then Exit Sub

	hr = factory.CreatePathGeometry( figure )
	If FAILED( hr ) Then Exit Sub

	hr = figure.Open( localSink )
	If FAILED( hr ) Then Exit Sub

	TestFigure( localSink )

	localSink.Close

	' Use transforms to get it the size and location desired
	' Make it the size we want
	TransformPath_c2d figure, factory, 0,0, %SCALEX,%SCALEY

	' Can I "Stack" transforms? (YES)
	'PathTransform figure, factory, helper, 20,20
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	BrushSolidColorNew_c2d borderBrush, renderTarget, helper, 255, 128, 128, 192
	BrushSolidColorNew_c2d fillBrush,   renderTarget, helper, 255, 192, 192, 255
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	borderBrush = Nothing
	fillBrush = Nothing
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform, a, b As D2D1_MATRIX_3X2_F
	Local center As D2D1_POINT_2F
	Local rc As RECT
	GetClientRect(hwnd, rc)

'  MatrixRotation( transform, 45, center )
'  AddMatrixTranslation( transform, rc.width/2, rc.height/2 )
	MatrixTranslate_c2d( transform, rc.width/2, rc.height/2 )

	renderTarget.SetTransform( transform )

	renderTarget.DrawGeometry( container, borderBrush, .5! )

	renderTarget.FillGeometry( figure, fillBrush )
	renderTarget.DrawGeometry( figure, borderBrush, 0.5! )

	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
