' ========================================================================================
' Test Path
' See tests\path for actual tests
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display Off
#Debug Error Off
#Optimize Size
#Option Version5
#Register All
#Tools Off
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

' Uncomment 1 of the following lines, compile, and run
' Note: each file often has multiple tests in it.

#Include "tests\path\arcPathTest.inc"
'#Include "tests\path\attachmentPathTest.inc"
'#Include "tests\path\boxPathTest.inc"
'#Include "tests\path\bubblePathTest.inc"
'#Include "tests\path\calendarPathTest.inc"
'#Include "tests\path\chartGridTest.inc"
'#Include "tests\path\chartRadarGridTest.inc"
'#Include "tests\path\chartRadarSymbolTest.inc"
'#Include "tests\path\chartSpiderGridTest.inc"
'#Include "tests\path\chartSymbolTest.inc"
'#Include "tests\path\circlePathTest.inc"
'#Include "tests\path\clipboardPathTest.inc"
'#Include "tests\path\clipPathTest.inc"
'#Include "tests\path\coolPathTest.inc"
'#Include "tests\path\databasePathTest.inc"
'#include "tests\path\donutWedgePathTest.inc"
'#Include "tests\path\fingerprintPathTest.inc"
'#Include "tests\path\heartPathTest.inc"
'#Include "tests\path\ignorePathTest.inc"
'#Include "tests\path\lcd16PathTest.inc"
'#Include "tests\path\lcd7PathTest.inc"
'#Include "tests\path\led5x7PathTest.inc"
'#Include "tests\path\linePathTest.inc"
'#Include "tests\path\mailReadPathTest.inc"
'#Include "tests\path\manPathTest.inc"
'#Include "tests\path\mazePathTest.inc"
'#Include "tests\path\needlePathTest.inc"
'#Include "tests\path\paintPathTest.inc"
'#Include "tests\path\piePathTest.inc"
'#Include "tests\path\pillPathTest.inc"
'#Include "tests\path\pinPathTest.inc"
'#Include "tests\path\plusPathTest.inc"
'#Include "tests\path\polygonPathTest.inc"
'#Include "tests\path\pulsePathTest.inc"
'#Include "tests\path\puzzlePathTest.inc"
'#Include "tests\path\reticleArcPathTest.inc"
'#Include "tests\path\reticlePathTest.inc"
'#Include "tests\path\starPathTest.inc"
'#Include "tests\path\tombstonePathTest.inc"
'#Include "tests\path\webPathTest.inc"

#If Not %Def( $$TITLE )
$$TITLE = "Test"
#EndIf
#If Not %Def( %SCALEX )
%SCALEX = 200
#EndIf
#If Not %Def( %SCALEY )
%SCALEY = 200
#EndIf

Global figure, container As ID2D1PathGeometry
Global borderBrush, fillBrush As ID2D1SolidColorBrush

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+80, %SCALEY+80, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Sub AppCreateDeviceIndependentResources()
	Local rc As D2D1_RECT_F

	rc.Left = -(%SCALEX / 2!)
	rc.Top = -(%SCALEY / 2!)
	rc.Right =  rc.Left + %SCALEX
	rc.Bottom = rc.Top + %SCALEY
	factory.CreateRectangleGeometry( rc, container )

	TestPath( figure )
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	Local brushProperties As D2D1_BRUSH_PROPERTIES

	brushProperties.opacity = 1.0
	brushProperties.transform = helper.IdentityMatrix()

	renderTarget.CreateSolidColorBrush( helper.ColorF( 128!/255!, 128!/255!, 192!/255!, 1.0 ), _
																						brushProperties, _
																						borderBrush )

	renderTarget.CreateSolidColorBrush( helper.ColorF( 192!/255!, 192!/255!, 255!/255!, 1.0 ), _
																						brushProperties, _
																						fillBrush )
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	borderBrush = Nothing
	fillBrush = Nothing
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform As D2D1_MATRIX_3X2_F
	Local rc As RECT
	GetClientRect(hwnd, rc)



	transform = helper.MatrixTranslation( rc.width/2, rc.height/2 )
	renderTarget.SetTransform( transform )
	renderTarget.DrawGeometry( container, borderBrush, .5! )

	renderTarget.FillGeometry( figure, fillBrush )
	renderTarget.DrawGeometry( figure, borderBrush, 1! )

	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
