' ========================================================================================
' Test Paths
' See the tests\paths for the actual tests
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display On
#Debug Error On
#Optimize Size
#Option Version5
#Register All
#Tools On
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

' Uncomment 1 of the following lines, compile, and run
' Note: each file often has multiple tests in it.

'#Include "tests\paths\chartRadarSymbolTest.inc"
'#Include "tests\paths\chartSymbolTest.inc"
'#Include "tests\paths\donutTest.inc"
'#Include "tests\paths\pieTest.inc"
#Include "tests\paths\puzzleTest.inc"
'#Include "tests\paths\reticleArcTest.inc"

#If Not %Def( $$TITLE )
$$TITLE = "Test Paths"
#EndIf
#If Not %Def( %SCALEX )
%SCALEX = 200
#EndIf
#If Not %Def( %SCALEY )
%SCALEY = 200
#EndIf

Global figure() As ID2D1TransformedGeometry
Global borderBrush, fillBrush As ID2D1SolidColorBrush
Global pal As iPalette_c2d

Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+80, %SCALEY+80, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Sub AppCreateDeviceIndependentResources()
	PaletteFromFileNew_c2d( pal, helper, factory, "berry", 255 )
	TestPaths figure()
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	Local brushProperties As D2D1_BRUSH_PROPERTIES
	Local drender As iDirectRender

	brushProperties.opacity = 1.0
	brushProperties.transform = helper.IdentityMatrix()

	renderTarget.CreateSolidColorBrush( helper.ColorF( 128!/255!, 128!/255!, 192!/255!, 1.0 ), _
																						brushProperties, _
																						borderBrush )

	renderTarget.CreateSolidColorBrush( helper.ColorF( 192!/255!, 192!/255!, 255!/255!, 1.0 ), _
																						brushProperties, _
																						fillBrush )
	drender = pal
	If IsObject( drender ) Then drender.CreateDeviceResources(renderTarget)
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	Local drender As iDirectRender
	borderBrush = Nothing
	fillBrush = Nothing
	drender = pal
	If IsObject( drender ) Then drender.DiscardDeviceResources()
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	Local transform As D2D1_MATRIX_3X2_F
	Local disp As ID2D1Geometry
	Local br As ID2D1SolidColorBrush
	Local i, j As Long
	Local rc As RECT
	Local lb1, ub1, lb2, ub2 As Long
	GetClientRect(hwnd, rc)

	transform = helper.MatrixTranslation( rc.width/2, rc.height/2 )

	renderTarget.SetTransform( transform )

	lb1 = LBound( figure(), 1 )
	ub1 = UBound( figure(), 1 )
	lb2 = LBound( figure(), 2 )
	ub2 = UBound( figure(), 2 )

	For j=lb2 To ub2
		For i = lb1 To ub1
			If IsInterface( pal, iPalette_c2d ) Then
				pal.GetBrush( (i-lb1)*(ub2-lb2+1)+(j-lb2), br )
				'pal.GetBrush( (j-lb2), br )
				'pal.GetBrush( (i-lb1), br )
			Else
				i = i
			End If
			If Not IsInterface( br, ID2D1SolidColorBrush ) Then
				i = i
			End If
			If IsInterface( figure( i, j ), ID2D1Geometry ) Then
				disp = figure( i, j )
				renderTarget.FillGeometry( disp, br )
				renderTarget.DrawGeometry( disp, br, 1! )
			Else
				i = i
			End If
		Next
	Next

	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
