' ========================================================================================
' Test Text
'
' Uses Framework.inc
' Uses Jos Roca's header files
#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All
#Debug Display Off
#Debug Error Off
#Optimize Size
#Option Version5
#Register All
#Tools Off
#If %Def( %PB_CC32 )
#Console Off
#EndIf
%BACKR = 0
%BACKG = 82
%BACKB = 121

#Include "framework.inc"

$$TITLE = "Test Text"
%SCALEX = 600
%SCALEY = 100

Global figure As ID2D1PathGeometry
Global borderBrush, fillBrush As ID2D1SolidColorBrush

Global textFormat As IDWriteTextFormat
Global textLayout As IDWriteTextLayout


Function WinMain ( ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long ) As Long
	FrameworkRun $$TITLE, %SCALEX+80, %SCALEY+80, nCmdShow
End Function

Sub AppSetupWin( win As iWindow )
End Sub

Sub AppCreateDeviceIndependentResources()
	Local rc As RECT

	GetClientRect win.hwnd, rc

	' TextFormat
	TextFormatNew_c2d textFormat, writeFactory, "Segoe UI", 100 ', %DWRITE_FONT_WEIGHT_BOLD, %DWRITE_FONT_STYLE_ITALIC
	textFormat.SetTextAlignment( %DWRITE_TEXT_ALIGNMENT_CENTER )
	textFormat.SetParagraphAlignment( %DWRITE_PARAGRAPH_ALIGNMENT_CENTER )

	' TextLayout
	TextLayoutNew_c2d textLayout, writeFactory, textFormat, "Hello World!", rc.right, rc.bottom
	TextUnderlineSet_c2d textLayout, "Hello World!", 1, 5

	' Create a Text Path
	TextPathGet_c2d( figure, factory, "Hello World!", "Calibri", 100!, %DWRITE_FONT_WEIGHT_BOLD, %DWRITE_FONT_STYLE_ITALIC, writeFactory )
End Sub

Sub AppCreateDeviceResources ( ByVal hWnd As Dword )
	BrushSolidColorNew_c2d borderBrush, renderTarget, helper, 255, 128, 128, 192
	BrushSolidColorNew_c2d fillBrush,   renderTarget, helper, 128, 240, 128,  80
End Sub

Sub AppDiscardDeviceResources( hwnd As Dword )
	borderBrush = Nothing
	fillBrush = Nothing
End Sub

Sub AppOnRender( ByVal hWnd As Dword )
	'Local layer As ID2D1Layer
	'Clipping2Start_c2d layer, renderTarget, factory, helper, 100, 30, 500, 120

	' Draw Path
	Local transform As D2D1_MATRIX_3X2_F
	Local bounds As D2D1_RECT_F
	Local rc As RECT
	GetClientRect(hwnd, rc)
	figure.GetBounds( helper.IdentityMatrix(), bounds )
	transform = helper.MatrixTranslation( rc.width/2 -(bounds.right+bounds.left)/2, rc.height/2 - (bounds.bottom+bounds.top)/2 )
	renderTarget.SetTransform( transform )
	renderTarget.FillGeometry( figure, fillBrush )
	renderTarget.DrawGeometry( figure, borderBrush, 3! )

	' Simple Draw text
	'TextFormatRender_c2d renderTarget, "Hello World!", textFormat, borderBrush ' Text is centered vertically / horizontally already no transform


	' Draw with text layout
	'TextLayoutRender_c2d renderTarget, textLayout, borderBrush             ' Text is centered from textFormat vertically / horizontally already no transform

	'ClippingStop_c2d renderTarget
	'layer = Nothing

	renderTarget.SetTransform( helper.IdentityMatrix() )
End Sub

Function AppWindowProc ( ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Dword ) As Dword
End Function
