
$$TITLE = "Chart Figure Test"

' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestFigure( figure As ID2D1GeometrySink )
	Local xValues(), yValues(), xPct(), yPct(), xPct2(), yPct2() As Single
	Local angle(), radius() As Single
	Local oYBound, oXBound As Bounds_F
	Local params As ChartSymbolParams
	Local zero As Single
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local mn, mx As Long
	Local oCount, cCount, iStep As Long

	'================================================================
	'User responsibility
	mn = 0: mx = 100
	'mn = -25: mx = 100
	'lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 1
	lb1 = 1: ub1 = 10: lb2 = 1: ub2 = 3

	' Provide data
	ReDim yValues(lb1 To ub1, lb2 To ub2), xValues(lb1 To ub1, lb2 To ub2)
	For i=lb1 To ub1
		For j = lb2 To ub2
			yValues(i,j) = Rnd( mn, mx ) + j*50
			xValues(i,j) = i
		Next
	Next

	params.roundTo        = 25  ' ................... Value to round max values away from zero to.
	params.display.width  = %SCALEX ' ................... Intended rendering width (size scaling will be done from)
	params.display.height = %SCALEY ' ................... Intended rendering height
	params.size           = 12  ' ................... Symbol size
	params.barPadding     = 0   ' ................... degree angle between adjacent bars
	params.groupPadding   = 10  ' ................... degree angle betwwen groups of bars
	'params.isArea = -1          ' ................... <>0 if drawing area for: HLine, Step, Line, or Spline
	'params.vLayout = %ChartVLayoutType.StackedValue ' Normal, StackedValue, StackedPercent

	' Choose a symbol renderer (point is default if none chosen)
	params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_LineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_StepFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HLineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_CircleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_DashFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_DiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowDiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowHexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowPentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowPillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowSquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowStar4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowStarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowTombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowTriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PlusFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PointFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_SquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_Star4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_StarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TickFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_XFigureAdd_c2d )

	ChartSetup_c2d xValues(), yValues(), xPct(), yPct(), params ' Create values to render and setup internal parameter values.
	'================================================================

	If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
		params.width =  6.283185307179586! / ( params.ub1 - params.lb1 + 1 )
		If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
			params.size = ( (params.width-params.groupPadding) / (params.ub2 - params.lb2 + 1) - params.groupPadding ) ' full bar angle (inluding bar padding which will vary with radius)
		End If
	End If
	' Convert x,y to polar coordinates
	Local x, y, r, a, pad, apg, apb, b As Single

	' Undo normalization
	params.barPadding *= params.display.width
	params.barPadding -= 2!
	params.groupPadding *= params.display.width

	If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
		apg = 6.283185307179586! / CSng(params.ub1 - params.lb1 + 1!)
		If params.vLayout = %ChartVLayoutType.Normal And params.ub2<>params.ub1 Then
			apb = ( apg - (params.groupPadding*0.0174532925199433!) ) / CSng( params.ub2 - params.lb2 + 1! )
			pad = params.barPadding
			b = apb
		Else
			apb = apg
			pad = Max( params.barPadding, params.groupPadding )
			b = 0
		End If
		params.size = apb - pad*0.0174532925199433!
	End If

	ReDim angle(params.lb1 To params.ub1, params.lb2 To params.ub2 ), radius(params.lb1 To params.ub1, params.lb2 To params.ub2 )
	For j = params.lb2 To params.ub2
		For i = params.lb1 To params.ub1
			If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
				a = (i-params.lb1)*apg + params.groupPadding* 0.0174532925199433!/2! + (j-params.lb2)*b
			Else
				a = xPct( i, j ) * 6.283185307! + 1.570796327!
			End If
			r = ( -params.ybounds.vmin + yPct( i, j ) ) * .5  ' -1 <= (n) -> (m) <= 1 s/b 0 -> .5
			angle(i,j) = a
			radius(i,j) = r
			xPct( i, j ) = Sin( a ) * r
			yPct( i, j ) = Cos( a ) * r
		Next
	Next

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = UBound( xPct(), 1 ) - LBound( xPct(), 1 ) + 1
	iStep = cCount / oCount
	For j = params.lb2 To params.ub2
		params.j = j
		For i = params.lb1 To params.ub1 Step iStep
			params.i1 = i
			params.i2 = i + iStep
			params.angle = angle(i,j)
			params.radius = radius(i,j)
			If j>params.lb2 Then params.innerRadius = radius(i,j-1)
			ChartRadarSymbolFigureAdd_c2d figure, xPct(), yPct(), radius(), params
		Next
	Next
End Sub
