
$$TITLE = "Chart Symbol Path Test"
' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestPath( figure As ID2D1PathGeometry )
	Local xValues(), yValues(), xPct(), yPct(), xPct2(), yPct2() As Single
	Local oYBound, oXBound As Bounds_F
	Local params As ChartSymbolParams
	Local zero As Single
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local mn, mx As Long
	Local oCount, cCount, iStep As Long

	'================================================================
	'User responsibility
	mn = 0: mx = 100
	'mn = -25: mx = 100
	'lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 1
	lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 3

	' Provide data
	ReDim yValues(lb1 To ub1, lb2 To ub2), xValues(lb1 To ub1, lb2 To ub2)
	For i=lb1 To ub1
		For j = lb2 To ub2
			yValues(i,j) = Rnd( mn, mx ) + j*50
			xValues(i,j) = (i-lb1)
		Next
	Next

	params.roundTo        = 25  ' ................... Value to round max values away from zero to.
	params.display.width  = %SCALEX ' ................... Intended rendering width (size scaling will be done from)
	params.display.height = %SCALEY ' ................... Intended rendering height
	params.size           = 20  ' ................... Symbol size
	params.barPadding     = 2   ' ................... space between adjacent bars
	params.groupPadding   = 10  ' ................... space betwwen groups of bars
	'params.isArea = -1          ' ................... <>0 if drawing area for: HLine, Step, Line, or Spline
	'params.vLayout = %ChartVLayoutType.StackedPercent ' Normal, StackedValue, StackedPercent
	'params.symbolCallback = CodePtr( xyz )  ' ....... Optional user routine called before each point.  size and renderer would be common things to change.

	' Choose a symbol renderer (point is default if none chosen)
	'params.symbolRender = CodePtr( ChartSymbol_HLineFigure )
	'params.symbolRender = CodePtr( ChartSymbol_BarFigure )
	'params.symbolRender = CodePtr( ChartSymbol_StepFigure )
	'params.symbolRender = CodePtr( ChartSymbol_LineFigure )
	'params.symbolRender = CodePtr( ChartSymbol_SplineFigure )
	'params.symbolRender = CodePtr( ChartSymbol_CircleFigure )
	'params.symbolRender = CodePtr( ChartSymbol_DashFigure )
	'params.symbolRender = CodePtr( ChartSymbol_DiamondFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HexagonFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowDiamondFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowHexagonFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPentagonFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowPillFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowSquareFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStar4Figure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowStarFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTombstoneFigure )
	'params.symbolRender = CodePtr( ChartSymbol_HollowTriangleFigure )
	'params.symbolRender = CodePtr( ChartSymbol_PentagonFigure )
	'params.symbolRender = CodePtr( ChartSymbol_PillFigure )
	'params.symbolRender = CodePtr( ChartSymbol_PlusFigure )
	'params.symbolRender = CodePtr( ChartSymbol_PointFigure )
	'params.symbolRender = CodePtr( ChartSymbol_SquareFigure )
	'params.symbolRender = CodePtr( ChartSymbol_Star4Figure )
	'params.symbolRender = CodePtr( ChartSymbol_StarFigure )
	'params.symbolRender = CodePtr( ChartSymbol_TickFigure )
	'params.symbolRender = CodePtr( ChartSymbol_TombstoneFigure )
	'params.symbolRender = CodePtr( ChartSymbol_TriangleFigure )
	'params.symbolRender = CodePtr( ChartSymbol_XFigure )
	'params.symbolRender = CodePtr( ChartSymbol_PulseFigure )
	params.symbolRender = CodePtr( ChartSymbol_HollowManFigure )

	ChartSetup_c2d xValues(), yValues(), xPct(), yPct(), params ' Create values to render and setup internal parameter values.
	'================================================================

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = UBound( xPct(), 1 ) - LBound( xPct(), 1 ) + 1
	iStep = cCount / oCount

	' Alter i & j
	j = params.lb2
	i = params.lb1

	params.j = j
	params.i1 = i
	params.i2 = Min(i + iStep, params.ub1)

	' Uncomment one of the following to test creating a single path
	'ChartSymbolPathNew_c2d figure, factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolSeriesPathNew_c2d figure, factory, xValues(), yValues(), xPct(), yPct(), params
	'ChartSymbolGroupPathNew_c2d figure, factory, xValues(), yValues(), xPct(), yPct(), params
	ChartSymbolAllPathNew_c2d figure, factory, xValues(), yValues(), xPct(), yPct(), params

	TransformPath_c2d figure, factory, 0,0, %SCALEX,%SCALEY
End Sub

'===================================================
' Examples of custom point routines
'===================================================
Sub ChartSymbol_PulseFigure( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local fSize As D2D1_SIZE_F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	fSize.width = params.size
	fSize.height = params.size
	PulseFigureAdd_c2d sink, center, fSize
End Sub

Sub ChartSymbol_HollowManFigure( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local fSize As D2D1_SIZE_F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	fSize.width = params.size
	fSize.height = params.size
	ManFigureAdd_c2d sink, center, fSize, 1
End Sub
