
$$TITLE = "Chart Symbol Path Test"
' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestPaths( figure() As ID2D1PathGeometry )
	Local xValues(), yValues(), xPct(), yPct(), xPct2(), yPct2() As Single
	Local oYBound, oXBound As Bounds_F
	Local params As ChartSymbolParams
	Local zero As Single
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local mn, mx As Long
	Local oCount, cCount, iStep As Long
	Local angle(), radius() As Single

	'================================================================
	'User responsibility
	mn = 0: mx = 100
	'mn = -25: mx = 100
	'lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 1
	lb1 = 1: ub1 = 5: lb2 = 1: ub2 = 3

	' Provide data
	ReDim yValues(lb1 To ub1, lb2 To ub2), xValues(lb1 To ub1, lb2 To ub2)
	For i=lb1 To ub1
		For j = lb2 To ub2
			yValues(i,j) = Rnd( mn, mx ) + j*50
			xValues(i,j) = (i-lb1)
		Next
	Next

	params.roundTo        = 25  ' ................... Value to round max values away from zero to.
	params.display.width  = %SCALEX ' ................... Intended rendering width (size scaling will be done from)
	params.display.height = %SCALEY ' ................... Intended rendering height
	params.size           = 12  ' ................... Symbol size
	params.barPadding     = 2   ' ................... space between adjacent bars
	params.groupPadding   = 10  ' ................... space betwwen groups of bars
	'params.isArea = -1          ' ................... <>0 if drawing area for: HLine, Step, Line, or Spline
	'params.vLayout = %ChartVLayoutType.StackedPercent ' Normal, StackedValue, StackedPercent
	'params.symbolCallback = CodePtr( xyz )  ' ....... Optional user routine called before each point.  size and renderer would be common things to change.

	' Choose a symbol renderer (point is default if none chosen)
	'params.symbolRender = CodePtr( ChartRadarSymbol_HLineFigureAdd_c2d )
	params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_StepFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_LineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_CircleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_DashFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_DiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowDiamondFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowHexagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowPentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowPillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowSquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowStar4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowStarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowTombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_HollowTriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PentagonFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PillFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PlusFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_PointFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_SquareFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_Star4FigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_StarFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TickFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TombstoneFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_TriangleFigureAdd_c2d )
	'params.symbolRender = CodePtr( ChartRadarSymbol_XFigureAdd_c2d )

	ChartSetup_c2d xValues(), yValues(), xPct(), yPct(), params ' New_c2d values to render and setup internal parameter values.
	ChartRadarSetup_c2d xValues(), xPct(), yPct(), angle(), radius(), iStep, params
	'================================================================

	' Uncomment one of the following to test creating a single path
	ChartRadarSymbolPathsNew_c2d figure(), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params
	'ChartRadarSymbolSeriesPathsNew_c2d figure(), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params
	'ChartRadarSymbolGroupPathsNew_c2d figure(), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params

	lb1 = LBound( figure(), 1 )
	ub1 = UBound( figure(), 1 )
	lb2 = LBound( figure(), 2 )
	ub2 = UBound( figure(), 2 )

	For i=lb1 To ub1
		For j=lb2 To ub2
			TransformPath_c2d figure(i,j), factory, 0,0, %SCALEX,%SCALEY
		Next
	Next

End Sub
