
$$TITLE = "Donut Paths Test"
' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestPaths( figure() As ID2D1Geometry )
	Local mn, mx, cnt, i As Long
	Local values() As Single

	mn = 10: mx = 100: cnt = 10

	ReDim values(cnt-1)
	For i=0 To cnt-1
		values(i) = Rnd(mn,mx)
	Next

	'DonutPathsTest_Default figure(), values()
	DonutPathsTest_ExplodeIndex figure(), values()
	'DonutPathsTest_ExplodeRoutine figure(), values()
	'DonutPathsTest_Gap figure(), values()
	'DonutPathsTest_Sweep figure(), values()
	'DonutPathsTest_Spiral figure(), values()
	'DonutPathsTest_Chevron figure(), values()

	For i=0 To cnt-1
		TransformPath_c2d figure(i), factory, 0,0, %SCALEX,%SCALEY
	Next
End Sub

Sub DonutPathsTest_Default( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.firstRadius.inner   =
	'params.firstRadius.outer   =
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	'params.gapDegrees          =
	'params.chevronAmount       =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub

Sub DonutPathsTest_ExplodeIndex( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.firstRadius.inner   =
	'params.firstRadius.outer   =
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	'params.gapDegrees          =
	'params.chevronAmount       =
	'params.explodeDistance     =
	'params.explodeIndex        =
	params.explodeDistance     = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex        = 2
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub

Function DonutPathsTest_Explode( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
	If valueIndex Mod 2 = 1 Then
		Function = refValue
	Else
		Function = 0
	End If
End Function

Sub DonutPathsTest_ExplodeRoutine( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.firstRadius.inner   =
	'params.firstRadius.outer   =
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	'params.gapDegrees          =
	'params.chevronAmount       =
	params.explodeDistance     = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex        = 2
	params.explodeFunction     = CodePtr( DonutPathsTest_Explode )

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub

Sub DonutPathsTest_Gap( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.firstRadius.inner   =
	'params.firstRadius.outer   =
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	params.gapDegrees          = 5
	'params.chevronAmount       =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub

Sub DonutPathsTest_Sweep( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	params.sweepDegrees.first  = 0
	params.sweepDegrees.last   = 180
	'params.firstRadius.inner   =
	'params.firstRadius.outer   =
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	'params.gapDegrees          =
	'params.chevronAmount       =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub


Sub DonutPathsTest_Spiral( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	params.sweepDegrees.first    = 0
	params.sweepDegrees.last     = 720
	params.firstRadius.inner   = .5
	params.firstRadius.outer   = .4
	params.lastRadius.inner    = .25
	params.lastRadius.outer    = .15
	'params.gapDegrees          =
	'params.chevronAmount       =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub

Sub DonutPathsTest_Chevron( figure() As ID2D1Geometry, values() As Single )
	Local params As DonutPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	params.firstRadius.outer   = .5
	params.firstRadius.inner   = .4
	'params.lastRadius.inner    =
	'params.lastRadius.outer    =
	'params.gapDegrees          =
	params.chevronAmount       = (params.firstRadius.outer - params.firstRadius.inner)*.5!
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	DonutPathsNew_c2d figure(), factory, values(), params
End Sub
