
$$TITLE = "Pie Paths Test"
' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestPaths( figure() As ID2D1Geometry )
	Local mn, mx, cnt, i As Long
	Local values() As Single

	mn = 10: mx = 100: cnt = 10

	ReDim values(cnt-1)
	For i=0 To cnt-1
		values(i) = Rnd(mn,mx)
	Next

	PiePathsTest_Default figure(), values()
	'PiePathsTest_ExplodeIndex figure(), values()
	'PiePathsTest_ExplodeRoutine figure(), values()
	'PiePathsTest_Gap figure(), values()
	'PiePathsTest_Sweep figure(), values()
	'PiePathsTest_Spiral figure(), values()

	For i=0 To cnt-1
		TransformPath_c2d figure(i), factory, 0,0, %SCALEX,%SCALEY
	Next
End Sub

Sub PiePathsTest_Default( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	'params.sweepDegrees.first    =
	'params.sweepDegrees.last     =
	'params.radius.first          =
	'params.radius.last           =
	'params.gapDegrees            =
	'params.explodeDistance       =
	'params.explodeIndex          =
	'params.explodeFunction       =

	PiePathsNew_c2d figure(), factory, values(), params
End Sub

Sub PiePathsTest_ExplodeIndex( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	'params.sweepDegrees.first    =
	'params.sweepDegrees.last     =
	'params.radius.first          =
	'params.radius.last           =
	'params.gapDegrees            =
	params.explodeDistance       = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex          = 2
	'params.explodeFunction       =

	PiePathsNew_c2d figure(), factory, values(), params
End Sub

Function PiePathsTest_Explode( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
	If valueIndex Mod 2 = 1 Then
		Function = refValue
	Else
		Function = 0
	End If
End Function

Sub PiePathsTest_ExplodeRoutine( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	'params.sweepDegrees.first    =
	'params.sweepDegrees.last     =
	'params.radius.first          =
	'params.radius.last           =
	'params.gapDegrees            =
	params.explodeDistance       = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex          = 2
	params.explodeFunction       = CodePtr( PiePathsTest_Explode )

	PiePathsNew_c2d figure(), factory, values(), params
End Sub

Sub PiePathsTest_Gap( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	'params.sweepDegrees.first    =
	'params.sweepDegrees.last     =
	'params.radius.first          =
	'params.radius.last           =
	params.gapDegrees            = 5
	'params.explodeDistance       =
	'params.explodeIndex          =
	'params.explodeFunction       =

	PiePathsNew_c2d figure(), factory, values(), params
End Sub

Sub PiePathsTest_Sweep( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	params.sweepDegrees.first    = 0
	params.sweepDegrees.last     = 180
	'params.radius.first          =
	'params.radius.last           =
	'params.gapDegrees            = 5
	'params.explodeDistance       =
	'params.explodeIndex          =
	'params.explodeFunction       =

	PiePathsNew_c2d figure(), factory, values(), params
End Sub


Sub PiePathsTest_Spiral( figure() As ID2D1Geometry, values() As Single )
	Local params As PiePathsParams

	'params.center.x              =
	'params.center.y              =
	params.sweepDegrees.first    = 0
	params.sweepDegrees.last     = 720
	params.radius.first          = .5
	params.radius.last           = .2
	'params.gapDegrees            = 5
	'params.explodeDistance       =
	'params.explodeIndex          =
	'params.explodeFunction       =

	PiePathsNew_c2d figure(), factory, values(), params
End Sub
