
$$TITLE = "Reticle Arc Paths Test"
' Default scale 200x200
%SCALEX = 400
%SCALEY = 400

Sub TestPaths( figure() As ID2D1Geometry )
	Local mn, mx, cnt, i As Long
	Local values() As Single

	mn = 10: mx = 100: cnt = 10

	ReDim values(cnt-1)
	For i=0 To cnt-1
		values(i) = Rnd(mn,mx)
	Next

	ReticleArcPathsTest_Default figure(), values()
	'ReticleArcPathsTest_ExplodeIndex figure(), values()
	'ReticleArcPathsTest_ExplodeRoutine figure(), values()
	'ReticleArcPathsTest_Gap figure(), values()
	'ReticleArcPathsTest_Sweep figure(), values()
	'ReticleArcPathsTest_Spiral figure(), values()
	'ReticleArcPathsTest_Inside figure(), values()
	'ReticleArcPathsTest_Both figure(), values()

	For i=0 To cnt-1
		TransformPath_c2d figure(i), factory, 0,0, %SCALEX,%SCALEY
	Next
End Sub

Sub ReticleArcPathsTest_Default( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Sub ReticleArcPathsTest_ExplodeIndex( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	params.explodeDistance     = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex        = 2
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Function ReticleArcPathsTest_Explode( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
	If valueIndex Mod 2 = 1 Then
		Function = refValue
	Else
		Function = 0
	End If
End Function

Sub ReticleArcPathsTest_ExplodeRoutine( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	params.explodeDistance     = 20! / CSng( Min(%SCALEX, %SCALEY) )
	params.explodeIndex        = 2
	params.explodeFunction     = CodePtr( ReticleArcPathsTest_Explode )

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Sub ReticleArcPathsTest_Gap( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	params.gapDegrees          = 5
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Sub ReticleArcPathsTest_Sweep( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	params.sweepDegrees.first  = 0
	params.sweepDegrees.last   = 180
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub


Sub ReticleArcPathsTest_Spiral( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	params.sweepDegrees.first  = 0
	params.sweepDegrees.last   = 720
	params.radius.first        = .5
	params.radius.last         = .2
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Outside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Sub ReticleArcPathsTest_Inside( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Inside 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub

Sub ReticleArcPathsTest_Both( figure() As ID2D1Geometry, values() As Single )
	Local params As ReticleArcPathsParams

	'params.center.x            =
	'params.center.y            =
	'params.sweepDegrees.first  =
	'params.sweepDegrees.last   =
	'params.radius.first        =
	'params.radius.last         =
	'params.gapDegrees          =
	'params.baseDegrees         =
	params.markSide            = %ReticleArcMarks.Both 'None, Outside, Inside, Both
	params.markSize            = 10! / Min(%SCALEX, %SCALEY)
	params.markDegrees         = 5
	'params.hideLine            =
	'params.explodeDistance     =
	'params.explodeIndex        =
	'params.explodeFunction     =

	ReticleArcPathsNew_c2d figure(), factory, values(), params
End Sub
