#Include This Once
#Include Once "d2d1.inc"
#Include Once "d2d1Helper.inc"
#Include Once "d2dUtils.inc"

Enum ChartHLayoutType
	Normal
	Clustered
End Enum

'  %ChartHLayoutType.Normal
'  %ChartHLayoutType.Clustered

Enum ChartVLayoutType
	Normal
	StackedValue
	StackedPercent
End Enum


'  %ChartVLayoutType.Normal
'  %ChartVLayoutType.StackedValue
'  %ChartVLayoutType.StackedPercent

Enum NeedleTipType
	Sharp
	Soft
End Enum

'  %NeedleTipType.Sharp
'  %NeedleTipType.Soft

Enum ReticleArcPathMarks
	Outside = 1
	Inside = 2
	Both = 3
End Enum

'  %ReticleArcPathMarks.Outside
'  %ReticleArcPathMarks.Inside
'  %ReticleArcPathMarks.Both

Enum ReticleMarks
	None = 0
	Top = 1
	Bottom = 2
	Both = 3
End Enum

'  %ReticleMarks.None
'  %ReticleMarks.Top
'  %ReticleMarks.Bottom
'  %ReticleMarks.Both

Enum PuzzleSides
	topSide = 1
	rightSide = 2
	bottomSide = 4
	leftSzie = 8
End Enum


'  %PuzzleSides.topSide
'  %PuzzleSides.rightSide
'  %PuzzleSides.bottomSide
'  %PuzzleSides.leftSzie


Type BOUNDS_F
	vmin As Single
	vmax As Single
End Type


'  params.vmin  =
'  params.vmax  =

Type Range_F
	first As Single
	last As Single
End Type


'  params.first  =
'  params.last   =

Type RadiusRange_F
	inner As Single
	outer As Single
End Type


'  params.inner  =
'  params.outer  =


Type ARGBColor
	B As Byte
	G As Byte
	R As Byte
	A As Byte
End Type

Union ARGBUnion
	parts As ARGBColor
	value As Dword
End Union


'  params.B      =
'  params.G      =
'  params.R      =
'  params.A      =
'  params.parts  =
'  params.value  =

Type StarPointsParams
	center As D2D1_POINT_2F    ' Center of star
	radius As RadiusRange_F    ' Outer/inner Radius of star
	rotateDegrees As Single    ' Degrees to rotate
	points As Long             ' # of points
End Type


'  params.center         =
'  params.radius         =
'  params.rotateDegrees  =
'  params.points         =

Type SmoothLineParams
	pctSide As Single     ' % of 1/2 line to use in rounding range (0-1)
	softness As Single    ' softness of rounding range (0-1)
End Type


'  params.pctSide   =
'  params.softness  =

Type ReticleSinkParams
	markSide As Long        ' ReticleMarks (Top,Bottom,Both)
	markSize As Single      ' Distance away from line (2x this if both)
	markCount As Single     ' # of marks
	hideLine As Long        ' <>0 hide line, 0 draw line (default)
End Type


'  params.markSide   =
'  params.markSize   =
'  params.markCount  =
'  params.hideLine   =

Type ReticleArcSinkParams
	center As D2D1_POINT_2F   ' Center of reticle arc
	sweepDegrees As Range_F   ' First/Last angle of arc
	radius As Range_F         ' First/Last radius. default .5
	baseDegrees As Single     ' Angle marks start at, if =arcDegrees.start normlized to arc, if constant Normalized across all arcs
	markSide As Long          ' ReticleArcPathMarks: Inside, Outside, or Both
	markSize As Single        ' length of mark from line (2x if both)
	markDegrees As Single     ' number of degrees between marks
	hideLine As Long          ' <>0 hide line, 0 draw line (default)
End Type


'  params.center        =
'  params.sweepDegrees  =
'  params.radius        =
'  params.baseDegrees   =
'  params.markSide      =
'  params.markSize      =
'  params.markDegrees   =
'  params.hideLine      =

Type ReticleArcPathsParams
	center As D2D1_POINT_2F     ' center
	sweepDegrees As Range_F     ' Start/End angles of arcs
	radius As Range_F           ' Start/End radius
	gapDegrees As Single        ' gap between arcs
	baseDegrees As Single       ' Angle marks start at, if =arcDegrees.start normlized to arc, if constant Normalized across all arcs
	markSide As Long          ' ReticleArcPathMarks: Inside, Outside, or Both
	markSize As Single        ' length of mark from line (2x if both)
	markDegrees As Single     ' number of degrees between marks
	hideLine As Long          ' <>0 hide line, 0 draw line (default)
	explodeDistance As Single   ' Distance to explode a slice. 0 = don't explode
	explodeIndex As Long        ' Index of slice to explode. <0 = don't explode
	explodeFunction As Dword    ' CodePtr to explode function.  0 = don't use.  Signature: Function Explosion( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
End Type


'  params.center           =
'  params.sweepDegrees     =
'  params.radius           =
'  params.gapDegrees       =
'  params.baseDegrees      =
'  params.markSide         =
'  params.markSize         =
'  params.markDegrees      =
'  params.hideLine         =
'  params.explodeDistance  =
'  params.explodeIndex     =
'  params.explodeFunction  =

Type ReticleArcPathParams
	center As D2D1_POINT_2F   ' Center of Reticle
	radius As RadiusRange_F   ' Start/End radius. if either =0 (default), it will be set to the other.  Use .01 to end near 0
	sweepDegrees As Range_F   ' Start/End angle of arc
	baseDegrees As Single     ' Angle marks start at, if =arcDegrees.start normlized to arc, if constant Normalized across all arcs
	markSide As Long          ' ReticleArcPathMarks: Inside, Outside, or Both
	markSize As Single        ' length of mark from line (2x if both)
	markDegrees As Single     ' number of degrees between marks
	hideLine As Long          ' <>0 hide line, 0 draw line (default)
End Type


'  params.center        =
'  params.radius        =
'  params.sweepDegrees  =
'  params.baseDegrees   =
'  params.markSide      =
'  params.markSize      =
'  params.markDegrees   =
'  params.hideLine      =

Enum ReticleArcMarks
	None = 0
	Outside = 1
	Inside = 2
	Both = 3
End Enum


'  %ReticleArcMarks.None
'  %ReticleArcMarks.Outside
'  %ReticleArcMarks.Inside
'  %ReticleArcMarks.Both

Type PositionParams
	center As D2D1_POINT_2F     ' Center of chart
	size As D2D1_SIZE_F         ' Size of chart
	rotateDegrees As Single     ' # of degrees to rotate chart
End Type


'  params.center         =
'  params.size           =
'  params.rotateDegrees  =

Type PolygonPointsParams
	center As D2D1_POINT_2F     ' Center of polygon
	radius As Single            ' Radius of polygon
	rotateDegrees As Single     ' # of degrees to rotate
	sides As Long               ' # of sides on polygon (3 to n)
End Type


'  params.center         =
'  params.radius         =
'  params.rotateDegrees  =
'  params.sides          =

Type PiePathsParams
	center As D2D1_POINT_2F           ' center of pie
	sweepDegrees As Range_F           ' Start/End angles of pie slices
	radius As Range_F                 ' Radius of pie
	gapDegrees As Single              ' gap between segments
	explodeDistance As Single         ' Distance to explode a slice. 0 = don't explode
	explodeIndex As Long              ' Slice to explode. 0 = don't explode
	explodeFunction As Dword          ' CodePtr to explode function.  0 = don't use.  Signature: Function Explosion( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
End Type


'  params.center           =
'  params.sweepDegrees     =
'  params.radius           =
'  params.gapDegrees       =
'  params.explodeDistance  =
'  params.explodeIndex     =
'  params.explodeFunction  =

Type NeedlePathParams
	center As D2D1_POINT_2F ' Center of needle
	rotateDegrees As Single ' # of degrees to rotate needle.  0-360

	' If baseRadius< baseWidth/2 Then free else attached
	baseRadius As Single    ' Distance from center to base of needle
	baseWidth As Single     ' bigger = fatter, smaller = thinner

	tipType As Long         ' NeedleTipType
	tipRadius As Single     ' distance from center to tip of needle
	tipWidth As Single      ' Width where tip starts
	tipLength As Single     ' Length of tip (clipped to tipRadius - baseRadius)
End Type


'  params.center         =
'  params.rotateDegrees  =
'  params.baseRadius     =
'  params.baseWidth      =
'  params.tipType        =
'  params.tipRadius      =
'  params.tipWidth       =
'  params.tipLength      =

Type MazePathParams
	center As D2D1_POINT_2F    ' Center of maze
	size As D2D1_SIZE_F        ' width/height of maze
	cellsX As Long             ' # of horizontal cells
	cellsY As Long             ' # of vertical cells
End Type


'  params.center  =
'  params.size    =
'  params.cellsX  =
'  params.cellsY  =

Type GearPointsParams
	center As D2D1_POINT_2F       ' Center of gear
	radius As RadiusRange_F       ' inner outer radius of cog
	rotateDegrees As Single       ' Degrees to rotate gear
	cogs As Long                  ' # of cogs on gear
	percentSlope As Single        ' % of segment to slope, Value range 0 to 1
End Type


'  params.center         =
'  params.radius         =
'  params.rotateDegrees  =
'  params.cogs           =
'  params.percentSlope   =

Type DonutPathsParams
	center As D2D1_POINT_2F       ' center of donut
	sweepDegrees As Range_F       ' Start/End angles of donut slices
	firstRadius As RadiusRange_F  ' first inner/outer radius
	lastRadius As RadiusRange_F   ' last inner/outer radius
	gapDegrees As Single          ' Degrees between segments
	chevronAmount As Single       ' Amount of chevron
	explodeDistance As Single     ' Distance to explode a slice. 0 = don't explode
	explodeIndex As Long          ' Slice to explode. 0 = don't explode
	explodeFunction As Dword      ' CodePtr to explode function.  0 = don't use.  Signature: Function Explosion( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single
End Type


'  params.center           =
'  params.sweepDegrees     =
'  params.firstRadius      =
'  params.lastRadius       =
'  params.gapDegrees       =
'  params.chevronAmount    =
'  params.explodeDistance  =
'  params.explodeIndex     =
'  params.explodeFunction  =

Type DonutPathParams
	center As D2D1_POINT_2F      ' Center of donut
	firstRadius As RadiusRange_F ' first inner/outer radius
	lastRadius As RadiusRange_F  ' last inner/outer radius
	sweepDegrees As Range_F      ' Start/End angle of slice
	chevronAmount As Single      ' cap chevron amount.  0 = Flat sides (default), >0 = chevron to left, <0 = chevron to right
End Type


'  params.center         =
'  params.firstRadius    =
'  params.lastRadius     =
'  params.sweepDegrees   =
'  params.chevronAmount  =

Type ChartSymbolParams
	i1 As Long                  ' Starting i in value(i,j)
	i2 As Long                  ' Ending i (for splines) in value(i,j)
	j As Long                   ' j in value(i,j)
	xCount As Long              ' Original # of x Values (i2-i1+1) (spline)
	lb1 As Long                 ' Lower bound index 1
	ub1 As Long                 ' Upper bound index 1
	lb2 As Long                 ' Lower bound index 2
	ub2 As Long                 ' Upper bound index 2
	ybounds As Bounds_F         ' Value min/max
	xbounds As Bounds_F         ' Series min/max
	zero As Single              ' Normalized Y zero value (always 0,0 for radar/spider)
	width As Single             ' Normalized max drawing width or degrees (radar/spider)
	angle As Single             ' Angle for symbol on radar chart
	radius As Single            ' Radius for symbol on radar chart
	innerRadius As Single       ' Inner radius for j>0
	isSpline As Long            ' Calc spline points?
	hLayout As Long             ' ChartHLayoutType: None, Clustered

	userData2 As Single         ' Values from here down are set by the user in display size values.
	display As D2D1_SIZE_F      ' intended display size
	size As Single              ' symbol size (at desired dislay size)
	groupPadding As Single      ' Normalized group padding (for bars, at desired dislay size)
	barPadding As Single        ' Normalized symbol padding (for bars, at desired dislay size)
	isFull As Long              ' Ignore y, area, & stacked and cover entire region (for hit testing line, step, mark, spline)
	isArea As Long              ' For line, step, spline and mark (flat line), makes an area
	vLayout As Long             ' ChartStackType: None, Value, Percent
	roundTo As Single           ' Value to round away from zero to.
	userData As Long            ' user data for use by symbolRender & symbolCallback.  Could be used to map to an object or as a special flag for a user rendering routine
	symbolrender As Dword       ' Address of routine that draws the chart symbol in the form of:Sub routine( ByRef valuePath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	symbolCallback As Dword     ' Address of routine to modify params in the form of: Sub routine( ByVal i As Long, params As ChartSymbolParams ) As Long.  Return 0 to render symbol, <>0 to skip symbol
End Type


'  params.i1              =
'  params.i2              =
'  params.j               =
'  params.xCount          =
'  params.lb1             =
'  params.ub1             =
'  params.lb2             =
'  params.ub2             =
'  params.ybounds         =
'  params.xbounds         =
'  params.zero            =
'  params.width           =
'  params.angle           =
'  params.radius          =
'  params.innerRadius     =
'  params.isSpline        =
'  params.hLayout         =
'  params.userData2       =
'  params.display         =
'  params.size            =
'  params.groupPadding    =
'  params.barPadding      =
'  params.isFull          =
'  params.isArea          =
'  params.vLayout         =
'  params.roundTo         =
'  params.userData        =
'  params.symbolrender    =
'  params.symbolCallback  =
Type ChartParams
	position As PositionParams
	symbol As ChartSymbolParams
	chartType As Long           ' ChartType: type: Point,Spike,Bar,Tower,Line,Area,Step,StepArea,Spline,SplineArea  yStacking: Stacked,Percent
	xbounds As BOUNDS_F         ' min/max x values
	ybounds As BOUNDS_F         ' min/max y values
	roundTo As Single           ' Value to round to i.e. (25, 100, etc) ignored if 0
End Type


'  params.position   =
'  params.symbol     =
'  params.chartType  =
'  params.xbounds    =
'  params.ybounds    =
'  params.roundTo    =

Type ChartGridParams
	center As D2D1_POINT_2F
	size As D2D1_SIZE_F
	rotateDegrees As Single
	xbounds As BOUNDS_F
	ybounds As BOUNDS_F
	verticalLines As Single
	horizontalLines As Single
	drawAnchor As Long
End Type


'  params.center           =
'  params.size             =
'  params.rotateDegrees    =
'  params.xbounds          =
'  params.ybounds          =
'  params.verticalLines    =
'  params.horizontalLines  =
'  params.drawAnchor       =

Function PI() As Single
	Function = 3.1415926535897932!
End Function

Function PI2() As Single
	Function = 6.283185307179586!
End Function

Function DegreesToRadians( angle As Single ) As Single
	Function = angle * 0.0174532925199433!
End Function

Sub ARGBSet_c2d( value As ARGBUnion, a As Byte, r As Byte, g As Byte, b As Byte )
	value.parts.A = a
	value.parts.R = r
	value.parts.G = g
	value.parts.B = b
End Sub

Sub ExtremeValueGet_c2d( values() As Single, bounds As Bounds_F, ByVal rounding As Single )
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long

	lb1 = LBound(values(), 1)
	ub1 = UBound(values(), 1)

	lb2 = LBound( values(), 2 )
	ub2 = UBound( values(), 2 )

	bounds.vmax = 0!
	bounds.vmin = 0!
	For i=lb1 To ub1
		For j=lb2 To ub2
			bounds.vmax = Max( bounds.vmax, values(i,j) )
			bounds.vmin = Min( bounds.vmin, values(i,j) )
		Next
	Next
	If rounding>0 Then
		If bounds.vmax > 0 And ( bounds.vmax Mod rounding)<>0 Then bounds.vmax += rounding
		If bounds.vmin < 0 And ( bounds.vmin Mod rounding)<>0 Then bounds.vmin -= rounding

		bounds.vmax \= rounding
		bounds.vmax *= rounding
		bounds.vmin \= rounding
		bounds.vmin *= rounding
	End If
End Sub

Sub ExtremeGroupGet_c2d( values() As Single, bounds As Bounds_F, ByVal rounding As Single )
	' For stacked charts
	Local i, j As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local sum As Single

	lb1 = LBound(values(), 1)
	ub1 = UBound(values(), 1)

	lb2 = LBound( values(), 2 )
	ub2 = UBound( values(), 2 )

	bounds.vmax = 0!
	bounds.vmin = 0!
	For i=lb1 To ub1
		sum = 0!
		For j = lb2 To ub2
			sum += values(i,j)
		Next
		bounds.vmax = Max( bounds.vmax, sum )
		bounds.vmin = Min( bounds.vmin, sum )
	Next
	If rounding>0 Then
		If bounds.vmax > 0! And (bounds.vmax Mod rounding)<>0! Then bounds.vmax += rounding
		If bounds.vmin < 0! And (bounds.vmin Mod rounding)<>0! Then bounds.vmin -= rounding

		bounds.vmax \= rounding
		bounds.vmax *= rounding
		bounds.vmin \= rounding
		bounds.vmin *= rounding
	End If
End Sub

Sub ChartSetup_c2d( xIn() As Single, yIn() As Single, xOut() As Single, yOut() As Single, params As ChartSymbolParams )
	ChartBoundsSet_c2d xIn(), params

	If params.ub1-params.lb1+1<3 Then
		' A cubic spline can't have less than three points!
		If ( params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d ) ) Then
			params.symbolRender = CodePtr( ChartSymbol_LineFigureAdd_c2d )
		End If
		If ( params.symbolRender = CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d ) ) Then
			params.symbolRender = CodePtr( ChartRadarSymbol_LineFigureAdd_c2d )
		End If
	End If
	If params.ub1-params.lb1+1<2 Then
		' A line can't have less that 2 points!
		If ( params.symbolRender = CodePtr( ChartSymbol_LineFigureAdd_c2d ) ) Then
			params.symbolRender = CodePtr( ChartSymbol_PointFigureAdd_c2d )
		End If
		If ( params.symbolRender = CodePtr( ChartRadarSymbol_PointFigureAdd_c2d ) ) Then
			params.symbolRender = CodePtr( ChartRadarSymbol_PointFigureAdd_c2d )
		End If
	End If

	params.size = ValueNormal_c2d( Max(2!,params.size), Max(params.display.width, params.display.height) )
	params.barPadding = ValueNormal_c2d( Max(2, params.barPadding+2), params.display.width )
	params.groupPadding = ValueNormal_c2d( params.groupPadding, params.display.width )

	params.isSpline = ( params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d ) ) Or ( params.symbolRender = CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d ) )
	params.hLayout = IIf&( (params.symbolRender = CodePtr( ChartSymbol_BarFigureAdd_c2d ) _
				Or params.symbolRender = CodePtr( ChartSymbol_SpikeFigureAdd_c2d ) _
				Or params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) _
				Or params.symbolRender = CodePtr( ChartRadarSymbol_SpikeFigureAdd_c2d ) _
				) _
				And params.vLayout = %ChartVLayoutType.Normal _
				And params.lb2<>params.ub2, %ChartHLayoutType.Clustered, %ChartHLayoutType.Normal )

	If params.isSpline Then
		ValuesToSplinePercent_c2d yIn(), xOut(), yOut(), params
	Else
		If params.vLayout = %ChartVLayoutType.StackedValue Then
			ExtremeGroupGet_c2d yIn(), params.yBounds, params.roundTo
			ValuesToStackedPercent_c2d yIn(), yOut(), params
		ElseIf params.vLayout = %ChartVLayoutType.StackedPercent Then
			ExtremeValueGet_c2d yIn(), params.yBounds, params.roundTo
			ValuesTo100Percent_c2d yIn(), yOut(), params
		Else
			ExtremeValueGet_c2d yIn(), params.yBounds, params.roundTo
			ValuesToNormalPercent_c2d yIn(), yOut(), params
		End If

		If params.hLayout = %ChartHLayoutType.Clustered And params.vLayout = %ChartVLayoutType.Normal And params.ub2>params.lb2 Then
			SeriesToClusteredPercent_c2d xIn(), xOut(), params
		Else
			SeriesToNormalPercent_c2d xIn(), xOut(), params
		End If
	End If

	ChartParamsSet_c2d xIn(), params
End Sub

Sub TransformSimple_c2d( ByRef transform As D2D_MATRIX_3X2_F, _
													ByVal translateX As Single, ByVal translateY As Single, _
													Optional ByVal scaleX As Single, Optional ByVal scaleY As Single, _
													Optional ByVal rotation As Single, _
													Optional ByVal skewX As Single, Optional ByVal skewY As Single, _
													Optional ByVal center As D2D1_POINT_2F )
'  'Local transform as D2D_MATRIX_3X2_F
	' Lots of optional parameters :)
	' For all parameters, using 0 means don't do that
	' eg: myTransform = TransformSimple_c2d( helper, 5, 5 ) ' Translate to 5, 5 only
	'     myTransform = TransformSimple_c2d( helper, 0, 0, 3 ) ' Scale by 3 only

	' Scale should be >0 so...  You can specify 0 for one or both of the scale factors to simplify changing scales equally.
	' if you specify one as 0 it will be set to the other
	' if you specify both as 0 they will be set to 1 and no scaling will be done
	Local temp As D2D_MATRIX_3X2_F

	If scaleX <= 0! Then scaleX = scaleY
	If scaleY <= 0! Then scaleY = scaleX
	If scaleX <= 0! Then scaleX = 1!: scaleY = 1!

	MatrixIdentity_c2d transform
	If skewX<>0! Or skewY<>0! Then            MatrixSkewAdd_c2d transform, skewX, skewY, center
	If scaleX<>1! Or scaleY<>1! Then          MatrixScaleAdd_c2d transform, scaleX, scaleY, center
	If rotation<>0! Then                      MatrixRotateAdd_c2d transform, rotation, center
	If translateX<>0! Or translateY<>0! Then  MatrixTranslateAdd_c2d transform, translateX, translateY
End Sub

Sub TransformPath_c2d( ByRef figure As ID2D1PathGeometry, factory As ID2D1Factory, _
													ByVal translateX As Single, ByVal translateY As Single, _
													Optional ByVal scaleX As Single, Optional ByVal scaleY As Single, _
													Optional ByVal rotation As Single, _
													Optional ByVal skewX As Single, Optional ByVal skewY As Single, _
													Optional ByVal center As D2D1_POINT_2F )
	' Lots of optional parameters :)
	' For all parameters, using 0 means don't do that
	' eg: myTransform = TransformSimple_c2d( helper, 5, 5 ) ' Translate to 5, 5 only
	'     myTransform = TransformSimple_c2d( helper, 0, 0, 3 ) ' Scale by 3 only

	' Scale should be >0 so...  You can specify 0 for one or both of the scale factors to simplify changing scales equally.
	' if you specify one as 0 it will be set to the other
	' if you specify both as 0 they will be set to 1 and no scaling will be done

	Local transform As D2D_MATRIX_3X2_F
	TransformSimple_c2d transform, translateX, translateY, scaleX, scaleY, rotation, skewX, skewY, center
	factory.CreateTransformedGeometry( figure, transform, figure )
End Sub

Sub TransformPath_c2d2( ByRef figure As ID2D1PathGeometry, factory As ID2D1Factory, transform As D2D_MATRIX_3X2_F )
	factory.CreateTransformedGeometry( figure, transform, figure )
End Sub

Sub MatrixReflectX_c2d( m As D2D1_MATRIX_3X2_F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = -1
	m.m12 = 0
	m.m21 = 0
	m.m22 = 1
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixReflectY_c2d( m As D2D1_MATRIX_3X2_F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = 1
	m.m12 = 0
	m.m21 = 0
	m.m22 = -1
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixReflectLeftDiagonal_c2d( m As D2D1_MATRIX_3X2_F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = -1
	m.m12 = 0
	m.m21 = 0
	m.m22 = -1
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixReflectRightDiagonal_c2d( m As D2D1_MATRIX_3X2_F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = 0
	m.m12 = 1
	m.m21 = 1
	m.m22 = 0
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixReflectAngle_c2d( m As D2D1_MATRIX_3X2_F, ByVal angle As Single, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = Cos( angle )
	m.m12 = -Sin( angle )
	m.m21 = Sin( angle )
	m.m22 = Cos( angle )
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixReflectAntiAngle_c2d( m As D2D1_MATRIX_3X2_F, ByVal angle As Single, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = Cos( angle )
	m.m12 = Sin( angle )
	m.m21 = Sin( angle )
	m.m22 = -Cos( angle )
	m.m31 = 0
	m.m32 = 0
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

' The following Adapted from d2d1Helper.inc by Jos Roca / Microsoft
Sub  MatrixMultiply_c2d( ByRef m As D2D_MATRIX_3X2_F, ByVal a As D2D_MATRIX_3X2_F, ByVal b As D2D_MATRIX_3X2_F )
	m.m11 = a.m11 * b.m11 + a.m12 * b.m21
	m.m12 = a.m11 * b.m12 + a.m12 * b.m22
	m.m21 = a.m21 * b.m11 + a.m22 * b.m21
	m.m22 = a.m21 * b.m12 + a.m22 * b.m22
	m.m31 = a.m31 * b.m11 + a.m32 * b.m21 + b.m31
	m.m32 = a.m31 * b.m12 + a.m32 * b.m22 + b.m32
End Sub

Sub MatrixTranslate_c2d( ByRef m As D2D1_MATRIX_3X2_F, ByVal x As Single, ByVal y As Single, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = 1.0!
	m.m12 = 0.0!
	m.m21 = 0.0!
	m.m22 = 1.0!
	m.m31 = x
	m.m32 = y
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixScale_c2d( ByRef m As D2D1_MATRIX_3X2_F, ByVal x As Single, ByVal y As Single, Optional ByRef center As D2D1_POINT_2F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	m.m11 = x
	m.m12 = 0.0!
	m.m21 = 0.0!
	m.m22 = y
	If IsMissing( center ) Then
		' Do nothing beause the results are 0
	Else
		m.m31 = center.x - x * center.x
		m.m32 = center.y - y * center.y
	End If
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixRotate_c2d( ByRef m As D2D1_MATRIX_3X2_F, ByVal angle As Single, ByVal center As D2D1_POINT_2F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	D2D1MakeRotateMatrix( angle, center, m )
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixSkew_c2d( ByRef m As D2D1_MATRIX_3X2_F, ByVal angleX As Single, ByVal angleY As Single, Optional ByRef center As D2D1_POINT_2F, Optional ByRef combineWith As D2D1_MATRIX_3X2_F )
	Local center_ As D2D1_POINT_2F
	If IsMissing( center ) Then
		D2D1MakeSkewMatrix( angleX, angleY, center_, m )
	Else
		D2D1MakeSkewMatrix( angleX, angleY, center, m )
	End If
	If Not IsMissing( combineWith ) Then
		MatrixMultiply_c2d m, combineWith, m
	End If
End Sub

Sub MatrixIdentity_c2d( ByRef m As D2D_MATRIX_3X2_F )
	m.m11 = 1.0!
	m.m12 = 0.0!
	m.m21 = 0.0!
	m.m22 = 1.0!
	m.m31 = 0.0!
	m.m32 = 0.0!
End Sub

Sub MatrixReset_c2d( ByRef m As D2D_MATRIX_3X2_F )
	m.m11 = 0.0!
	m.m12 = 0.0!
	m.m21 = 0.0!
	m.m22 = 0.0!
	m.m31 = 0.0!
	m.m32 = 0.0!
End Sub

Sub MatrixTranslateAdd_c2d( ByRef transform As D2D1_MATRIX_3X2_F, ByVal x As Single, ByVal y As Single )
	Local m As D2D1_MATRIX_3X2_F
	MatrixTranslate_c2d m, x, y
	MatrixMultiply_c2d transform, transform, m
End Sub

Sub MatrixScaleAdd_c2d( ByRef transform As D2D1_MATRIX_3X2_F, ByVal x As Single, ByVal y As Single, Optional ByRef center As D2D1_POINT_2F )
	Local m As D2D1_MATRIX_3X2_F
	MatrixScale_c2d m, x, y, center
	MatrixMultiply_c2d transform, transform, m
End Sub

Sub MatrixRotateAdd_c2d( ByRef transform As D2D1_MATRIX_3X2_F, ByVal angle As Single, ByVal center As D2D1_POINT_2F )
	Local m As D2D1_MATRIX_3X2_F
	MatrixRotate_c2d m, angle, center
	MatrixMultiply_c2d transform, transform, m
End Sub

Sub MatrixSkewAdd_c2d( ByRef transform As D2D1_MATRIX_3X2_F, ByVal angleX As Single, ByVal angleY As Single, Optional ByRef center As D2D1_POINT_2F )
	Local m As D2D1_MATRIX_3X2_F
	MatrixSkew_c2d m, angleX, angleY, center
	MatrixMultiply_c2d transform, transform, m
End Sub


Sub MatrixAlignTopLeft_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 0!+w*.5, 0+h*.5 )
End Sub

Sub MatrixAlignTopCenter_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, .5!, 0+h*.5 )
End Sub

Sub MatrixAlignTopRight_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 1!-w*.5!, 0!+h*.5 )
End Sub

Sub MatrixAlignCenterLeft_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 0!+w*.5, .5 )
End Sub

Sub MatrixAlignCenterCenter_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, .5!, .5 )
End Sub

Sub MatrixAlignCenterRight_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 1!-w*.5!, .5 )
End Sub

Sub MatrixAlignBottomLeft_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 0!+w*.5, 1!-h*.5! )
End Sub

Sub MatrixAlignBottomCenter_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, .5!, 1!-h*.5! )
End Sub

Sub MatrixAlignBottomRight_c2d( ByRef m As D2D1_MATRIX_3X2_F, Optional ByVal w As Single, Optional ByVal h As Single )
	MatrixTranslate_c2d( m, 1!-w*.5!, 1!-h*.5! )
End Sub

Sub ValuesToStackedPercent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local lastY, zero, spread As Single
	Local hr As Long
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params
	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	spread = params.yBounds.vmax - params.yBounds.vmin: ' Should be group extremes

	For i = params.lb1 To params.ub1
		lastY = 0
		For j = params.lb2 To params.ub2
			percentOut( i, j ) = lastY + valuesIn( i, j ) / spread
			lastY = percentOut( i, j )
		Next
	Next
End Sub

Sub ValuesToSplinePercent_c2d( valuesIn() As Single, xPercentOut() As Single, yPercentOut() As Single, params As ChartSymbolParams )
	Local stacking, lb1, ub1, lb2, ub2, barNumber, valueCount, lineCount, i, j, z As Long
	Local pnts(), pntsDraw() As D2D1_POINT_2F
	Local start, dx, yValuesTemp(), spread As Single
	Local m, idx As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	' Normal point conversion
	stacking = params.vLayout
	If params.vLayout = %ChartVLayoutType.StackedValue Then
		ExtremeGroupGet_c2d valuesIn(), params.yBounds, params.roundTo
		ValuesToStackedPercent_c2d valuesIn(), yValuesTemp(), params
	ElseIf params.vLayout = %ChartVLayoutType.StackedPercent Then
		ExtremeValueGet_c2d valuesIn(), params.yBounds, params.roundTo
		ValuesToClusterPercent_c2d valuesIn(), yValuesTemp(), params
	Else
		ExtremeValueGet_c2d valuesIn(), params.yBounds, params.roundTo
		ValuesToNormalPercent_c2d valuesIn(), yValuesTemp(), params
	End If

	valueCount = params.ub1 - params.lb1 + 1
	ReDim pnts( valueCount-1 )

	dx = 1! / CSng(valueCount)
	' Now spline the series
	For j = params.lb2 To params.ub2
		start = (1! / CSng( valueCount ) ) / 2!
		For i = params.lb1 To params.ub1
			idx = i-params.lb1
			pnts( idx ).x = start
			pnts( idx ).y = yValuesTemp( i, j )
			start += dx
		Next

		CubicSpline_internal_c2d pnts(), pntsDraw()
		lb1 = LBound( pntsDraw() )
		ub1 = UBound( pntsDraw() )
		spread = (ub1 - lb1 + 1)

		If j=params.lb2 Then ReDim xPercentOut( lb1 To ub1, params.lb2 To params.ub2 ), yPercentOut( lb1 To ub1, params.lb2 To params.ub2 )

		' Save splined values
		For i = lb1 To ub1
			yPercentOut( i, j ) = pntsDraw( i ).y
			xPercentOut( i, j ) = pntsDraw( i ).x
		Next
	Next
	params.lb1 = LBound( xPercentOut(), 1 )
	params.ub1 = UBound( xPercentOut(), 1 )
End Sub

Sub ValuesToNormalPercent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local pY, zero, spread As Single
	Local hr As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local isNormal As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	' Smallest value can't be > 0 (GroupExtreme limits it)
	' Largest value can't be < 0 (GroupExtreme limits it)
	spread = params.ybounds.vmax - params.ybounds.vmin

	For i = params.lb1 To params.ub1
		For j = params.lb2 To params.ub2
			Local c As Single
			c = valuesIn( i, j )
			percentOut( i, j ) = valuesIn( i, j ) / spread
			c = percentOut( i, j )
		Next
	Next
End Sub

Sub ValuesToClusterPercent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local total, curVal, startAngle, degreesPerValue, valueCount As Single
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	valueCount = params.ub1 - params.lb1 + 1

	For i = params.lb1 To params.ub1
		total = 0
		For j = params.lb2 To params.ub2
			total += valuesIn(i,j)
		Next
		curVal = 0
		For j = params.lb2 To params.ub2
			curVal += valuesIn( i, j )
			percentOut( i, j ) = curVal / total
		Next
	Next
End Sub

Sub ValuesTo100Percent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local lastY, zero, spread As Single
	Local hr As Long
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params
	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	For i = params.lb1 To params.ub1
		spread = 0
		For j = params.lb2 To params.ub2
			spread += valuesIn( i, j )
		Next
		lastY = 0
		For j = params.lb2 To params.ub2
			percentOut( i, j ) = lastY + valuesIn( i, j ) / spread
			lastY = percentOut( i, j )
		Next
	Next
End Sub

Sub StarPointsNew_c2d( values() As D2D1_Point_2F, pointCount As Long, Optional ByVal center As D2D1_POINT_2F, Optional ByVal radius As RadiusRange_F, Optional rotation As Single )
	Local angle, s As Single
	Local r As Long
	Local i, j As Long
	Local x1, y1 As Single

	angle = DegreesToRadians( rotation + 90! )
	s = DegreesToRadians ( 360! ) / CSng( pointCount * 2! )
	ReDim values( pointCount * 2 - 1 )

	For i=1 To pointCount*2
		r Xor= 1
		If r Then
			values(j).x = center.x + Sin(angle) * radius.outer
			values(j).y = center.y + Cos(angle) * radius.outer
		Else
			values(j).x = center.x + Sin(angle) * radius.inner
			values(j).y = center.y + Cos(angle) * radius.inner
		End If
		Incr j
		angle += s
	Next
End Sub

Sub CubicSpline_internal_c2d( pntsIn() As D2D1_POINT_2F, pntsOut() As D2D1_POINT_2F )
	Local i, n, c As Long
	Local start, last, dx As Single
	Local lb1, ub1 As Long

	' Dim pntsIn( x )
	ub1 = UBound( pntsIn() )
	c = ub1+1

	' Generate point sequences (12 segments per point)
	n = c*40-1

	ReDim pntsOut( n )

	For i=0 To n
		pntsOut(i).x = CSng(i) / CSng(n): 'start
	Next

	' calculate splines
	For i=0 To n
		pntsOut(i).y = CubicSplinePoint_internal_c2d( pntsIn(), pntsOut(i).x )
	Next
	start = pntsOut( n ).y
	start = pntsOut( 0 ).y
	i=i
End Sub

Function CubicSplinePoint_internal_c2d( pnts() As D2D1_POINT_2F, x As Single ) As Single
	Local pa() As D2D1_POINT_2F
	Local i, c, ub1 As Long
	Local dx As Single
	ub1 = UBound( pnts() )
	c = ub1
	ReDim pa(c+4)

	Local m, b As Single
	' Insert mythical point (use the last point)

	For i=0 To ub1
		pa(i+2) = pnts(i)
	Next
	If ub1<>0 Then
		dx = (pnts(1).x - pnts(0).x)
	Else
		dx = pnts(0).x
	End If

	pa(0).x = pnts(0).x - dx*2
	pa(0).y = pnts(ub1-1).y

	pa(1).x = pnts(0).x - dx
	pa(1).y = pnts(ub1).y

	pa(c+3).x = pnts(ub1).x + dx
	pa(c+3).y = pnts(0).y

	pa(c+4).x = pnts(ub1).x + dx*2
	pa(c+4).y = pnts(1).y

	Local d1, d2, y As Single
	Local n As Long
	Local dx(), derivative() As Single
	n = UBound( pa() )
	ReDim dx(n)

	CubicSplineSecondDerivatives_internal_c2d derivative(), pa()

	For i=1 To n
		dx(i) = pa(i).x - pa(i-1).x
	Next
	m = UBound( derivative() )
	If m<0 Then Function = 1: Exit Function

	For i=1 To n-1
		If x >= pa(i).x And x < pa(i + 1).x Then
			d1 = x - pa(i).x
			d2 = pa(i + 1).x - x
			y = derivative(i - 1) * d2 * d2 * d2 / (6.0 * dx(i + 1)) + _
					derivative(i) * d1 * d1 * d1 / (6.0 * dx(i + 1)) + _
					(pa(i + 1).y / dx(i + 1) - derivative(i) * dx(i + 1) / 6.0) * d1 + _
					(pa(i).y / dx(i + 1) - derivative(i - 1) * dx(i + 1) / 6.0) * d2
			Exit For
		End If
	Next
	Function = y
End Function

Sub CubicSplineSecondDerivatives_internal_c2d(derivative() As Single, pnts() As D2D1_POINT_2F )
	Local i, n As Long
	n = UBound( pnts() )
	Local c1(), c2(), c3(), dx() As Single
	ReDim c1(n), c2(n), c3(n), dx(n), derivative(n)

	For i=1 To n
		dx(i) = pnts(i).x - pnts(i - 1).x
		derivative(i) = (pnts(i).y - pnts(i - 1).y) / dx(i)
	Next

	For i=1 To n-1
		c2(i - 1) = 2
		c3(i - 1) = dx(i + 1) / (dx(i) + dx(i + 1))
		c1(i - 1) = 1 - c3(i - 1)
		derivative(i - 1) = 6 * (derivative(i + 1) - derivative(i)) / (dx(i) + dx(i + 1))
	Next

	CubicSplineTridiagonal_internal_c2d derivative(), n - 1, c1(), c2(), c3()
End Sub

Sub CubicSplineTridiagonal_internal_c2d( derivative() As Single, n As Long, c1() As Single, c2() As Single, c3() As Single )
	Local i, isSingular As Long
	Local tol As Single

	tol = 1.0e-12!
	isSingular = IIf&( c2(0) < tol, -1, 0 )

	i = 1
	While i < n And IsFalse isSingular
		c1(i) = c1(i) / c2(i - 1)
		c2(i) = c2(i) - c1(i) * c3(i - 1)
		isSingular = IIf&(c2(i) < tol, -1, 0 )
		derivative(i) = derivative(i) - c1(i) * derivative(i - 1)

		i += 1
	Wend

	If IsFalse isSingular Then
		derivative(n - 1) = derivative(n - 1) / c2(n - 1)
		For i=n-2 To 0 Step -1
			derivative(i) = (derivative(i) - c3(i) * derivative(i + 1)) / c2(i)
		Next
	Else
		'Erase derivative()
	End If
End Sub

Sub SeriesToNormalPercent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local pointSpacing, groupCount, startX As Single
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 ): ' Works for 1 and 2 dimension arrays! :)

	groupCount = params.ub1 - params.lb1 + 1
	pointSpacing = 1  / groupCount
	startX = pointSpacing / 2!

	For i = params.lb1 To params.ub1
		For j = params.lb2 To params.ub2
			percentOut( i, j ) = startX
		Next
		startX += pointSpacing
	Next

End Sub

Sub SeriesToNormalDegrees_c2d( valuesIn() As Single, degreesOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local degrees, degreesPerPoint As Single
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	ReDim degreesOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )
	degreesPerPoint = 360! / (ub1 - lb1 + 1)

	For i = params.lb1 To params.ub1
		degrees = degreesPerPoint / 2! + (( i - params.lb1 ) * degreesPerPoint )
		For j = params.lb2 To params.ub2
			degreesOut( i, j ) = degrees
		Next
	Next
End Sub

Sub SeriesToClusteredPercent_c2d( valuesIn() As Single, percentOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local groupCount, barCount As Single
	Local groupSpacing, barSpacing, groupX As Single
	Local lb1, ub1, lb2, ub2 As Long

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	' PB's cool, even if my input array only has 1 dimension this works to output a 1 dimension array :)
	ReDim percentOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	groupCount = params.ub1 - params.lb1 + 1
	barCount = params.ub2 - params.lb2 + 1
	groupSpacing = 1 / groupCount
	barSpacing = (groupSpacing - params.groupPadding) / barCount
	params.width = barSpacing

	For i = params.lb1 To params.ub1
		groupX = params.groupPadding/2! + barSpacing/2 + ( i - params.lb1 ) * groupSpacing
		For j = params.lb2 To params.ub2
			percentOut(i,j) = groupX + ( j - params.lb2 ) * barSpacing
		Next
	Next
End Sub

Sub SeriesToClusteredDegrees_c2d( valuesIn() As Single, degreesOut() As Single, params As ChartSymbolParams )
	Local i, j As Long
	Local startAngle, valueCount, groupCount, degreesPercluster, degreesPerBar As Single
	Local lb1, ub1, lb2, ub2 As Long

	' expects params.groupPadding to be in degrees
	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d valuesIn(), params

	ReDim degreesOut( params.lb1 To params.ub1, params.lb2 To params.ub2 )

	valueCount = params.ub1 - params.lb1 + 1
	groupCount = params.ub2 - params.lb2 + 1
	degreesPerCluster = (360! / valueCount)
	degreesPerBar = (degreesPerCluster-params.groupPadding) / (groupCount)

	For i = params.lb1 To params.ub1
		startAngle = (i-lb1) * degreesPerCluster + degreesPerBar/2! + params.groupPadding/2!
		For j = params.lb2 To params.ub2
			degreesOut(i,j) =  startAngle + (j-lb2)*degreesPerBar
		Next
	Next
End Sub

Function PolygonPointsNew_c2d( values() As PointF, params As PolygonPointsParams ) As Long
	Local i As Long
	Local degreesPerSide, rotateRadians As Single

	If params.sides<3 Then Exit Function
	ReDim values(params.sides-1)

	rotateRadians = DegreesToRadians(params.rotateDegrees)
	degreesPerSide = DegreesToRadians(360! / params.sides)
	For i=0 To params.sides-1
		values(i).x = params.center.x + Sin( i * degreesPerSide + rotateRadians ) * params.radius
		values(i).y = params.center.y + Cos( i * degreesPerSide + rotateRadians ) * params.radius
	Next
	Function = -1
End Function

Function ValueNormal_c2d( ByVal value As Single, ByVal spread As Single ) As Single
	Function = value / spread
End Function

Sub GearPointsNew_c2d( values() As PointF, cx As Single, cy As Single, dta As GearPointsParams )
	Local a, e, s, o As Single
	Local i, r, started, pointIndex, hr As Long
	Local x1, y1, x2, y2 As Single

	a = DegreesToRadians( dta.rotateDegrees )
	e = a + PI2
	s = PI2 / ( dta.cogs * 2!)
	o = s * dta.percentSlope

	ReDim values( dta.cogs*4-1 )

	For i=1 To dta.cogs*2
		r Xor= 1
		If r Then
			x1 = cx + Sin(a+o)   * dta.radius.outer
			y1 = cy + Cos(a+o)   * dta.radius.outer
			x2 = cx + Sin(a+s-o) * dta.radius.outer
			y2 = cy + Cos(a+s-o) * dta.radius.outer
		Else
			x1 = cx + Sin(a+o)   * dta.radius.inner
			y1 = cy + Cos(a+o)   * dta.radius.inner
			x2 = cx + Sin(a+s-o) * dta.radius.inner
			y2 = cy + Cos(a+s-o) * dta.radius.inner
		End If

		values(pointIndex).x = x1
		values(pointIndex).y = y1
		Incr pointIndex

		values(pointIndex).x = x2
		values(pointIndex).y = y2
		Incr pointIndex

		a += s
	Next
End Sub

Sub Lines2JoinSmoothStroke_c2d( sink As ID2D1GeometrySink, line1a As D2D1_POINT_2F, line1b As D2D1_POINT_2F, line2a As D2D1_POINT_2F, line2b As D2D1_POINT_2F, ByVal softness As Single )
	'Local x As Single, y As Single, w As Single, h As Single
	Local dx, dy As Single
	Local pa As D2D1_POINT_2F
	Local bez As D2D1_BEZIER_SEGMENT

	' Note this doesn't start or end a figure.  Designed to be used to add a smooth connection between two disconnected lines as part of the
	' It's expected the current position is already at line1b.  If you want to draw line1 you should have just finished drawing it...

	dx = line1b.x - line1a.x
	dy = line1b.y - line1a.y
	bez.point1.x = line1b.x + dx*softness
	bez.point1.y = line1b.y + dy*softness

	dx = line2a.x - line2b.x
	dy = line2a.y - line2b.y
	bez.point2.x = line2a.x + dx*softness
	bez.point2.y = line2a.y + dy*softness

	bez.point3.x = line2a.x
	bez.point3.y = line2a.y
	sink.AddBezier( bez )
End Sub

Sub LineSmoothJoinEnd_c2d( endPoint As D2D1_POINT_2F, p1 As D2D1_POINT_2F, p2 As D2D1_POINT_2F, p3 As D2D1_POINT_2F, param As SmoothLineParams )
	Local dx, dy, px, py, ex2, ey2 As Single
	Local percentSide As Single

	percentSide = Max( 0, Min( 1!, param.pctSide ) ) * .5

	px = p2.x
	py = p2.y

	' Calc distance back line2
	dx = p3.x - px
	dy = p3.y - py
	ex2 = px + dx*param.pctSide
	ey2 = py + dy*param.pctSide

	endPoint.x = ex2
	endPoint.y = ey2
End Sub

Sub LinesSmoothJoinStroke_c2d( localSink As ID2D1GeometrySink, p1 As D2D1_POINT_2F, p2 As D2D1_POINT_2F, p3 As D2D1_POINT_2F, param As SmoothLineParams )
	Local dx, dy, px, py, ex1, ey1, ex2, ey2 As Single
	Local cx1, cy1, cx2, cy2 As Single
	Local pa As D2D1_POINT_2F
	Local bez As D2D1_BEZIER_SEGMENT
	Local percentSide As Single

	percentSide = Max( 0, Min( 1!, param.pctSide ) ) * .5

	px = p2.x
	py = p2.y

	' Calc distance back line1
	dx = p1.x - px
	dy = p1.y - py
	ex1 = px + dx*percentSide
	ey1 = py + dy*percentSide

	dx = ex1 - px
	dy = ey1 - py
	cx1 = px + dx*param.softness
	cy1 = py + dy*param.softness

	' Calc distance back line2
	dx = p3.x - px
	dy = p3.y - py
	ex2 = px + dx*percentSide
	ey2 = py + dy*percentSide

	dx = ex2 - px
	dy = ey2 - py
	cx2 = px + dx*param.softness
	cy2 = py + dy*param.softness

	'line to ex1, ey1
	pa.x = ex1
	pa.y = ey1
	localSink.AddLine( pa )

	'bezier (use mid point as anchor for Bezier)
	'  px, py
	'  px, py
	'  ex2, ey2
	bez.point1.x = cx1
	bez.point1.y = cy1
	bez.point2.x = cx2
	bez.point2.y = cy2
	bez.point3.x = ex2
	bez.point3.y = ey2
	localSink.AddBezier( bez )
End Sub

Sub ArcStroke_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	startAngle = DegreesToRadians( startAngle )
	endAngle = DegreesToRadians( endAngle )
	ArcRadiansStroke_c2d sink, startAngle, endAngle, startRadius, endRadius, center
End Sub

Sub ArcRadiansStroke_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	Local sweep, seg, segDegrees, radius, radiusChange As Single
	Local pieSeg As D2D1_ARC_SEGMENT
	startAngle  += 1.570796326794897!  ' +90 degrees
	endAngle    += 1.570796326794897!

	' Current position is at start of arc
	startRadius = Max( 0!, Min( .5!, startRadius ) )
	endRadius = Max( 0!, Min( .5!, endRadius ) )
	If startRadius = 0! Then startRadius = .5!
	If endRadius = 0! Then endRadius = startRadius

	If startAngle = endAngle Then endAngle += .0001!
	If Abs(endAngle - startAngle) >= PI2()-.0001! And startRadius = endRadius Then
		If endAngle>startAngle Then
			endAngle = startAngle + PI2() - .0001!
		Else
			endAngle = startAngle - PI2() + .0001!
		End If
	End If

	sweep = endAngle - startAngle

	pieSeg.rotationAngle = 0
	If sweep>0 Then
		pieSeg.sweepDirection = %D2D1_SWEEP_DIRECTION_COUNTER_CLOCKWISE
	Else
		pieSeg.sweepDirection = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	End If
	pieSeg.arcSize = %D2D1_ARC_SIZE_SMALL

	If endRadius <> startRadius Then
		segDegrees = DegreesToRadians( 15! ) * Sgn( sweep )
		radiusChange = (endRadius - startRadius) / ( Abs(endAngle - startAngle) / Abs(segDegrees) )
		radius = startRadius

		For seg = startAngle+segDegrees To endAngle-segDegrees+.01*Sgn(sweep) Step segDegrees
			radius += radiusChange
			pieSeg.point.x = center.x + Sin( seg ) * radius
			pieSeg.point.y = center.y + Cos( seg ) * radius
			pieSeg.size.width = radius
			pieSeg.size.height = radius
			sink.AddArc( pieSeg )
		Next
	End If

	pieSeg.point.x = center.x + Sin( endAngle ) * endRadius
	pieSeg.point.y = center.y + Cos( endAngle ) * endRadius
	pieSeg.size.width = endRadius
	pieSeg.size.height = endRadius
	If Abs( sweep ) < 3.141592653589794! Or endRadius <> startRadius Then
		pieSeg.arcSize = %D2D1_ARC_SIZE_SMALL
	Else
		pieSeg.arcSize = %D2D1_ARC_SIZE_LARGE
	End If
	sink.AddArc( pieSeg )
End Sub

Sub WebFigure_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  .3066245 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -5.330614E-2 * fSize.width
	pa.y = center.y +  .3074464 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1009498 * fSize.width
	pa.y = center.y +  .3099123 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1426875 * fSize.width
	pa.y = center.y +  .3140222 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1785192 * fSize.width
	pa.y = center.y +  .3197759 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2418412 * fSize.width
	pa.y = center.y +  .4074525 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1173892 * fSize.width
	pa.y = center.y +  .3917438 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.43546E-4 * fSize.width
	pa.y = center.y +  .3865076 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1173891 * fSize.width
	pa.y = center.y +  .3917438 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2423283 * fSize.width
	pa.y = center.y +  .4074525 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1785192 * fSize.width
	pa.y = center.y +  .3197759 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1427179 * fSize.width
	pa.y = center.y +  .3140222 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1010716 * fSize.width
	pa.y = center.y +  .3099123 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  5.358009E-2 * fSize.width
	pa.y = center.y +  .3074464 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  .3066245 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  .2028738 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -5.041403E-2 * fSize.width
	pa.y = center.y +  .2055529 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1010716 * fSize.width
	pa.y = center.y +  .2135899 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1551388 * fSize.width
	pa.y = center.y +  .288115 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -8.426693E-2 * fSize.width
	pa.y = center.y +  .2808086 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.43546E-4 * fSize.width
	pa.y = center.y +  .2783731 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  8.426689E-2 * fSize.width
	pa.y = center.y +  .2808086 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1556259 * fSize.width
	pa.y = center.y +  .288115 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1010716 * fSize.width
	pa.y = center.y +  .2135899 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  5.053576E-2 * fSize.width
	pa.y = center.y +  .2055529 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  .2028738 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  7.476863E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -7.769119E-2 * fSize.width
	pa.y = center.y +  .1814418 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.43546E-4 * fSize.width
	pa.y = center.y +  .1746225 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.677541E-2 * fSize.width
	pa.y = center.y +  .1763273 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  7.769119E-2 * fSize.width
	pa.y = center.y +  .1814418 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.43546E-4 * fSize.width
	pa.y = center.y +  7.476863E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .1405261 * fSize.width
	pa.y = center.y +  1.485631E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  1.972723E-2 * fSize.width
	pa.y = center.y +  5.382368E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  9.327813E-2 * fSize.width
	pa.y = center.y +  .1551388 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1127618 * fSize.width
	pa.y = center.y +  7.866537E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1243302 * fSize.width
	pa.y = center.y +  4.834389E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1405261 * fSize.width
	pa.y = center.y +  1.485631E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.1405261 * fSize.width
	pa.y = center.y +  1.485631E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.1243302 * fSize.width
	pa.y = center.y +  4.834389E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1127618 * fSize.width
	pa.y = center.y +  7.866537E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -9.327813E-2 * fSize.width
	pa.y = center.y +  .1551388 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.972723E-2 * fSize.width
	pa.y = center.y +  5.382368E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1405261 * fSize.width
	pa.y = center.y +  1.485631E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .2661958 * fSize.width
	pa.y = center.y + -2.605943E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .1785192 * fSize.width
	pa.y = center.y +  2.679006E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .140526 * fSize.width
	pa.y = center.y +  .0857282 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1142231 * fSize.width
	pa.y = center.y +  .1838772 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .172187 * fSize.width
	pa.y = center.y +  .2632733 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1869216 * fSize.width
	pa.y = center.y +  .194715 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2116415 * fSize.width
	pa.y = center.y +  .1108134 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2386751 * fSize.width
	pa.y = center.y +  .0356795 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2661958 * fSize.width
	pa.y = center.y + -2.605943E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2661958 * fSize.width
	pa.y = center.y + -2.605943E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2386751 * fSize.width
	pa.y = center.y +  .0356795 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2116415 * fSize.width
	pa.y = center.y +  .1108134 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1869216 * fSize.width
	pa.y = center.y +  .194715 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.172187 * fSize.width
	pa.y = center.y +  .2632733 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1142231 * fSize.width
	pa.y = center.y +  .1838772 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1390648 * fSize.width
	pa.y = center.y +  .0893814 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1562348 * fSize.width
	pa.y = center.y +  4.554311E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1785192 * fSize.width
	pa.y = center.y +  2.679006E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2661958 * fSize.width
	pa.y = center.y + -2.605943E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .4059912 * fSize.width
	pa.y = center.y + -7.135899E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .3032148 * fSize.width
	pa.y = center.y + -3.823673E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2878105 * fSize.width
	pa.y = center.y + -7.793473E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2717974 * fSize.width
	pa.y = center.y +  2.898198E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2551754 * fSize.width
	pa.y = center.y +  7.208963E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2379445 * fSize.width
	pa.y = center.y +  .1215295 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2101802 * fSize.width
	pa.y = center.y +  .2149294 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1941062 * fSize.width
	pa.y = center.y +  .293473 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2559669 * fSize.width
	pa.y = center.y +  .3787141 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .283244 * fSize.width
	pa.y = center.y +  .2534096 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3163663 * fSize.width
	pa.y = center.y +  .1376035 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3550901 * fSize.width
	pa.y = center.y +  .0356795 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4059912 * fSize.width
	pa.y = center.y + -7.135899E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.4059912 * fSize.width
	pa.y = center.y + -7.135899E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.3550901 * fSize.width
	pa.y = center.y +  .0356795 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3163663 * fSize.width
	pa.y = center.y +  .1376035 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.283244 * fSize.width
	pa.y = center.y +  .2534096 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2559669 * fSize.width
	pa.y = center.y +  .3787141 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1941062 * fSize.width
	pa.y = center.y +  .293473 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2101802 * fSize.width
	pa.y = center.y +  .2149294 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2379445 * fSize.width
	pa.y = center.y +  .1215295 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2551754 * fSize.width
	pa.y = center.y +  7.208963E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2717974 * fSize.width
	pa.y = center.y +  2.898198E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2878105 * fSize.width
	pa.y = center.y + -7.793473E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3032148 * fSize.width
	pa.y = center.y + -3.823673E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4059912 * fSize.width
	pa.y = center.y + -7.135899E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.1078909 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y +  2.654652E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1390648 * fSize.width
	pa.y = center.y + -1.388212E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  6.989771E-2 * fSize.width
	pa.y = center.y + -5.772041E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  4.274229E-2 * fSize.width
	pa.y = center.y + -7.951778E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.1078909 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.1078909 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -4.274233E-2 * fSize.width
	pa.y = center.y + -7.951778E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.989771E-2 * fSize.width
	pa.y = center.y + -5.772041E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1390648 * fSize.width
	pa.y = center.y + -1.388212E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y +  2.654652E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.1078909 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.2394058 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.1483195 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  4.931803E-2 * fSize.width
	pa.y = center.y + -.1115441 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  8.840721E-2 * fSize.width
	pa.y = center.y + -7.915246E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1731612 * fSize.width
	pa.y = center.y + -2.508524E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2666829 * fSize.width
	pa.y = center.y + -5.528495E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .204944 * fSize.width
	pa.y = center.y + -9.108622E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1307842 * fSize.width
	pa.y = center.y + -.1419873 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  6.502675E-2 * fSize.width
	pa.y = center.y + -.1928885 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.2394058 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.2394058 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -6.502679E-2 * fSize.width
	pa.y = center.y + -.1928885 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1307842 * fSize.width
	pa.y = center.y + -.1419873 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.204944 * fSize.width
	pa.y = center.y + -9.108622E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2666829 * fSize.width
	pa.y = center.y + -5.528495E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1731612 * fSize.width
	pa.y = center.y + -2.508524E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -8.840721E-2 * fSize.width
	pa.y = center.y + -7.915246E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -4.931807E-2 * fSize.width
	pa.y = center.y + -.1115441 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.1483195 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.2394058 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.3869946 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.2788602 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.768871E-2 * fSize.width
	pa.y = center.y + -.2544751 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  6.819285E-2 * fSize.width
	pa.y = center.y + -.2271066 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1053945 * fSize.width
	pa.y = center.y + -.1967547 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1492937 * fSize.width
	pa.y = center.y + -.1634194 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1917316 * fSize.width
	pa.y = center.y + -.1330979 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2313687 * fSize.width
	pa.y = center.y + -.1069167 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2682051 * fSize.width
	pa.y = center.y + -8.487579E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3022406 * fSize.width
	pa.y = center.y + -6.697516E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4025816 * fSize.width
	pa.y = center.y + -9.961033E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2903069 * fSize.width
	pa.y = center.y + -.1648807 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1892353 * fSize.width
	pa.y = center.y + -.2330736 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1018022 * fSize.width
	pa.y = center.y + -.3032148 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.3869946 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.3869946 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.1016805 * fSize.width
	pa.y = center.y + -.3032148 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1887482 * fSize.width
	pa.y = center.y + -.2330736 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2900633 * fSize.width
	pa.y = center.y + -.1648807 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4020945 * fSize.width
	pa.y = center.y + -9.961033E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3022406 * fSize.width
	pa.y = center.y + -6.697516E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2682051 * fSize.width
	pa.y = center.y + -8.487579E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2313688 * fSize.width
	pa.y = center.y + -.1069167 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1917316 * fSize.width
	pa.y = center.y + -.1330979 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1492937 * fSize.width
	pa.y = center.y + -.1634194 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1053945 * fSize.width
	pa.y = center.y + -.1967547 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.819289E-2 * fSize.width
	pa.y = center.y + -.2271066 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -3.768875E-2 * fSize.width
	pa.y = center.y + -.2544751 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.2788602 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.3869946 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.4790551 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.4790551 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  1.388212E-2 * fSize.width
	pa.y = center.y + -.4264491 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1067949 * fSize.width
	pa.y = center.y + -.3359717 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2072577 * fSize.width
	pa.y = center.y + -.2545056 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2581588 * fSize.width
	pa.y = center.y + -.2186739 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3134438 * fSize.width
	pa.y = center.y + -.1827813 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3731125 * fSize.width
	pa.y = center.y + -.1468278 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4371651 * fSize.width
	pa.y = center.y + -.1108134 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4912324 * fSize.width
	pa.y = center.y + -.1283488 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y + -.1020458 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4434973 * fSize.width
	pa.y = center.y + -8.353629E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3876035 * fSize.width
	pa.y = center.y +  3.093035E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3426693 * fSize.width
	pa.y = center.y +  .1483195 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3243424 * fSize.width
	pa.y = center.y +  .2071359 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3073551 * fSize.width
	pa.y = center.y +  .2700925 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2917073 * fSize.width
	pa.y = center.y +  .3371895 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2773989 * fSize.width
	pa.y = center.y +  .4084267 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3168534 * fSize.width
	pa.y = center.y +  .4624939 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2944472 * fSize.width
	pa.y = center.y +  .4790551 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2652216 * fSize.width
	pa.y = center.y +  .4391135 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1321237 * fSize.width
	pa.y = center.y +  .4204822 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.43546E-4 * fSize.width
	pa.y = center.y +  .4142718 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1322455 * fSize.width
	pa.y = center.y +  .4204822 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2652216 * fSize.width
	pa.y = center.y +  .4391135 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2944472 * fSize.width
	pa.y = center.y +  .4790551 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3168534 * fSize.width
	pa.y = center.y +  .4624939 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2773989 * fSize.width
	pa.y = center.y +  .4084267 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2917073 * fSize.width
	pa.y = center.y +  .3371895 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3073551 * fSize.width
	pa.y = center.y +  .2700925 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3243424 * fSize.width
	pa.y = center.y +  .2071359 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3426693 * fSize.width
	pa.y = center.y +  .1483195 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3876035 * fSize.width
	pa.y = center.y +  3.093035E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4434973 * fSize.width
	pa.y = center.y + -8.353629E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.5 * fSize.width
	pa.y = center.y + -.1020458 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4912324 * fSize.width
	pa.y = center.y + -.1283488 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.436678 * fSize.width
	pa.y = center.y + -.1108134 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3728386 * fSize.width
	pa.y = center.y + -.1468278 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.313322 * fSize.width
	pa.y = center.y + -.1827813 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2581284 * fSize.width
	pa.y = center.y + -.2186739 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2072577 * fSize.width
	pa.y = center.y + -.2545056 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1067949 * fSize.width
	pa.y = center.y + -.3359717 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.4264491 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.388212E-2 * fSize.width
	pa.y = center.y + -.4790551 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function WebPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	WebFigure_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Function TombstoneBodyLength_c2d( Optional ByVal thickness As Single, Optional ByVal scaleTombstone As Single ) As Single
	If scaleTombstone = 0! Then scaleTombstone = 1!
	thickness = Min( 1!, thickness )
	If thickness=0!   Then thickness   = 1
	Function   = ((1!-thickness) + thickness/2!) * scaleTombstone
End Function

Function TombstoneCapSize_c2d( Optional ByVal thickness As Single, Optional ByVal scaleTombstone As Single ) As Single
	If scaleTombstone = 0! Then scaleTombstone = 1!
	thickness = Min( 1!, thickness )
	If thickness=0!   Then thickness   = 1
	Function = thickness * .5! * scaleTombstone
End Function

Sub TombstoneFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal thickness As Single, Optional ByVal scaleTombstone As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long )
	Local tl, tr, bl, br As D2D1_POINT_2F
	Local h, w, cap As Single
	Local dot As D2D1_ARC_SEGMENT

	If scaleTombstone = 0! Then scaleTombstone = 1!
	w = Min( 1!, thickness )

	If w=0!   Then w   = scaleTombstone Else w *= scaleTombstone
	If h=0!   Then h   = TombstoneBodyLength_c2d( thickness, scaleTombstone ) Else h *= scaleTombstone
	If cap=0! Then cap = TombstoneCapSize_c2d( thickness, scaleTombstone ) Else cap *= scaleTombstone

	' Get 4 corners
	tl.x = center.x - w / 2!
	tl.y = center.y - h / 2! + cap/2

	tr.x = tl.x + w
	tr.y = tl.y

	bl.x = tl.x
	bl.y = tl.y + h

	br.x = tr.x
	br.y = bl.y

	If isHollow Then
		sink.BeginFigure( tl, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( tl, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	dot.point            = tr
	dot.size.width       = cap
	dot.size.height      = cap
	dot.rotationAngle    = 0
	dot.sweepDirection   = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	dot.arcSize          = %D2D1_ARC_SIZE_SMALL
	sink.AddArc( dot )

	sink.AddLine( br )
	sink.AddLine( bl )

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub StarFigureAdd_c2d( sink As ID2D1GeometrySink, pointCount As Long, Optional ByVal center As D2D1_POINT_2F, Optional ByVal radius As RadiusRange_F, Optional ByVal rotation As Single, Optional ByVal roundness As Single, Optional ByVal isHollow As Long )
	Local pa As D2D1_POINT_2F
	Local i, c, start As Long
	Local vertices() As D2D1_POINT_2F
	Local params As SmoothLineParams


	pointCount = Max( 4!, pointCount )
	If radius.outer = 0! Then radius.outer = .5!
	If radius.inner = 0! Then radius.inner = radius.outer * .4!

	StarPointsNew_c2d  vertices(), pointCount, center, radius, rotation

	c = UBound( vertices() )
	If roundness>0 Then
		params.pctSide = roundness
		params.softness = .25

		pa.x = (vertices(0).x + vertices(c).x ) / 2!
		pa.y = (vertices(0).y + vertices(c).y ) / 2!
		start = 0
	Else
		pa = vertices(0)
		start = 1
	End If

	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If
	For i=start To c
		If roundness>0! Then
			If i=0 Then
				LinesSmoothJoinStroke_c2d sink, vertices(c), vertices(i), vertices(i+1), params
			ElseIf i<c Then
				LinesSmoothJoinStroke_c2d sink, vertices(i-1), vertices(i), vertices(i+1), params
			Else
				LinesSmoothJoinStroke_c2d sink, vertices(i-1), vertices(i), vertices(0), params
			End If
		Else
			sink.AddLine vertices(i)
		End If
	Next
	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub ReticleArcFigureAdd_c2d( sink As ID2D1GeometrySink, params As ReticleArcSinkParams )
	Local pa As D2D1_POINT_2F
	Local sweep, seg, segDegrees, radius, radiusChange, baseAngle, markSize, markAngle, modAngle As Single
	Local firstAngle, lastAngle, firstRadius, lastRadius As Single
	Local center As D2D1_POINT_2F
	Local ofsInner, ofsOuter As Single
	Local markSide, hideLine As Long
	Local pieSeg As D2D1_ARC_SEGMENT

	center      = params.center
	firstAngle  = params.sweepDegrees.first
	lastAngle   = params.sweepDegrees.last
	firstRadius = params.radius.first
	lastRadius  = params.radius.last
	baseAngle = params.baseDegrees
	markSide    = params.markSide
	markSize    = params.markSize
	markAngle   = params.markDegrees
	hideLine    = params.hideLine

	firstRadius = Max( 0!, Min( .5!, firstRadius ) )
	lastRadius  = Max( 0!, Min( .5!, lastRadius ) )
	If firstRadius = 0! Then firstRadius = .5!
	If lastRadius = 0!  Then lastRadius = firstRadius

	modAngle = (firstAngle-baseAngle) Mod markAngle

	firstAngle = DegreesToRadians( firstAngle + 90 )
	lastAngle  = DegreesToRadians( lastAngle + 90 )
	baseAngle  = DegreesToRadians( baseAngle + 90 )
	markAngle  = DegreesToRadians( markAngle )
	modAngle   = DegreesToRadians( modAngle )
	sweep      = lastAngle - firstAngle

	If hideLine=0 Then
		' base registration line
		pa.x = center.x + Sin( firstAngle ) * firstRadius
		pa.y = center.y + Cos( firstAngle ) * firstRadius
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		ArcRadiansStroke_c2d sink, firstAngle - DegreesToRadians(90), lastAngle - DegreesToRadians(90), firstRadius, lastRadius, center
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If

	If ( markSide And %ReticleArcMarks.Inside ) <> 0 Then ofsInner = -markSize
	If ( markSide And %ReticleArcMarks.Outside ) <> 0 Then ofsOuter = markSize

	If ofsInner<>ofsOuter Then
		' Draw registration marks
		markAngle = Abs(markAngle) * Sgn( sweep )
		radiusChange = (lastRadius - firstRadius) / ( (lastAngle - firstAngle) / Abs( markAngle ) )
		radius = firstRadius

		If modAngle <> 0 Then
			firstAngle += modAngle
			radius += (lastRadius - firstRadius) / ( (lastAngle - firstAngle) / Abs( modAngle ) )
		End If

		For seg = firstAngle To lastAngle+.01*Sgn(sweep) Step markAngle
			pa.x = center.x + Sin( seg ) * ( radius + ofsInner )
			pa.y = center.y + Cos( seg ) * ( radius + ofsInner )
			sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )

			pa.x = center.x + Sin( seg ) * ( radius + ofsOuter )
			pa.y = center.y + Cos( seg ) * ( radius + ofsOuter )
			sink.AddLine( pa )
			sink.EndFigure( %D2D1_FIGURE_END_OPEN )
			radius += radiusChange
		Next
	End If
End Sub

Sub ReticleFigureAdd_c2d( sink As ID2D1GeometrySink, params As ReticleSinkParams )
	Local pa As D2D1_POINT_2F
	Local markSide, hideLine As Long
	Local x, delta, markCount, markSize, ofsTop, ofsBottom As Single

	markSide  = params.markSide
	markSize  = params.markSize
	markCount = params.markCount
	hideLine  = params.hideLine

	If hideLine=0 Then
		' Registration line
		pa.x = -.5
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		pa.x = .5
		sink.AddLine( pa )
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If

	delta = 1! / markCount
	If (markSide And %ReticleMarks.Top)<>0 Then ofsTop = -markSize
	If (markSide And %ReticleMarks.Bottom)<>0 Then ofsBottom = markSize

	For x = -.5 To .5+.001 Step delta
		pa.x = x
		pa.y = ofsTop
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		pa.y = ofsBottom
		sink.AddLine( pa )
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	Next
End Sub

Sub MailReadFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.4623245 * fSize.width
	pa.y = center.y + -.106838 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.4617618 * fSize.width
	pa.y = center.y + -.106838 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.243679 * fSize.width
	pa.y = center.y +  .1069012 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -7.506254E-4 * fSize.width
	pa.y = center.y +  .3451674 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2422569 * fSize.width
	pa.y = center.y +  .1069012 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4603082 * fSize.width
	pa.y = center.y + -.106838 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4623245 * fSize.width
	pa.y = center.y + -.106838 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4623245 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4623245 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -7.034307E-5 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2035542 * fSize.width
	pa.y = center.y + -.321827 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4073038 * fSize.width
	pa.y = center.y + -.1434977 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2036011 * fSize.width
	pa.y = center.y +  3.389379E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.346368E-5 * fSize.width
	pa.y = center.y +  .211129 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.203648 * fSize.width
	pa.y = center.y +  3.389379E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.407382 * fSize.width
	pa.y = center.y + -.1434977 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2036793 * fSize.width
	pa.y = center.y + -.321827 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function MailReadPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	MailReadFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Type PuzzleSideParams_internal
	vflip As Long
	hrotate As Long
	hflip As Long
	flat As Long
End Type

Sub PuzzlePieceFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal leftOut As Long, ByVal topOut As Long, ByVal rightOut As Long, ByVal bottomOut As Long, Optional ByVal isHollow As Long, _
											Optional ByVal center As D2D1_POINT_2F, Optional ByVal sideSize As D2D1_SIZE_F )
	Local pa As D2D1_POINT_2F
	Local param As PuzzleSideParams_internal
	Local x, y, w, h As Single
	x = center.x
	y = center.y
	w = sideSize.width
	h = sideSize.height

	If w=0! Then w=1!
	If h=0! Then h=1!
	x -= w*.5
	y -= h*.5
	pa.x = x
	pa.y = y

	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	'Top
	param.vflip    = IIf&(topOut,   0,1)
	param.hrotate  = 0
	param.hflip    = 0
	param.flat     = IIf&(topOut<0   ,1,0)
	Call PuzzleSideAdd_internal_c2d( sink, x,   y,   w,    h/4!, param )

	'Right
	param.vflip    = IIf&(rightOut, 1,0)
	param.hrotate  = 1
	param.hflip    = 0
	param.flat     = IIf&(rightOut<0 ,1,0)
	Call PuzzleSideAdd_internal_c2d( sink, x+w, y,   w/4!, h,    param )

	'Bottom
	param.vflip    = IIf&(bottomOut,1,0)
	param.hrotate  = 0
	param.hflip    = 1
	param.flat     = IIf&(bottomOut<0,1,0)
	Call PuzzleSideAdd_internal_c2d( sink, x,   y+h, w,    h/4!, param )

	'Left
	param.vflip    = IIf&(leftOut,  0,1)
	param.hrotate  = 1
	param.hflip    = 1
	param.flat     = IIf&(leftOut<0  ,1,0)
	Call PuzzleSideAdd_internal_c2d( sink, x,   y,   w/4!, h,    param )

	If isHollow Then
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	Else
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	End If
End Sub

Sub PuzzleSideAdd_internal_c2d( sink As ID2D1GeometrySink, ByVal tx As Single, ByVal ty As Single, ByVal w As Single, ByVal h As Single, param As PuzzleSideParams_internal )
	Local bez As D2D1_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F
	Dim puzzlePts(37) As Single
	Local i As Long

	If param.flat Then
		Local x1 As Single, x2 As Single, y1 As Single, y2 As Single
		If IsFalse param.hrotate And IsFalse param.hflip Then
			'Top
			pa.x = tx+w
			pa.y = ty
			sink.AddLine( pa )
		ElseIf IsFalse param.hrotate And IsTrue param.hflip Then
			'Bottom
			pa.x = tx
			pa.y = ty
			sink.AddLine( pa )
		ElseIf IsTrue param.hrotate And IsFalse param.hflip Then
			' Right
			pa.x = tx
			pa.y = ty+h
			sink.AddLine( pa )
		ElseIf IsTrue param.hrotate And IsTrue param.hflip Then
			' Left
			pa.x = tx
			pa.y = ty
			sink.AddLine( pa )
		End If
		Exit Sub
	End If

	Array Assign puzzlePts() =0.000!, 0.571!, _
														0.350!, 1.000!, _
														0.370!, 0.714!, _
														0.370!, 0.714!, _
														0.400!, 0.571!, _
														0.380!, 0.429!, _
														0.380!, 0.429!, _
														0.200!, 0.000!, _
														0.500!, 0.000!, _
														0.500!, 0.000!, _
														0.800!, 0.000!, _
														0.620!, 0.429!, _
														0.620!, 0.429!, _
														0.600!, 0.571!, _
														0.630!, 0.714!, _
														0.630!, 0.714!, _
														0.650!, 1.000!, _
														1.000!, 0.571!, _
														1.000!, 0.571!

	For i=0 To 36 Step 2
		' Flip and rotate
		If param.vflip Then puzzlePts(i+1) = 1.0!-puzzlePts(i+1): ' Vertical flip
		If param.hflip Then puzzlePts(i) = 1.0!-puzzlePts(i):   ' Horizontal flip
		If param.hrotate Then Swap puzzlePts(i), puzzlePts(i+1):  ' Rotate 90

		' Move to 0,0 ->1,0
		Local amt As Single
		amt = 0.571!
		If param.hrotate Then
			If param.vflip Then amt = 0.429
			puzzlePts(i) -= amt
		Else
			If param.vflip Then amt = 0.429
			puzzlePts(i+1) -= amt
		End If

		' Scale
		puzzlePts(i)   *= CSng(w)
		puzzlePts(i+1) *= CSng(h)

		' Translate into position
		puzzlePts(i)   += tx
		puzzlePts(i+1) += ty
	Next

	' (0,1) should have been the ending point of the last side (or the starting point)
	For i = 2 To 36 Step 6
		bez.point1.x = puzzlePts(i+0)
		bez.point1.y = puzzlePts(i+1)
		bez.point2.x = puzzlePts(i+2)
		bez.point2.y = puzzlePts(i+3)
		bez.point3.x = puzzlePts(i+4)
		bez.point3.y = puzzlePts(i+5)
		sink.AddBezier( bez )
	Next
End Sub

Sub PulseFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.0457247 * fSize.width
	pa.y = center.y + -.3668437 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x + -4.511861E-2 * fSize.width
	bez.point1.y = center.y + -.3668435 * fSize.height
	bez.point2.x = center.x + -4.450685E-2 * fSize.width
	bez.point2.y = center.y + -.3668161 * fSize.height
	bez.point3.x = center.x + -4.389064E-2 * fSize.width
	bez.point3.y = center.y + -.3667604 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -3.420314E-2 * fSize.width
	bez.point1.y = center.y + -.3660104 * fSize.height
	bez.point2.x = center.x + -2.637502E-2 * fSize.width
	bez.point2.y = center.y + -.3585575 * fSize.height
	bez.point3.x = center.x + -2.512503E-2 * fSize.width
	bez.point3.y = center.y + -.3489016 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -2.213061E-2 * fSize.width
	pa.y = center.y + -.325417 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.122339E-2 * fSize.width
	pa.y = center.y + -.2398741 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .0446406 * fSize.width
	pa.y = center.y +  .1982547 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1033125 * fSize.width
	pa.y = center.y + -.188078 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1046718 * fSize.width
	bez.point1.y = center.y + -.1970465 * fSize.height
	bez.point2.x = center.x +  .1117812 * fSize.width
	bez.point2.y = center.y + -.2040619 * fSize.height
	bez.point3.x = center.x +  .12075 * fSize.width
	bez.point3.y = center.y + -.2052963 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .12975 * fSize.width
	bez.point1.y = center.y + -.2065306 * fSize.height
	bez.point2.x = center.x +  .1385312 * fSize.width
	bez.point2.y = center.y + -.201687 * fSize.height
	bez.point3.x = center.x +  .14225 * fSize.width
	bez.point3.y = center.y + -.1934216 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1956875 * fSize.width
	pa.y = center.y + -7.489374E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4795156 * fSize.width
	pa.y = center.y + -7.489374E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .4908281 * fSize.width
	bez.point1.y = center.y + -7.489374E-2 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y + -6.570649E-2 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y + -5.440995E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y + -4.308215E-2 * fSize.height
	bez.point2.x = center.x +  .4908281 * fSize.width
	bez.point2.y = center.y + -3.391051E-2 * fSize.height
	bez.point3.x = center.x +  .4795156 * fSize.width
	bez.point3.y = center.y + -3.391051E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1824687 * fSize.width
	pa.y = center.y + -3.391051E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1744218 * fSize.width
	bez.point1.y = center.y + -3.391051E-2 * fSize.height
	bez.point2.x = center.x +  .1671094 * fSize.width
	bez.point2.y = center.y + -3.864476E-2 * fSize.height
	bez.point3.x = center.x +  .1637656 * fSize.width
	bez.point3.y = center.y + -4.597268E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1334062 * fSize.width
	pa.y = center.y + -.1133301 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  6.314062E-2 * fSize.width
	pa.y = center.y +  .3494223 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  6.162498E-2 * fSize.width
	bez.point1.y = center.y +  .3594376 * fSize.height
	bez.point2.x = center.x +  5.301561E-2 * fSize.width
	bez.point2.y = center.y +  .3668437 * fSize.height
	bez.point3.x = center.x +  4.290624E-2 * fSize.width
	bez.point3.y = center.y +  .3668437 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  4.265623E-2 * fSize.width
	pa.y = center.y +  .3668437 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  3.242186E-2 * fSize.width
	bez.point1.y = center.y +  .3667187 * fSize.height
	bez.point2.x = center.x +  2.387498E-2 * fSize.width
	bez.point2.y = center.y +  .3590783 * fSize.height
	bez.point3.x = center.x +  .0225781 * fSize.width
	bez.point3.y = center.y +  .3489379 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.0531719 * fSize.width
	pa.y = center.y + -.2450139 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1909375 * fSize.width
	pa.y = center.y +  .2354724 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1935625 * fSize.width
	bez.point1.y = center.y +  .2446597 * fSize.height
	bez.point2.x = center.x + -.2020312 * fSize.width
	bez.point2.y = center.y +  .2506908 * fSize.height
	bez.point3.x = center.x + -.2117813 * fSize.width
	bez.point3.y = center.y +  .2502845 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2213125 * fSize.width
	bez.point1.y = center.y +  .2497533 * fSize.height
	bez.point2.x = center.x + -.2292344 * fSize.width
	bez.point2.y = center.y +  .2426753 * fSize.height
	bez.point3.x = center.x + -.2308281 * fSize.width
	bez.point3.y = center.y +  .2332537 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2865938 * fSize.width
	pa.y = center.y + -9.701809E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3316875 * fSize.width
	pa.y = center.y + -2.083302E-3 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3350625 * fSize.width
	bez.point1.y = center.y +  5.057111E-3 * fSize.height
	bez.point2.x = center.x + -.3422656 * fSize.width
	bez.point2.y = center.y +  9.619489E-3 * fSize.height
	bez.point3.x = center.x + -.3501875 * fSize.width
	bez.point3.y = center.y +  9.619489E-3 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.4795157 * fSize.width
	pa.y = center.y +  9.619489E-3 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.4908125 * fSize.width
	bez.point1.y = center.y +  9.619489E-3 * fSize.height
	bez.point2.x = center.x + -.5 * fSize.width
	bez.point2.y = center.y +  4.322529E-4 * fSize.height
	bez.point3.x = center.x + -.5 * fSize.width
	bez.point3.y = center.y + -1.086432E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.5 * fSize.width
	bez.point1.y = center.y + -2.219212E-2 * fSize.height
	bez.point2.x = center.x + -.4908125 * fSize.width
	bez.point2.y = center.y + -3.134811E-2 * fSize.height
	bez.point3.x = center.x + -.4795157 * fSize.width
	bez.point3.y = center.y + -3.134811E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3631562 * fSize.width
	pa.y = center.y + -3.134811E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2957031 * fSize.width
	pa.y = center.y + -.1733128 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.291875 * fSize.width
	bez.point1.y = center.y + -.1813907 * fSize.height
	bez.point2.x = center.x + -.2832813 * fSize.width
	bez.point2.y = center.y + -.1860312 * fSize.height
	bez.point3.x = center.x + -.2743906 * fSize.width
	bez.point3.y = center.y + -.1848125 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2655313 * fSize.width
	bez.point1.y = center.y + -.1835625 * fSize.height
	bez.point2.x = center.x + -.2584688 * fSize.width
	bez.point2.y = center.y + -.1767346 * fSize.height
	bez.point3.x = center.x + -.257 * fSize.width
	bez.point3.y = center.y + -.1679223 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2054532 * fSize.width
	pa.y = center.y +  .137444 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.512502E-2 * fSize.width
	pa.y = center.y + -.351964 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -6.263478E-2 * fSize.width
	bez.point1.y = center.y + -.3607235 * fSize.height
	bez.point2.x = center.x + -5.481618E-2 * fSize.width
	bez.point2.y = center.y + -.3668464 * fSize.height
	bez.point3.x = center.x + -.0457247 * fSize.width
	bez.point3.y = center.y + -.3668437 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function PulsePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PulseFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub PolygonFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal sides As Long, Optional ByVal rotationDegrees As Single, Optional ByVal roundness As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal radius As Single, Optional ByVal isHollow As _
Long )
	Local pa, pb, pc, pd As D2D1_POINT_2F
	Local angle, angleStep As Single
	Local i As Long
	Local params As SmoothLineParams

	If radius <=0! Then radius = .5!

	sides = Max( 3, sides ): ' Minimimum polygon has 3 sides!
	angle = DegreesToRadians( rotationDegrees + 90! )
	angleStep = DegreesToRadians( 360! / sides )

	If roundness>0 Then
		params.pctSide = roundness
		params.softness = .25

		pb.x = center.x + Sin(angle) * radius
		pb.y = center.x + Cos(angle) * radius
		pc.x = center.x + Sin(angle+angleStep) * radius
		pc.y = center.x + Cos(angle+angleStep) * radius

		pa.x = (pb.x+pc.x)/2
		pa.y = (pb.y+pc.y)/2
	Else
		pa.x = center.x + Sin(angle) * radius
		pa.y = center.y + Cos(angle) * radius
	End If

	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	For i=1 To sides
		angle += angleStep
		If roundness>0! Then
			pa.x = center.x + Sin(angle-angleStep) * radius
			pa.y = center.y + Cos(angle-angleStep) * radius
			pb.x = center.x + Sin(angle) * radius
			pb.y = center.y + Cos(angle) * radius
			pc.x = center.x + Sin(angle+angleStep) * radius
			pc.y = center.y + Cos(angle+angleStep) * radius
			LinesSmoothJoinStroke_c2d sink, pa, pb, pc, params
		Else
			pa.x = center.x + Sin(angle) * radius
			pa.y = center.y + Cos(angle) * radius
			sink.AddLine( pa )
		End If
	Next

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub PlusFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal scaleFigure As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long )
	Local pa As D2D1_POINT_2F

	If scaleFigure = 0 Then scaleFigure = 1!
	'
	'     3--4
	'     |  |
	'  1--2  5--6
	'  |        |
	'  C--B  8--7
	'     |  |
	'     A--9

	' 1
	pa.x = center.x + -.495 * scaleFigure
	pa.y = center.y + -.165 * scaleFigure
	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	' 2
	pa.x = center.x + -.165 * scaleFigure
	pa.y = center.y + -.165 * scaleFigure
	sink.AddLine( pa )

	' 3
	pa.x = center.x + -.165 * scaleFigure
	pa.y = center.y + -.495 * scaleFigure
	sink.AddLine( pa )

	' 4
	pa.x = center.x +  .165 * scaleFigure
	pa.y = center.y + -.495 * scaleFigure
	sink.AddLine( pa )

	' 5
	pa.x = center.x +  .165 * scaleFigure
	pa.y = center.y + -.165 * scaleFigure
	sink.AddLine( pa )

	' 6
	pa.x = center.x +  .495 * scaleFigure
	pa.y = center.y + -.165 * scaleFigure
	sink.AddLine( pa )

	' 7
	pa.x = center.x +  .495 * scaleFigure
	pa.y = center.y +  .165 * scaleFigure
	sink.AddLine( pa )

	' 8
	pa.x = center.x +  .165 * scaleFigure
	pa.y = center.y +  .165 * scaleFigure
	sink.AddLine( pa )

	' 9
	pa.x = center.x +  .165 * scaleFigure
	pa.y = center.y +  .495 * scaleFigure
	sink.AddLine( pa )

	' A
	pa.x = center.x + -.165 * scaleFigure
	pa.y = center.y +  .495 * scaleFigure
	sink.AddLine( pa )

	' B
	pa.x = center.x + -.165 * scaleFigure
	pa.y = center.y +  .165 * scaleFigure
	sink.AddLine( pa )

	' C
	pa.x = center.x + -.495 * scaleFigure
	pa.y = center.y +  .165 * scaleFigure
	sink.AddLine( pa )

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub PinFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .2011212 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y + -.1898527 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4120626 * fSize.width
	pa.y = center.y + -9.859974E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3529035 * fSize.width
	pa.y = center.y + -.1599374 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  8.655801E-2 * fSize.width
	pa.y = center.y +  .1164029 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  9.991525E-2 * fSize.width
	pa.y = center.y +  .130266 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .0840717 * fSize.width
	pa.y = center.y +  .3334954 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.119687E-2 * fSize.width
	pa.y = center.y +  .182751 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.5 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.154339 * fSize.width
	pa.y = center.y +  8.609778E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2985293 * fSize.width
	pa.y = center.y + -6.343025E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.102588 * fSize.width
	pa.y = center.y + -7.982268E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -9.396218E-2 * fSize.width
	pa.y = center.y + -7.097001E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.192959E-2 * fSize.width
	pa.y = center.y + -.1042216 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.192959E-2 * fSize.width
	pa.y = center.y + -.1088657 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -5.745502E-2 * fSize.width
	pa.y = center.y + -.1088657 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .172292 * fSize.width
	pa.y = center.y + -.3473585 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1131825 * fSize.width
	pa.y = center.y + -.4087456 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function PinPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PinFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub ManFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

If fSize.width = 0! Then fSize.width = 1!
If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -8.043661E-3 * fSize.width
	pa.y = center.y +  .1159684 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  4.551947E-2 * fSize.width
	pa.y = center.y +  .1695706 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.898494E-3 * fSize.width
	pa.y = center.y +  .2111928 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .0468558 * fSize.width
	pa.y = center.y +  .2609652 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -9.984924E-3 * fSize.width
	pa.y = center.y +  .43131 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.854417E-2 * fSize.width
	pa.y = center.y +  .2629246 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.060859E-2 * fSize.width
	pa.y = center.y +  .2105795 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -6.164752E-2 * fSize.width
	pa.y = center.y +  .1695706 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .2179213 * fSize.width
	pa.y = center.y +  .110193 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .3495819 * fSize.width
	bez.point1.y = center.y +  .1349368 * fSize.height
	bez.point2.x = center.x +  .4492428 * fSize.width
	bez.point2.y = center.y +  .2504364 * fSize.height
	bez.point3.x = center.x +  .4492428 * fSize.width
	bez.point3.y = center.y +  .3892575 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .4492428 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4492428 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4492428 * fSize.width
	pa.y = center.y +  .3892575 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.4492428 * fSize.width
	bez.point1.y = center.y +  .251636 * fSize.height
	bez.point2.x = center.x + -.3513231 * fSize.width
	bez.point2.y = center.y +  .1368537 * fSize.height
	bez.point3.x = center.x + -.221362 * fSize.width
	bez.point3.y = center.y +  .1108135 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -1.171975E-2 * fSize.width
	pa.y = center.y +  .4394394 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -7.769717E-2 * fSize.width
	pa.y = center.y + -.3684043 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x + -.1056969 * fSize.width
	bez.point1.y = center.y + -.3684745 * fSize.height
	bez.point2.x = center.x + -.1409987 * fSize.width
	bez.point2.y = center.y + -.3612668 * fSize.height
	bez.point3.x = center.x + -.1451367 * fSize.width
	bez.point3.y = center.y + -.325357 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1451367 * fSize.width
	bez.point1.y = center.y + -.325357 * fSize.height
	bez.point2.x = center.x + -.1451367 * fSize.width
	bez.point2.y = center.y + -.2555825 * fSize.height
	bez.point3.x = center.x + -.1637598 * fSize.width
	bez.point3.y = center.y + -.2462704 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1683822 * fSize.width
	pa.y = center.y + -.1811512 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1870067 * fSize.width
	pa.y = center.y + -.1997597 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1800401 * fSize.width
	pa.y = center.y + -.1113767 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1451367 * fSize.width
	pa.y = center.y + -.1090298 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1451367 * fSize.width
	bez.point1.y = center.y + -.1090298 * fSize.height
	bez.point2.x = center.x + -.1358231 * fSize.width
	bez.point2.y = center.y +  7.004469E-2 * fSize.height
	bez.point3.x = center.x +  .0339758 * fSize.width
	bez.point3.y = center.y +  3.517463E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .0339758 * fSize.width
	bez.point1.y = center.y +  3.517463E-2 * fSize.height
	bez.point2.x = center.x +  .1153755 * fSize.width
	bez.point2.y = center.y +  9.582329E-3 * fSize.height
	bez.point3.x = center.x +  .1339655 * fSize.width
	bez.point3.y = center.y + -.1090298 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1619035 * fSize.width
	pa.y = center.y + -.1113767 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1688702 * fSize.width
	pa.y = center.y + -.1904634 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1572468 * fSize.width
	pa.y = center.y + -.1881192 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1572468 * fSize.width
	bez.point1.y = center.y + -.1881192 * fSize.height
	bez.point2.x = center.x +  .1502457 * fSize.width
	bez.point2.y = center.y + -.2555825 * fSize.height
	bez.point3.x = center.x +  .1432791 * fSize.width
	bez.point3.y = center.y + -.2834846 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1386223 * fSize.width
	pa.y = center.y + -.3509334 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1386223 * fSize.width
	bez.point1.y = center.y + -.3509334 * fSize.height
	bez.point2.x = center.x +  9.909528E-2 * fSize.width
	bez.point2.y = center.y + -.3835082 * fSize.height
	bez.point3.x = center.x +  4.094376E-2 * fSize.width
	bez.point3.y = center.y + -.3555889 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  4.094376E-2 * fSize.width
	bez.point1.y = center.y + -.3555889 * fSize.height
	bez.point2.x = center.x + -2.652125E-2 * fSize.width
	bez.point2.y = center.y + -.3579332 * fSize.height
	bez.point3.x = center.x + -4.280013E-2 * fSize.width
	bez.point3.y = center.y + -.3649011 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -4.280013E-2 * fSize.width
	bez.point1.y = center.y + -.3649011 * fSize.height
	bez.point2.x = center.x + -5.853946E-2 * fSize.width
	bez.point2.y = center.y + -.3683562 * fSize.height
	bez.point3.x = center.x + -7.769717E-2 * fSize.width
	bez.point3.y = center.y + -.3684043 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  1.904438E-3 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  8.119932E-2 * fSize.width
	bez.point1.y = center.y + -.5000067 * fSize.height
	bez.point2.x = center.x +  .1363063 * fSize.width
	bez.point2.y = center.y + -.4579486 * fSize.height
	bez.point3.x = center.x +  .1363063 * fSize.width
	bez.point3.y = center.y + -.4579486 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2386418 * fSize.width
	bez.point1.y = center.y + -.3765344 * fSize.height
	bez.point2.x = center.x +  .1828352 * fSize.width
	bez.point2.y = center.y + -.2369692 * fSize.height
	bez.point3.x = center.x +  .1828352 * fSize.width
	bez.point3.y = center.y + -.2369692 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2060818 * fSize.width
	bez.point1.y = center.y + -.2230189 * fSize.height
	bez.point2.x = center.x +  .2037719 * fSize.width
	bez.point2.y = center.y + -.2113958 * fSize.height
	bez.point3.x = center.x +  .2037719 * fSize.width
	bez.point3.y = center.y + -.2113958 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2037719 * fSize.width
	bez.point1.y = center.y + -6.018892E-2 * fSize.height
	bez.point2.x = center.x +  .1618998 * fSize.width
	bez.point2.y = center.y + -7.183056E-2 * fSize.height
	bez.point3.x = center.x +  .1618998 * fSize.width
	bez.point3.y = center.y + -7.183056E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1386188 * fSize.width
	bez.point1.y = center.y +  2.586294E-2 * fSize.height
	bez.point2.x = center.x +  4.794234E-2 * fSize.width
	bez.point2.y = center.y +  7.004439E-2 * fSize.height
	bez.point3.x = center.x +  4.794234E-2 * fSize.width
	bez.point3.y = center.y +  7.004439E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1288571 * fSize.width
	bez.point1.y = center.y +  .1142445 * fSize.height
	bez.point2.x = center.x + -.1730378 * fSize.width
	bez.point2.y = center.y + -6.950226E-2 * fSize.height
	bez.point3.x = center.x + -.1730378 * fSize.width
	bez.point3.y = center.y + -6.950226E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2102545 * fSize.width
	bez.point1.y = center.y + -7.415762E-2 * fSize.height
	bez.point2.x = center.x + -.2149099 * fSize.width
	bez.point2.y = center.y + -.1602121 * fSize.height
	bez.point3.x = center.x + -.2149099 * fSize.width
	bez.point3.y = center.y + -.1602121 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.226569 * fSize.width
	bez.point1.y = center.y + -.2183623 * fSize.height
	bez.point2.x = center.x + -.1939745 * fSize.width
	bez.point2.y = center.y + -.2416258 * fSize.height
	bez.point3.x = center.x + -.1939745 * fSize.width
	bez.point3.y = center.y + -.2416258 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2637831 * fSize.width
	bez.point1.y = center.y + -.404436 * fSize.height
	bez.point2.x = center.x + -.1381679 * fSize.width
	bez.point2.y = center.y + -.4532747 * fSize.height
	bez.point3.x = center.x + -.1381679 * fSize.width
	bez.point3.y = center.y + -.4532747 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -8.780301E-2 * fSize.width
	bez.point1.y = center.y + -.4884515 * fSize.height
	bez.point2.x = center.x + -3.963097E-2 * fSize.width
	bez.point2.y = center.y + -.4999965 * fSize.height
	bez.point3.x = center.x +  1.904438E-3 * fSize.width
	bez.point3.y = center.y + -.5 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function ManPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ManFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub LineFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal p1 As D2D1_POINT_2F, ByVal p2 As D2D1_POINT_2F )
	sink.BeginFigure( p1, %D2D1_FIGURE_BEGIN_HOLLOW )
	sink.AddLine( p2 )
	sink.EndFigure( %D2D1_FIGURE_END_OPEN )
End Sub

Function PillBodyLength_c2d( Optional ByVal thickness As Single, Optional ByVal scalePill As Single ) As Single
	If scalePill = 0! Then scalePill! = 1!
	thickness = Min( 1!, thickness )
	If thickness=0! Then thickness   = 0.4!
	Function = (1!-thickness) * scalePill
End Function

Function PillCapSize_c2d( Optional ByVal thickness As Single, Optional ByVal scalePill As Single ) As Single
	If scalePill = 0! Then scalePill! = 1!
	thickness = Min( 1!, thickness )
	If thickness=0!   Then thickness   = 0.4!
	Function = (thickness / 2!) * scalePill
End Function

Sub PillFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal thickness As Single, Optional ByVal scalePill As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long )
	Local tl, tr, bl, br As D2D1_POINT_2F
	Local h, w, cap As Single
	Local dot As D2D1_ARC_SEGMENT

	h = Min( 1!, thickness )

	If scalePill = 0! Then scalePill! = 1!

	If h=0!   Then h   = 0.4! * scalePill Else h *= scalePill
	If w=0!   Then w   = PillBodyLength_c2d( thickness, scalePill ) Else w *= scalePill
	If cap=0! Then cap = PillCapSize_c2d( thickness, scalePill ) Else h *= scalePill

	' Get 4 corners
	tl.x = center.x-w/2!
	tl.y = center.y-h/2!

	tr.x = tl.x + w
	tr.y = tl.y

	bl.x = tl.x
	bl.y = tl.y + h

	br.x = tr.x
	br.y = bl.y

	If isHollow Then
		sink.BeginFigure( bl, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( bl, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	dot.point            = tl
	dot.size.width       = cap
	dot.size.height      = cap
	dot.rotationAngle    = 0
	dot.sweepDirection   = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	dot.arcSize          = %D2D1_ARC_SIZE_SMALL
	sink.AddArc( dot )

	sink.AddLine( tr )

	dot.point            = br
	dot.size.width       = cap
	dot.size.height      = cap
	dot.rotationAngle    = 0
	dot.sweepDirection   = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	dot.arcSize          = %D2D1_ARC_SIZE_SMALL
	sink.AddArc( dot )

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub PieFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	startAngle = DegreesToRadians( startAngle  )
	endAngle = DegreesToRadians( endAngle )
	PieRadianFigureAdd_c2d sink, startAngle, endAngle, startRadius, endRadius, center
End Sub

Sub PieRadianFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	Local pa As D2D1_POINT_2F

	startRadius = Max( 0!, Min( .5!, startRadius ) )
	endRadius = Max( 0!, Min( .5!, endRadius ) )
	If startRadius = 0! Then startRadius = .5!
	If endRadius = 0! Then endRadius = startRadius

	sink.BeginFigure( center, %D2D1_FIGURE_BEGIN_FILLED )

	pa.x = center.x + Sin( startAngle + 1.570796326794897! ) * startRadius
	pa.y = center.y + Cos( startAngle + 1.570796326794897! ) * startRadius
	sink.AddLine( pa )

	ArcRadiansStroke_c2d sink, startAngle, endAngle, startRadius, endRadius, center

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub NeedleThinFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long )
	Local params As NeedlePathParams

	params.rotateDegrees  = angle

	params.baseRadius     = baseRadius
	params.baseWidth      = .05 * (1-params.baseRadius)

	params.tipType        = IIf&( isSoft,%NeedleTipType.Soft, %NeedleTipType.Sharp )
	params.tipRadius      = .5
	params.tipWidth       = .025
	params.tipLength      = .0125

	NeedleFigureAdd_c2d sink, params
End Sub

Sub NeedleMidFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long )
	Local params As NeedlePathParams

	params.rotateDegrees  = angle

	params.baseRadius     = baseRadius
	params.baseWidth      = .1 * (1-params.baseRadius)

	params.tipType        = IIf&( isSoft,%NeedleTipType.Soft, %NeedleTipType.Sharp )
	params.tipRadius      = .5
	params.tipWidth       = .05
	params.tipLength      = .025

	NeedleFigureAdd_c2d sink, params
End Sub

Sub NeedleThickFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long )
	Local params As NeedlePathParams

	params.rotateDegrees  = angle

	params.baseRadius     = baseRadius
	params.baseWidth      = .2 * (1-params.baseRadius)

	params.tipType        = IIf&( isSoft,%NeedleTipType.Soft, %NeedleTipType.Sharp )
	params.tipRadius      = .5
	params.tipWidth       = .1
	params.tipLength      = .05

	NeedleFigureAdd_c2d sink, params
End Sub

Sub PaintFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .191342 * fSize.width
	pa.y = center.y + -.1622671 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .191342 * fSize.width
	bez.point1.y = center.y + -.1622671 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y + -.1111184 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y +  .1207707 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y +  .1820403 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y +  .2902658 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y +  .351526 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y +  .5502701 * fSize.height
	bez.point2.x = center.x +  .3111969 * fSize.width
	bez.point2.y = center.y +  .4214025 * fSize.height
	bez.point3.x = center.x +  .3111969 * fSize.width
	bez.point3.y = center.y +  .3042622 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .3111969 * fSize.width
	bez.point1.y = center.y +  .1501029 * fSize.height
	bez.point2.x = center.x +  .4475232 * fSize.width
	bez.point2.y = center.y +  9.411748E-2 * fSize.height
	bez.point3.x = center.x +  .3851071 * fSize.width
	bez.point3.y = center.y +  3.172358E-2 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -9.911714E-2 * fSize.width
	pa.y = center.y + -.4896123 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  4.553692E-2 * fSize.width
	bez.point1.y = center.y + -.4896123 * fSize.height
	bez.point2.x = center.x +  .1275589 * fSize.width
	bez.point2.y = center.y + -.285835 * fSize.height
	bez.point3.x = center.x +  .1325441 * fSize.width
	bez.point3.y = center.y + -.1366548 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1327239 * fSize.width
	pa.y = center.y + -.126036 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1381023 * fSize.width
	pa.y = center.y + -.1206541 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1932996 * fSize.width
	bez.point1.y = center.y + -6.541989E-2 * fSize.height
	bez.point2.x = center.x +  .2662271 * fSize.width
	bez.point2.y = center.y +  7.555482E-3 * fSize.height
	bez.point3.x = center.x +  .2908045 * fSize.width
	bez.point3.y = center.y +  3.214577E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .332197 * fSize.width
	bez.point1.y = center.y +  7.354995E-2 * fSize.height
	bez.point2.x = center.x +  .3038851 * fSize.width
	bez.point2.y = center.y +  .1194923 * fSize.height
	bez.point3.x = center.x +  .2865491 * fSize.width
	bez.point3.y = center.y +  .1368128 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .269213 * fSize.width
	bez.point1.y = center.y +  .1541394 * fSize.height
	bez.point2.x = center.x + -5.652767E-2 * fSize.width
	bez.point2.y = center.y +  .4798674 * fSize.height
	bez.point3.x = center.x + -5.652767E-2 * fSize.width
	bez.point3.y = center.y +  .4798674 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.0927227 * fSize.width
	bez.point1.y = center.y +  .5160676 * fSize.height
	bez.point2.x = center.x + -.2191786 * fSize.width
	bez.point2.y = center.y +  .4482761 * fSize.height
	bez.point3.x = center.x + -.3388651 * fSize.width
	bez.point3.y = center.y +  .3285012 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.4586627 * fSize.width
	bez.point1.y = center.y +  .208764 * fSize.height
	bez.point2.x = center.x + -.5264523 * fSize.width
	bez.point2.y = center.y +  8.231222E-2 * fSize.height
	bez.point3.x = center.x + -.4902573 * fSize.width
	bez.point3.y = center.y +  4.611204E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1451237 * fSize.width
	pa.y = center.y + -.2990186 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1451237 * fSize.width
	bez.point1.y = center.y + -.2990186 * fSize.height
	bez.point2.x = center.x + -.1219951 * fSize.width
	bez.point2.y = center.y + -.3210945 * fSize.height
	bez.point3.x = center.x + -.0905967 * fSize.width
	bez.point3.y = center.y + -.3207699 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.0741499 * fSize.width
	bez.point1.y = center.y + -.3205998 * fSize.height
	bez.point2.x = center.x + -5.543406E-2 * fSize.width
	bez.point2.y = center.y + -.3142835 * fSize.height
	bez.point3.x = center.x + -.0365847 * fSize.width
	bez.point3.y = center.y + -.2954288 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  2.46832E-3 * fSize.width
	pa.y = center.y + -.2562843 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  2.380772E-2 * fSize.width
	bez.point1.y = center.y + -.1889843 * fSize.height
	bez.point2.x = center.x +  .0101463 * fSize.width
	bez.point2.y = center.y + -.1315301 * fSize.height
	bez.point3.x = center.x +  1.757731E-4 * fSize.width
	bez.point3.y = center.y + -.1021277 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -1.876276E-2 * fSize.width
	bez.point1.y = center.y + -9.016513E-2 * fSize.height
	bez.point2.x = center.x + -3.143413E-2 * fSize.width
	bez.point2.y = center.y + -6.917804E-2 * fSize.height
	bez.point3.x = center.x + -3.143413E-2 * fSize.width
	bez.point3.y = center.y + -4.509115E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -3.143413E-2 * fSize.width
	bez.point1.y = center.y + -7.796469E-3 * fSize.height
	bez.point2.x = center.x + -1.190971E-3 * fSize.width
	bez.point2.y = center.y +  2.247586E-2 * fSize.height
	bez.point3.x = center.x +  3.616664E-2 * fSize.width
	bez.point3.y = center.y +  2.247586E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  7.353956E-2 * fSize.width
	bez.point1.y = center.y +  2.247586E-2 * fSize.height
	bez.point2.x = center.x +  .1037827 * fSize.width
	bez.point2.y = center.y + -7.796469E-3 * fSize.height
	bez.point3.x = center.x +  .1037827 * fSize.width
	bez.point3.y = center.y + -4.509115E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1037827 * fSize.width
	bez.point1.y = center.y + -6.864571E-2 * fSize.height
	bez.point2.x = center.x +  .0917075 * fSize.width
	bez.point2.y = center.y + -8.932818E-2 * fSize.height
	bez.point3.x = center.x +  7.346096E-2 * fSize.width
	bez.point3.y = center.y + -.1014116 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  7.542384E-2 * fSize.width
	bez.point1.y = center.y + -.1174115 * fSize.height
	bez.point2.x = center.x +  7.664866E-2 * fSize.width
	bez.point2.y = center.y + -.1495728 * fSize.height
	bez.point3.x = center.x +  7.086935E-2 * fSize.width
	bez.point3.y = center.y + -.1879322 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  7.086935E-2 * fSize.width
	bez.point1.y = center.y + -.1879322 * fSize.height
	bez.point2.x = center.x +  7.823595E-2 * fSize.width
	bez.point2.y = center.y + -.1805606 * fSize.height
	bez.point3.x = center.x +  9.032334E-2 * fSize.width
	bez.point3.y = center.y + -.168465 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .0915369 * fSize.width
	pa.y = center.y + -.1672507 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .0906752 * fSize.width
	pa.y = center.y + -.1749783 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  7.465307E-2 * fSize.width
	bez.point1.y = center.y + -.3019726 * fSize.height
	bez.point2.x = center.x +  4.112819E-3 * fSize.width
	bez.point2.y = center.y + -.450959 * fSize.height
	bez.point3.x = center.x + -9.911714E-2 * fSize.width
	bez.point3.y = center.y + -.450959 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2253382 * fSize.width
	bez.point1.y = center.y + -.450959 * fSize.height
	bez.point2.x = center.x + -.2537294 * fSize.width
	bez.point2.y = center.y + -.3221422 * fSize.height
	bez.point3.x = center.x + -.2537294 * fSize.width
	bez.point3.y = center.y + -.277008 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2923746 * fSize.width
	pa.y = center.y + -.277008 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2923746 * fSize.width
	bez.point1.y = center.y + -.3592024 * fSize.height
	bez.point2.x = center.x + -.2399107 * fSize.width
	bez.point2.y = center.y + -.4896123 * fSize.height
	bez.point3.x = center.x + -9.911714E-2 * fSize.width
	bez.point3.y = center.y + -.4896123 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function PaintPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PaintFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub NeedleFigureAdd_c2d( sink As ID2D1GeometrySink, params As NeedlePathParams )
	Local angle, arcAngle, radius As Single
	Local baseA, baseB, tipA, tipB, tipEnd As D2D1_POINT_2F
	Local bez As D2D1_BEZIER_SEGMENT
	Local dot As D2D1_ARC_SEGMENT

	Local baseOfs, rotation, centerX, centerY, baseRadius, baseWidth, tipRadius, tipWidth, tipLength As Single
	Local baseType, tipType As Long

	centerX    = params.center.x
	centerY    = params.center.y
	rotation   = DegreesToRadians( params.rotateDegrees + 90 )
	baseRadius = params.baseRadius
	baseWidth  = params.baseWidth
	tipType    = params.tipType
	tipRadius  = params.tipRadius
	tipWidth   = params.tipWidth
	tipLength  = params.tipLength

	If tipRadius <= 0 Then tipRadius = .5
	If tipWidth  <= 0 Then tipWidth = .05
	' default base radius 0
	If baseWidth <=0 Then baseWidth = .5


	' Note: this is going from (-.5, 0) to (.5, 1), rotations should be ValueNormal_c2d
	' but just be aware that you're translating the bottom center....

	' Calc 4 points
	If baseRadius = 0 Then
		angle = rotation+1.57079632679!
		radius = baseWidth/2!
		baseA.x = centerX + Sin( angle ) * radius
		baseA.y = centerY + Cos( angle ) * radius
		angle = rotation-1.57079632679!
		baseB.x = centerX + Sin( angle ) * radius
		baseB.y = centerY + Cos( angle ) * radius
	Else
		arcAngle = (baseWidth/2!) / baseRadius
		angle = rotation + arcAngle
		baseA.x = centerX + Sin( angle ) * baseRadius
		baseA.y = centerY + Cos( angle ) * baseRadius

		angle = rotation - arcAngle
		baseB.x = centerX + Sin( angle ) * baseRadius
		baseB.y = centerY + Cos( angle ) * baseRadius
	End If

	arcAngle = (tipWidth/2!) / tipRadius
	angle = rotation + arcAngle
	radius = ( tipRadius - tipLength)
	tipA.x = centerX + Sin( angle ) * radius
	tipA.y = centerY + Cos( angle ) * radius

	angle = rotation - arcAngle
	tipB.x = centerX + Sin( angle ) * radius
	tipB.y = centerY + Cos( angle ) * radius

	angle = rotation
	tipEnd.x = centerX + Sin( angle ) * tipRadius
	tipEnd.y = centerY + Cos( angle ) * tipRadius

	sink.BeginFigure( baseA, %D2D1_FIGURE_BEGIN_FILLED )

	If baseRadius = 0 Then
		radius = baseWidth / 2!
	Else
		radius = Max( params.baseRadius / 2!, baseWidth / 2! )
	End If

	dot.point            = baseB
	dot.size.width       = radius
	dot.size.height      = radius
	dot.rotationAngle    = 0
	dot.sweepDirection   = IIf&( baseRadius = 0, %D2D1_SWEEP_DIRECTION_COUNTER_CLOCKWISE, %D2D1_SWEEP_DIRECTION_CLOCKWISE )
	dot.arcSize          = %D2D1_ARC_SIZE_SMALL
	sink.AddArc( dot )

	sink.AddLine( tipB )

	If params.tipType = %NeedleTipType.Sharp Then
		sink.AddLine( tipEnd )
		sink.AddLine( tipA )
	Else
		Lines2JoinSmoothStroke_c2d sink, baseB, tipB, tipA, baseA, tipLength / (tipRadius-tipLength-baseRadius)* 1.22
	End If

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16VSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	If Not IsObject( localSink ) Then Exit Sub

	segment(0).x =  1: segment(0).y = 0
	segment(1).x = .5: segment(1).y = 0
	segment(2).x =  0: segment(2).y = 0
	segment(3).x =  0: segment(3).y = 1
	segment(4).x = .5: segment(4).y = 1
	segment(5).x =  1: segment(5).y = 1

	For i=0 To 5
		segment(i).x *= segmentThickness
		segment(i).y *= segmentHeight
		segment(i).x += segmentLeft
		segment(i).y += segmentTop
		If i = 0  Then
			segment(i).y += segmentThickness/2!
		ElseIf i=2 Then
			segment(i).y += segmentThickness/2!
		ElseIf i=3 Then
			segment(i).y -= segmentThickness/2!
		ElseIf i=5 Then
			segment(i).y -= segmentThickness/2!
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16RightLeftTopSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	If Not IsObject( localSink ) Then Exit Sub

	segment(0).x =  0: segment(0).y = 1
	segment(1).x =  0: segment(1).y = 1
	segment(2).x =  0: segment(2).y = 1
	segment(3).x =  1: segment(3).y = 0
	segment(4).x =  1: segment(4).y = 0
	segment(5).x =  1: segment(5).y = 0

	For i=0 To 5
		segment(i).x *= segmentWidth * .83
		segment(i).y *= segmentHeight * .88
		segment(i).x += segmentLeft + segmentThickness * .35
		segment(i).y += segmentTop + segmentThickness * .35
		If i=0 Then
			segment(i).x += segmentThickness  * .55
			segment(i).y -= 0
		ElseIf i=1 Then
			segment(i).x += 0
			segment(i).y -= 0
		ElseIf i=2 Then
			segment(i).x += 0
			segment(i).y -= segmentThickness  * 1.2
		ElseIf i=3 Then
			segment(i).x -= segmentThickness  * .85
			segment(i).y += 0
		ElseIf i=4 Then
			segment(i).x -= 0
			segment(i).y += 0
		ElseIf i=5 Then
			segment(i).x -= 0
			segment(i).y += segmentThickness  * .85
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16RightLeftBottomSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	If Not IsObject( localSink ) Then Exit Sub

	segment(0).x =  0: segment(0).y = 1
	segment(1).x =  0: segment(1).y = 1
	segment(2).x =  0: segment(2).y = 1
	segment(3).x =  1: segment(3).y = 0
	segment(4).x =  1: segment(4).y = 0
	segment(5).x =  1: segment(5).y = 0

	For i=0 To 5
		segment(i).x *= segmentWidth * .83
		segment(i).y *= segmentHeight * .88
		segment(i).x += segmentLeft + segmentThickness * .35
		segment(i).y += segmentTop + segmentThickness * .35
		If i=0 Then
			segment(i).x += segmentThickness  * .85
			segment(i).y -= 0
		ElseIf i=1 Then
			segment(i).x += 0
			segment(i).y -= 0
		ElseIf i=2 Then
			segment(i).x += 0
			segment(i).y -= segmentThickness  * .85
		ElseIf i=3 Then
			segment(i).x -= segmentThickness  * .55
			segment(i).y += 0
		ElseIf i=4 Then
			segment(i).x -= 0
			segment(i).y += 0
		ElseIf i=5 Then
			segment(i).x -= 0
			segment(i).y += segmentThickness  * 1.2
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16LeftRightTopSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	If Not IsObject( localSink ) Then Exit Sub

	segment(0).x =  0: segment(0).y = 0
	segment(1).x =  0: segment(1).y = 0
	segment(2).x =  0: segment(2).y = 0
	segment(3).x =  1: segment(3).y = 1
	segment(4).x =  1: segment(4).y = 1
	segment(5).x =  1: segment(5).y = 1

	For i=0 To 5
		segment(i).x *= segmentWidth
		segment(i).y *= segmentHeight
		segment(i).x += segmentLeft
		segment(i).y += segmentTop
		If i = 0 Then
			segment(i).x += 0
			segment(i).y += segmentThickness * .85
		ElseIf i=1 Then
			segment(i).x += 0
			segment(i).y += 0
		ElseIf i=2 Then
			segment(i).x += segmentThickness * .85
			segment(i).y += 0
		ElseIf i=3 Then
			segment(i).x -= 0
			segment(i).y -= segmentThickness * 1.2
		ElseIf i=4 Then
			segment(i).x -= 0
			segment(i).y -= 0
		ElseIf i=5 Then
			segment(i).x -= segmentThickness * .55
			segment(i).y -= 0
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16LeftRightBottomSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	If Not IsObject( localSink ) Then Exit Sub

	segment(0).x =  0: segment(0).y = 0
	segment(1).x =  0: segment(1).y = 0
	segment(2).x =  0: segment(2).y = 0
	segment(3).x =  1: segment(3).y = 1
	segment(4).x =  1: segment(4).y = 1
	segment(5).x =  1: segment(5).y = 1

	For i=0 To 5
		segment(i).x *= segmentWidth
		segment(i).y *= segmentHeight
		segment(i).x += segmentLeft
		segment(i).y += segmentTop
		If i = 0 Then
			segment(i).x += 0
			segment(i).y += segmentThickness * 1.2
		ElseIf i=1 Then
			segment(i).x += 0
			segment(i).y += 0
		ElseIf i=2 Then
			segment(i).x += segmentThickness * .55
			segment(i).y += 0
		ElseIf i=3 Then
			segment(i).x -= 0
			segment(i).y -= segmentThickness * .85
		ElseIf i=4 Then
			segment(i).x -= 0
			segment(i).y -= 0
		ElseIf i=5 Then
			segment(i).x -= segmentThickness * .85
			segment(i).y -= 0
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd16HSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal segmentLeft As Single, ByVal segmentTop As Single, ByVal segmentWidth As Single, ByVal segmentHeight As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local segment() As D2D1_POINT_2F
	ReDim segment(5)

	segment(0).x  = 0: segment(0).y  = 1
	segment(1).x  = 0: segment(1).y  = .5
	segment(2).x  = 0: segment(2).y  = 0
	segment(3).x  = 1: segment(3).y  = 0
	segment(4).x  = 1: segment(4).y  = .5
	segment(5).x  = 1: segment(5).y  = 1

	For i=0 To 5
		segment(i).x *= segmentWidth
		segment(i).y *= segmentThickness
		segment(i).x += segmentLeft
		segment(i).y += segmentTop
		If i = 0  Or i = 2 Then
			segment(i).x += segmentThickness/2
		ElseIf i=3 Or i=5 Then
			segment(i).x -= segmentThickness/2
		End If
	Next
	localSink.BeginFigure( segment(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( segment(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd7VSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal x As Single, ByVal y As Single, ByVal w As Single, ByVal h As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local t As Single
	Local pnts() As D2D1_POINT_2F
	ReDim pnts(5)

	pnts(0).x =  1: pnts(0).y = 0
	pnts(1).x = .5: pnts(1).y = 0
	pnts(2).x =  0: pnts(2).y = 0
	pnts(3).x =  0: pnts(3).y = 1
	pnts(4).x = .5: pnts(4).y = 1
	pnts(5).x =  1: pnts(5).y = 1

	For i=0 To 5
		pnts(i).x *= segmentThickness
		pnts(i).y *= h
		pnts(i).x += x
		pnts(i).y += y
		If i = 0 Or i = 2 Then
			pnts(i).y += segmentThickness/2!
		ElseIf i = 3 Or i = 5 Then
			pnts(i).y -= segmentThickness/2!
		End If
	Next
	localSink.BeginFigure( pnts(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( pnts(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub Lcd7HSegmentFigureAdd_c2d( localSink As ID2D1GeometrySink, ByVal x As Single, ByVal y As Single, ByVal w As Single, ByVal h As Single, ByVal segmentThickness As Single )
	Local i As Long
	Local t As Single
	Local pnts() As D2D1_POINT_2F
	ReDim pnts(5)

	pnts(0).x  = 0: pnts(0).y  = 1
	pnts(1).x  = 0: pnts(1).y  = .5
	pnts(2).x  = 0: pnts(2).y  = 0
	pnts(3).x  = 1: pnts(3).y  = 0
	pnts(4).x  = 1: pnts(4).y  = .5
	pnts(5).x  = 1: pnts(5).y  = 1

	For i=0 To 5
		pnts(i).x *= w
		pnts(i).y *= segmentThickness
		pnts(i).x += x
		pnts(i).y += y
		If i = 0 Or i = 2 Then
			pnts(i).x += segmentThickness/2!
		ElseIf i = 3 Or i = 5 Then
			pnts(i).x -= segmentThickness/2!
		End If
	Next
	localSink.BeginFigure( pnts(0), %D2D1_FIGURE_BEGIN_FILLED )
	localSink.AddLines( pnts(1), 5 )
	localSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub IgnoreFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.3980386 * fSize.width
	pa.y = center.y + -.1282881 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.3980386 * fSize.width
	pa.y = center.y +  .1282881 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .398009 * fSize.width
	pa.y = center.y +  .1282881 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .398009 * fSize.width
	pa.y = center.y + -.1282881 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -7.275936E-7 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .2761458 * fSize.width
	bez.point1.y = center.y + -.5 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y + -.2761429 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y + -7.275936E-7 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y +  .2761502 * fSize.height
	bez.point2.x = center.x +  .2761458 * fSize.width
	bez.point2.y = center.y +  .5 * fSize.height
	bez.point3.x = center.x + -7.275936E-7 * fSize.width
	bez.point3.y = center.y +  .5 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2761458 * fSize.width
	bez.point1.y = center.y +  .5 * fSize.height
	bez.point2.x = center.x + -.5 * fSize.width
	bez.point2.y = center.y +  .2761502 * fSize.height
	bez.point3.x = center.x + -.5 * fSize.width
	bez.point3.y = center.y + -7.275936E-7 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.5 * fSize.width
	bez.point1.y = center.y + -.2761429 * fSize.height
	bez.point2.x = center.x + -.2761458 * fSize.width
	bez.point2.y = center.y + -.5 * fSize.height
	bez.point3.x = center.x + -7.275936E-7 * fSize.width
	bez.point3.y = center.y + -.5 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function IgnorePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	IgnoreFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub HeartFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.2537248 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2353199 * fSize.width
	pa.y = center.y + -.4992537 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2173532 * fSize.width
	pa.y = center.y + -.4970147 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1998247 * fSize.width
	pa.y = center.y + -.493283 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1827344 * fSize.width
	pa.y = center.y + -.4880587 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1660824 * fSize.width
	pa.y = center.y + -.4813417 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1498685 * fSize.width
	pa.y = center.y + -.4731321 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1340929 * fSize.width
	pa.y = center.y + -.4634298 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1187555 * fSize.width
	pa.y = center.y + -.4522349 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -9.114812E-2 * fSize.width
	pa.y = center.y + -.4265721 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.0687993 * fSize.width
	pa.y = center.y + -.3973488 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -5.170903E-2 * fSize.width
	pa.y = center.y + -.3645651 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.0398773 * fSize.width
	pa.y = center.y + -.3282209 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -3.527607E-2 * fSize.width
	pa.y = center.y + -.3120618 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -3.023664E-2 * fSize.width
	pa.y = center.y + -.2986415 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.475898E-2 * fSize.width
	pa.y = center.y + -.2879601 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.884312E-2 * fSize.width
	pa.y = center.y + -.2800175 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.183173E-2 * fSize.width
	pa.y = center.y + -.274759 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -3.067484E-3 * fSize.width
	pa.y = center.y + -.2730061 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  8.326029E-3 * fSize.width
	pa.y = center.y + -.274759 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  1.621385E-2 * fSize.width
	pa.y = center.y + -.2800175 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.256787E-2 * fSize.width
	pa.y = center.y + -.2882888 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.848373E-2 * fSize.width
	pa.y = center.y + -.2990797 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.396144E-2 * fSize.width
	pa.y = center.y + -.3123904 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.900088E-2 * fSize.width
	pa.y = center.y + -.3282209 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  5.211985E-2 * fSize.width
	pa.y = center.y + -.366674 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  6.956612E-2 * fSize.width
	pa.y = center.y + -.4005259 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  9.133978E-2 * fSize.width
	pa.y = center.y + -.4297765 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1174408 * fSize.width
	pa.y = center.y + -.4544259 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1319087 * fSize.width
	pa.y = center.y + -.464902 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1470475 * fSize.width
	pa.y = center.y + -.4739812 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1628574 * fSize.width
	pa.y = center.y + -.4816636 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1793382 * fSize.width
	pa.y = center.y + -.4879492 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1964901 * fSize.width
	pa.y = center.y + -.492838 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2143131 * fSize.width
	pa.y = center.y + -.49633 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .232807 * fSize.width
	pa.y = center.y + -.4984252 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .251972 * fSize.width
	pa.y = center.y + -.4991236 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2742386 * fSize.width
	pa.y = center.y + -.4981239 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2954645 * fSize.width
	pa.y = center.y + -.4951249 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3156496 * fSize.width
	pa.y = center.y + -.4901266 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .334794 * fSize.width
	pa.y = center.y + -.4831288 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3528977 * fSize.width
	pa.y = center.y + -.4741318 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3699606 * fSize.width
	pa.y = center.y + -.4631354 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3859827 * fSize.width
	pa.y = center.y + -.4501397 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4009641 * fSize.width
	pa.y = center.y + -.4351446 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4145212 * fSize.width
	pa.y = center.y + -.4183693 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4262708 * fSize.width
	pa.y = center.y + -.4000329 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4362127 * fSize.width
	pa.y = center.y + -.3801353 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .444347 * fSize.width
	pa.y = center.y + -.3586766 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4506738 * fSize.width
	pa.y = center.y + -.3356568 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4551928 * fSize.width
	pa.y = center.y + -.3110758 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4579042 * fSize.width
	pa.y = center.y + -.2849337 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4588081 * fSize.width
	pa.y = center.y + -.2572305 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4565896 * fSize.width
	pa.y = center.y + -.2183392 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4499343 * fSize.width
	pa.y = center.y + -.1787905 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .438842 * fSize.width
	pa.y = center.y + -.1385846 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4233129 * fSize.width
	pa.y = center.y + -.0977213 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4133093 * fSize.width
	pa.y = center.y + -7.628999E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4010462 * fSize.width
	pa.y = center.y + -5.318799E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3865236 * fSize.width
	pa.y = center.y + -2.841531E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3697415 * fSize.width
	pa.y = center.y + -1.971954E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3506998 * fSize.width
	pa.y = center.y +  2.614209E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3293985 * fSize.width
	pa.y = center.y +  5.592682E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3058378 * fSize.width
	pa.y = center.y +  8.738223E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2800175 * fSize.width
	pa.y = center.y +  .1205083 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2543684 * fSize.width
	pa.y = center.y +  .1528812 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2313212 * fSize.width
	pa.y = center.y +  .1820771 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2108759 * fSize.width
	pa.y = center.y +  .208096 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1930324 * fSize.width
	pa.y = center.y +  .2309378 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1777909 * fSize.width
	pa.y = center.y +  .2506025 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1651512 * fSize.width
	pa.y = center.y +  .2670903 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1551134 * fSize.width
	pa.y = center.y +  .280401 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1476775 * fSize.width
	pa.y = center.y +  .2905346 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.19106E-3 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1511832 * fSize.width
	pa.y = center.y +  .2887818 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1586122 * fSize.width
	pa.y = center.y +  .2784222 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1686295 * fSize.width
	pa.y = center.y +  .2648718 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1812349 * fSize.width
	pa.y = center.y +  .2481308 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1964286 * fSize.width
	pa.y = center.y +  .2281989 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2142104 * fSize.width
	pa.y = center.y +  .2050764 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2345804 * fSize.width
	pa.y = center.y +  .1787632 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2575386 * fSize.width
	pa.y = center.y +  .1492592 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.283085 * fSize.width
	pa.y = center.y +  .1165644 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.308782 * fSize.width
	pa.y = center.y +  8.317813E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3321922 * fSize.width
	pa.y = center.y +  5.159947E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3533154 * fSize.width
	pa.y = center.y +  2.182844E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3721516 * fSize.width
	pa.y = center.y + -6.134969E-3 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.388701 * fSize.width
	pa.y = center.y + -3.229075E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4029634 * fSize.width
	pa.y = center.y + -5.663892E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4149389 * fSize.width
	pa.y = center.y + -7.917945E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4246275 * fSize.width
	pa.y = center.y + -9.991236E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4395815 * fSize.width
	pa.y = center.y + -.1395979 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4502629 * fSize.width
	pa.y = center.y + -.1793383 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4566718 * fSize.width
	pa.y = center.y + -.2191334 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4588081 * fSize.width
	pa.y = center.y + -.2589833 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4571374 * fSize.width
	pa.y = center.y + -.2954371 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4521253 * fSize.width
	pa.y = center.y + -.3294259 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4437719 * fSize.width
	pa.y = center.y + -.3609498 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4320771 * fSize.width
	pa.y = center.y + -.3900088 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4172875 * fSize.width
	pa.y = center.y + -.416055 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3996494 * fSize.width
	pa.y = center.y + -.4385407 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.379163 * fSize.width
	pa.y = center.y + -.457466 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3558282 * fSize.width
	pa.y = center.y + -.4728309 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3308775 * fSize.width
	pa.y = center.y + -.4847174 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3055434 * fSize.width
	pa.y = center.y + -.4932077 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2798258 * fSize.width
	pa.y = center.y + -.4983019 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2537248 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function HeartPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	HeartFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub FingerprintFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

If fSize.width = 0! Then fSize.width = 1!
If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  8.120064E-2 * fSize.width
	pa.y = center.y +  9.897507E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .1373712 * fSize.width
	bez.point1.y = center.y +  .2528852 * fSize.height
	bez.point2.x = center.x +  .356171 * fSize.width
	bez.point2.y = center.y +  .3184846 * fSize.height
	bez.point3.x = center.x +  .3583694 * fSize.width
	bez.point3.y = center.y +  .319133 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3484214 * fSize.width
	pa.y = center.y +  .3532523 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3459997 * fSize.width
	bez.point1.y = center.y +  .352557 * fSize.height
	bez.point2.x = center.x +  .2883854 * fSize.width
	bez.point2.y = center.y +  .3355739 * fSize.height
	bez.point3.x = center.x +  .2225731 * fSize.width
	bez.point3.y = center.y +  .2977093 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1342183 * fSize.width
	bez.point1.y = center.y +  .2468882 * fSize.height
	bez.point2.x = center.x +  7.377759E-2 * fSize.width
	bez.point2.y = center.y +  .1823732 * fSize.height
	bez.point3.x = center.x +  4.779609E-2 * fSize.width
	bez.point3.y = center.y +  .1111596 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  6.210754E-2 * fSize.width
	pa.y = center.y + -1.101738E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  7.119183E-2 * fSize.width
	bez.point1.y = center.y + -1.123394E-2 * fSize.height
	bez.point2.x = center.x +  .0804333 * fSize.width
	bez.point2.y = center.y + -9.816061E-3 * fSize.height
	bez.point3.x = center.x +  8.978724E-2 * fSize.width
	bez.point3.y = center.y + -6.755718E-3 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1541378 * fSize.width
	bez.point1.y = center.y +  1.432481E-2 * fSize.height
	bez.point2.x = center.x +  .2017828 * fSize.width
	bez.point2.y = center.y +  .1098184 * fSize.height
	bez.point3.x = center.x +  .2037765 * fSize.width
	bez.point3.y = center.y +  .1138917 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2045499 * fSize.width
	pa.y = center.y +  .1156995 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2201352 * fSize.width
	bez.point1.y = center.y +  .1588729 * fSize.height
	bez.point2.x = center.x +  .335162 * fSize.width
	bez.point2.y = center.y +  .2075166 * fSize.height
	bez.point3.x = center.x +  .404025 * fSize.width
	bez.point3.y = center.y +  .2280237 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3938738 * fSize.width
	pa.y = center.y +  .2621178 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3739761 * fSize.width
	bez.point1.y = center.y +  .2561758 * fSize.height
	bez.point2.x = center.x +  .1994845 * fSize.width
	bez.point2.y = center.y +  .2023449 * fSize.height
	bez.point3.x = center.x +  .1715122 * fSize.width
	bez.point3.y = center.y +  .128799 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1592032 * fSize.width
	bez.point1.y = center.y +  .1042639 * fSize.height
	bez.point2.x = center.x +  .1198361 * fSize.width
	bez.point2.y = center.y +  4.048484E-2 * fSize.height
	bez.point3.x = center.x +  7.867984E-2 * fSize.width
	bez.point3.y = center.y +  2.704155E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  6.641314E-2 * fSize.width
	bez.point1.y = center.y +  2.302921E-2 * fSize.height
	bez.point2.x = center.x +  5.499954E-2 * fSize.width
	bez.point2.y = center.y +  2.390574E-2 * fSize.height
	bez.point3.x = center.x +  4.383123E-2 * fSize.width
	bez.point3.y = center.y +  2.972741E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  4.252972E-2 * fSize.width
	pa.y = center.y +  3.033833E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  4.234533E-2 * fSize.width
	bez.point1.y = center.y +  3.041331E-2 * fSize.height
	bez.point2.x = center.x +  2.265236E-2 * fSize.width
	bez.point2.y = center.y +  3.904271E-2 * fSize.height
	bez.point3.x = center.x +  8.329472E-3 * fSize.width
	bez.point3.y = center.y +  5.899985E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -1.030572E-2 * fSize.width
	bez.point1.y = center.y +  8.500051E-2 * fSize.height
	bez.point2.x = center.x + -1.179004E-2 * fSize.width
	bez.point2.y = center.y +  .1184244 * fSize.height
	bez.point3.x = center.x +  3.934353E-3 * fSize.width
	bez.point3.y = center.y +  .158362 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  6.132678E-3 * fSize.width
	bez.point1.y = center.y +  .1635118 * fSize.height
	bez.point2.x = center.x +  8.036885E-2 * fSize.width
	bez.point2.y = center.y +  .3316732 * fSize.height
	bez.point3.x = center.x +  .3048663 * fSize.width
	bez.point3.y = center.y +  .3946211 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2952651 * fSize.width
	pa.y = center.y +  .4288605 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1683576 * fSize.width
	bez.point1.y = center.y +  .3932789 * fSize.height
	bez.point2.x = center.x +  8.718265E-2 * fSize.width
	bez.point2.y = center.y +  .3257375 * fSize.height
	bez.point3.x = center.x +  4.142819E-2 * fSize.width
	bez.point3.y = center.y +  .2753392 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -8.494874E-3 * fSize.width
	bez.point1.y = center.y +  .2203724 * fSize.height
	bez.point2.x = center.x + -2.814721E-2 * fSize.width
	bez.point2.y = center.y +  .1738412 * fSize.height
	bez.point3.x = center.x + -2.896282E-2 * fSize.width
	bez.point3.y = center.y +  .1718881 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.0290628 * fSize.width
	pa.y = center.y +  .1715834 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -5.502273E-2 * fSize.width
	bez.point1.y = center.y +  .1058357 * fSize.height
	bez.point2.x = center.x + -3.813744E-2 * fSize.width
	bez.point2.y = center.y +  6.192943E-2 * fSize.height
	bez.point3.x = center.x + -1.940069E-2 * fSize.width
	bez.point3.y = center.y +  .0367006 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -8.654781E-4 * fSize.width
	bez.point1.y = center.y +  1.172334E-2 * fSize.height
	bez.point2.x = center.x +  2.308046E-2 * fSize.width
	bez.point2.y = center.y +  8.000304E-5 * fSize.height
	bez.point3.x = center.x +  2.794279E-2 * fSize.width
	bez.point3.y = center.y + -2.093369E-3 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  3.900778E-2 * fSize.width
	bez.point1.y = center.y + -7.758609E-3 * fSize.height
	bez.point2.x = center.x +  5.042772E-2 * fSize.width
	bez.point2.y = center.y + -1.073891E-2 * fSize.height
	bez.point3.x = center.x +  6.210754E-2 * fSize.width
	bez.point3.y = center.y + -1.101738E-2 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  5.498017E-2 * fSize.width
	pa.y = center.y + -.109799 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  6.798543E-2 * fSize.width
	bez.point1.y = center.y + -.1098858 * fSize.height
	bez.point2.x = center.x +  8.095635E-2 * fSize.width
	bez.point2.y = center.y + -.1085412 * fSize.height
	bez.point3.x = center.x +  9.387016E-2 * fSize.width
	bez.point3.y = center.y + -.1057604 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1856855 * fSize.width
	bez.point1.y = center.y + -8.599978E-2 * fSize.height
	bez.point2.x = center.x +  .2402297 * fSize.width
	bez.point2.y = center.y + -6.137048E-4 * fSize.height
	bez.point3.x = center.x +  .2425094 * fSize.width
	bez.point3.y = center.y +  3.001895E-3 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2434453 * fSize.width
	pa.y = center.y +  4.695587E-3 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2918647 * fSize.width
	bez.point1.y = center.y +  .1041971 * fSize.height
	bez.point2.x = center.x +  .4037608 * fSize.width
	bez.point2.y = center.y +  .1221265 * fSize.height
	bez.point3.x = center.x +  .4049 * fSize.width
	bez.point3.y = center.y +  .1222858 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3997125 * fSize.width
	pa.y = center.y +  .157465 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3943814 * fSize.width
	bez.point1.y = center.y +  .1566868 * fSize.height
	bez.point2.x = center.x +  .2689776 * fSize.width
	bez.point2.y = center.y +  .1371169 * fSize.height
	bez.point3.x = center.x +  .2119522 * fSize.width
	bez.point3.y = center.y +  2.123595E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2069054 * fSize.width
	bez.point1.y = center.y +  1.358453E-2 * fSize.height
	bez.point2.x = center.x +  .1597469 * fSize.width
	bez.point2.y = center.y + -5.522372E-2 * fSize.height
	bez.point3.x = center.x +  8.640309E-2 * fSize.width
	bez.point3.y = center.y + -7.100942E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .044618 * fSize.width
	bez.point1.y = center.y + -8.000457E-2 * fSize.height
	bez.point2.x = center.x +  1.364143E-3 * fSize.width
	bez.point2.y = center.y + -6.997192E-2 * fSize.height
	bez.point3.x = center.x + -4.219279E-2 * fSize.width
	bez.point3.y = center.y + -4.122398E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -4.536928E-2 * fSize.width
	bez.point1.y = center.y + -3.869902E-2 * fSize.height
	bez.point2.x = center.x + -.0708594 * fSize.width
	bez.point2.y = center.y + -1.774936E-2 * fSize.height
	bez.point3.x = center.x + -8.866062E-2 * fSize.width
	bez.point3.y = center.y +  2.148125E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1143554 * fSize.width
	bez.point1.y = center.y +  .07806 * fSize.height
	bez.point2.x = center.x + -.1112024 * fSize.width
	bez.point2.y = center.y +  .1426105 * fSize.height
	bez.point3.x = center.x + -7.930299E-2 * fSize.width
	bez.point3.y = center.y +  .2133109 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -7.875301E-2 * fSize.width
	pa.y = center.y +  .2146922 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -7.826552E-2 * fSize.width
	bez.point1.y = center.y +  .2160578 * fSize.height
	bez.point2.x = center.x + -2.744308E-2 * fSize.width
	bez.point2.y = center.y +  .3532399 * fSize.height
	bez.point3.x = center.x +  .2074148 * fSize.width
	bez.point3.y = center.y +  .4599881 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1927057 * fSize.width
	pa.y = center.y +  .4923751 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -4.917235E-2 * fSize.width
	bez.point1.y = center.y +  .3824363 * fSize.height
	bez.point2.x = center.x + -.1070524 * fSize.width
	bez.point2.y = center.y +  .2405089 * fSize.height
	bez.point3.x = center.x + -.1119758 * fSize.width
	bez.point3.y = center.y +  .2273263 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1568561 * fSize.width
	bez.point1.y = center.y +  .1274358 * fSize.height
	bez.point2.x = center.x + -.1416986 * fSize.width
	bez.point2.y = center.y +  .0522792 * fSize.height
	bez.point3.x = center.x + -.121049 * fSize.width
	bez.point3.y = center.y +  6.786195E-3 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -9.840731E-2 * fSize.width
	bez.point1.y = center.y + -.0430786 * fSize.height
	bez.point2.x = center.x + -6.465484E-2 * fSize.width
	bez.point2.y = center.y + -6.881258E-2 * fSize.height
	bez.point3.x = center.x + -.0632299 * fSize.width
	bez.point3.y = center.y + -6.988754E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -6.237678E-2 * fSize.width
	pa.y = center.y + -7.049849E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -2.335995E-2 * fSize.width
	bez.point1.y = center.y + -9.639532E-2 * fSize.height
	bez.point2.x = center.x +  1.596446E-2 * fSize.width
	bez.point2.y = center.y + -.1095386 * fSize.height
	bez.point3.x = center.x +  5.498017E-2 * fSize.width
	bez.point3.y = center.y + -.109799 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  5.727988E-2 * fSize.width
	pa.y = center.y + -.2071465 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .1277581 * fSize.width
	bez.point1.y = center.y + -.2060994 * fSize.height
	bez.point2.x = center.x +  .1985235 * fSize.width
	bez.point2.y = center.y + -.1776113 * fSize.height
	bez.point3.x = center.x +  .2668223 * fSize.width
	bez.point3.y = center.y + -.1220655 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .3516788 * fSize.width
	bez.point1.y = center.y + -5.303635E-2 * fSize.height
	bez.point2.x = center.x +  .4021952 * fSize.width
	bez.point2.y = center.y +  3.248954E-2 * fSize.height
	bez.point3.x = center.x +  .4042905 * fSize.width
	bez.point3.y = center.y +  3.608949E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3736128 * fSize.width
	pa.y = center.y +  5.403468E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3731222 * fSize.width
	bez.point1.y = center.y +  5.322531E-2 * fSize.height
	bez.point2.x = center.x +  .3237886 * fSize.width
	bez.point2.y = center.y + -3.014749E-2 * fSize.height
	bez.point3.x = center.x +  .2436882 * fSize.width
	bez.point3.y = center.y + -9.505009E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1394039 * fSize.width
	bez.point1.y = center.y + -.1795463 * fSize.height
	bez.point2.x = center.x +  .0340789 * fSize.width
	bez.point2.y = center.y + -.194415 * fSize.height
	bez.point3.x = center.x + -6.943514E-2 * fSize.width
	bez.point3.y = center.y + -.1392169 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.0699039 * fSize.width
	bez.point1.y = center.y + -.1389576 * fSize.height
	bez.point2.x = center.x + -.116697 * fSize.width
	bez.point2.y = center.y + -.1138875 * fSize.height
	bez.point3.x = center.x + -.1551901 * fSize.width
	bez.point3.y = center.y + -5.989412E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2068034 * fSize.width
	bez.point1.y = center.y +  1.249279E-2 * fSize.height
	bez.point2.x = center.x + -.2183594 * fSize.width
	bez.point2.y = center.y +  9.922338E-2 * fSize.height
	bez.point3.x = center.x + -.1895708 * fSize.width
	bez.point3.y = center.y +  .1978164 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1890834 * fSize.width
	bez.point1.y = center.y +  .1994195 * fSize.height
	bez.point2.x = center.x + -.1399716 * fSize.width
	bez.point2.y = center.y +  .3598636 * fSize.height
	bez.point3.x = center.x +  2.974461E-2 * fSize.width
	bez.point3.y = center.y +  .4701689 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  1.035585E-2 * fSize.width
	pa.y = center.y +  .4999999 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1708539 * fSize.width
	bez.point1.y = center.y +  .3822024 * fSize.height
	bez.point2.x = center.x + -.2216141 * fSize.width
	bez.point2.y = center.y +  .2149209 * fSize.height
	bez.point3.x = center.x + -.2236891 * fSize.width
	bez.point3.y = center.y +  .2078413 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2635656 * fSize.width
	bez.point1.y = center.y +  7.126891E-2 * fSize.height
	bez.point2.x = center.x + -.2242 * fSize.width
	bez.point2.y = center.y + -2.437252E-2 * fSize.height
	bez.point3.x = center.x + -.1841616 * fSize.width
	bez.point3.y = center.y + -.0805252 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1408044 * fSize.width
	bez.point1.y = center.y + -.1413372 * fSize.height
	bez.point2.x = center.x + -8.823486E-2 * fSize.width
	bez.point2.y = center.y + -.1694902 * fSize.height
	bez.point3.x = center.x + -8.610052E-2 * fSize.width
	bez.point3.y = center.y + -.1706339 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -3.902955E-2 * fSize.width
	bez.point1.y = center.y + -.195733 * fSize.height
	bez.point2.x = center.x +  9.057945E-3 * fSize.width
	bez.point2.y = center.y + -.2078629 * fSize.height
	bez.point3.x = center.x +  5.727988E-2 * fSize.width
	bez.point3.y = center.y + -.2071465 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  5.800699E-2 * fSize.width
	pa.y = center.y + -.3087128 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  9.352624E-2 * fSize.width
	bez.point1.y = center.y + -.3082969 * fSize.height
	bez.point2.x = center.x +  .1292958 * fSize.width
	bez.point2.y = center.y + -.3026105 * fSize.height
	bez.point3.x = center.x +  .165001 * fSize.width
	bez.point3.y = center.y + -.2916707 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2721968 * fSize.width
	bez.point1.y = center.y + -.2587878 * fSize.height
	bez.point2.x = center.x +  .3409212 * fSize.width
	bez.point2.y = center.y + -.1903532 * fSize.height
	bez.point3.x = center.x +  .3437915 * fSize.width
	bez.point3.y = center.y + -.1874609 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3185636 * fSize.width
	pa.y = center.y + -.162414 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3179105 * fSize.width
	bez.point1.y = center.y + -.1630702 * fSize.height
	bez.point2.x = center.x +  .2533361 * fSize.width
	bez.point2.y = center.y + -.2273783 * fSize.height
	bez.point3.x = center.x +  .1545636 * fSize.width
	bez.point3.y = center.y + -.2576753 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  2.319607E-2 * fSize.width
	bez.point1.y = center.y + -.2979582 * fSize.height
	bez.point2.x = center.x + -.1029403 * fSize.width
	bez.point2.y = center.y + -.2607878 * fSize.height
	bez.point3.x = center.x + -.2203517 * fSize.width
	bez.point3.y = center.y + -.1471545 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2250532 * fSize.width
	bez.point1.y = center.y + -.1416608 * fSize.height
	bez.point2.x = center.x + -.2713978 * fSize.width
	bez.point2.y = center.y + -8.577617E-2 * fSize.height
	bez.point3.x = center.x + -.2955264 * fSize.width
	bez.point3.y = center.y + -4.868006E-4 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.3291555 * fSize.width
	bez.point1.y = center.y +  .1183496 * fSize.height
	bez.point2.x = center.x + -.3059824 * fSize.width
	bez.point2.y = center.y +  .235614 * fSize.height
	bez.point3.x = center.x + -.2266375 * fSize.width
	bez.point3.y = center.y +  .3480254 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2556918 * fSize.width
	pa.y = center.y +  .3685333 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3029517 * fSize.width
	bez.point1.y = center.y +  .3015768 * fSize.height
	bez.point2.x = center.x + -.3319641 * fSize.width
	bez.point2.y = center.y +  .2315234 * fSize.height
	bez.point3.x = center.x + -.3419109 * fSize.width
	bez.point3.y = center.y +  .1603184 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.3498883 * fSize.width
	bez.point1.y = center.y +  .1031511 * fSize.height
	bez.point2.x = center.x + -.3456549 * fSize.width
	bez.point2.y = center.y +  4.528992E-2 * fSize.height
	bez.point3.x = center.x + -.3292996 * fSize.width
	bez.point3.y = center.y + -1.170247E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.301547 * fSize.width
	bez.point1.y = center.y + -.108481 * fSize.height
	bez.point2.x = center.x + -.2488141 * fSize.width
	bez.point2.y = center.y + -.1686624 * fSize.height
	bez.point3.x = center.x + -.2465764 * fSize.width
	bez.point3.y = center.y + -.1711874 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2456608 * fSize.width
	pa.y = center.y + -.1721406 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1758568 * fSize.width
	bez.point1.y = center.y + -.2398674 * fSize.height
	bez.point2.x = center.x + -.1013559 * fSize.width
	bez.point2.y = center.y + -.2829206 * fSize.height
	bez.point3.x = center.x + -2.426914E-2 * fSize.width
	bez.point3.y = center.y + -.3001098 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  2.906182E-3 * fSize.width
	bez.point1.y = center.y + -.3061712 * fSize.height
	bez.point2.x = center.x +  3.038091E-2 * fSize.width
	bez.point2.y = center.y + -.3090362 * fSize.height
	bez.point3.x = center.x +  5.800699E-2 * fSize.width
	bez.point3.y = center.y + -.3087128 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  3.515832E-2 * fSize.width
	pa.y = center.y + -.4040507 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .1401827 * fSize.width
	bez.point1.y = center.y + -.4032866 * fSize.height
	bez.point2.x = center.x +  .2175918 * fSize.width
	bez.point2.y = center.y + -.3698721 * fSize.height
	bez.point3.x = center.x +  .2212778 * fSize.width
	bez.point3.y = center.y + -.3682566 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .206995 * fSize.width
	pa.y = center.y + -.3356797 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2060388 * fSize.width
	bez.point1.y = center.y + -.3361078 * fSize.height
	bez.point2.x = center.x +  .1095002 * fSize.width
	bez.point2.y = center.y + -.3775491 * fSize.height
	bez.point3.x = center.x + -9.680278E-3 * fSize.width
	bez.point3.y = center.y + -.3666469 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1680435 * fSize.width
	bez.point1.y = center.y + -.3521591 * fSize.height
	bez.point2.x = center.x + -.290216 * fSize.width
	bez.point2.y = center.y + -.2564427 * fSize.height
	bez.point3.x = center.x + -.3727751 * fSize.width
	bez.point3.y = center.y + -8.214714E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.4049 * fSize.width
	pa.y = center.y + -9.736707E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3563987 * fSize.width
	bez.point1.y = center.y + -.1997816 * fSize.height
	bez.point2.x = center.x + -.2933278 * fSize.width
	bez.point2.y = center.y + -.2778812 * fSize.height
	bez.point3.x = center.x + -.2174416 * fSize.width
	bez.point3.y = center.y + -.3295002 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.156306 * fSize.width
	bez.point1.y = center.y + -.3710642 * fSize.height
	bez.point2.x = center.x + -8.698924E-2 * fSize.width
	bez.point2.y = center.y + -.3955158 * fSize.height
	bez.point3.x = center.x + -1.140842E-2 * fSize.width
	bez.point3.y = center.y + -.4021912 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  4.587781E-3 * fSize.width
	bez.point1.y = center.y + -.4036026 * fSize.height
	bez.point2.x = center.x +  2.015485E-2 * fSize.width
	bez.point2.y = center.y + -.4041598 * fSize.height
	bez.point3.x = center.x +  3.515832E-2 * fSize.width
	bez.point3.y = center.y + -.4040507 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  7.446142E-3 * fSize.width
	pa.y = center.y + -.4999952 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  4.379287E-2 * fSize.width
	bez.point1.y = center.y + -.5001572 * fSize.height
	bez.point2.x = center.x +  6.715324E-2 * fSize.width
	bez.point2.y = center.y + -.4961287 * fSize.height
	bez.point3.x = center.x +  6.860825E-2 * fSize.width
	bez.point3.y = center.y + -.4958783 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  6.240356E-2 * fSize.width
	pa.y = center.y + -.4608622 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  6.043014E-2 * fSize.width
	bez.point1.y = center.y + -.4612132 * fSize.height
	bez.point2.x = center.x + -.1366544 * fSize.width
	bez.point2.y = center.y + -.4942076 * fSize.height
	bez.point3.x = center.x + -.2784385 * fSize.width
	bez.point3.y = center.y + -.3492836 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3038703 * fSize.width
	pa.y = center.y + -.3741382 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2228966 * fSize.width
	bez.point1.y = center.y + -.4569182 * fSize.height
	bez.point2.x = center.x + -.1260528 * fSize.width
	bez.point2.y = center.y + -.4856253 * fSize.height
	bez.point3.x = center.x + -5.907777E-2 * fSize.width
	bez.point3.y = center.y + -.495146 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -3.419457E-2 * fSize.width
	bez.point1.y = center.y + -.4986757 * fSize.height
	bez.point2.x = center.x + -1.159262E-2 * fSize.width
	bez.point2.y = center.y + -.4999104 * fSize.height
	bez.point3.x = center.x +  7.446142E-3 * fSize.width
	bez.point3.y = center.y + -.4999952 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function FingerprintPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	FingerprintFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Function DonutWedgeFigureAdd_c2d( sink As ID2D1GeometrySink, params As DonutPathParams ) As Long
	Local p2 As DonutPathParams
	p2 = params
	p2.sweepDegrees.first = DegreesToRadians( p2.sweepDegrees.first )
	p2.sweepDegrees.last = DegreesToRadians( p2.sweepDegrees.last )
	Function = DonutWedgeRadianFigureAdd_c2d( sink, p2 )
End Function

Function DonutWedgeRadianFigureAdd_c2d( sink As ID2D1GeometrySink, params As DonutPathParams ) As Long
	Local center, firstInner, lastInner, firstOuter, lastOuter As D2D1_POINT_2F
	Local radius, radiusChange, segDegrees, seg, sweep, firstAngle, lastAngle As Single
	Local chevron, firstOuterRadius, lastOuterRadius, firstInnerRadius, lastInnerRadius As Single
	Local isClockwise, isSmallAngle As Long

	firstAngle = params.sweepDegrees.first
	lastAngle = params.sweepDegrees.last

	If firstAngle = lastAngle Then lastAngle += 1.570796326794897!: ' A 0 degree wedge just isn't.  Default it to 90 degrees

	sweep = lastAngle - firstAngle

	firstOuterRadius = params.firstRadius.outer
	lastOuterRadius = params.lastRadius.outer
	firstInnerRadius = params.firstRadius.inner
	lastInnerRadius = params.lastRadius.inner
	center = params.center
	chevron = params.chevronAmount

	isClockwise = IsTrue (sweep>0!)
	isSmallAngle = ( Abs( sweep ) < 3.1415926535897932! Or firstInnerRadius <> lastInnerRadius )

	' Defaults for radii
	If firstOuterRadius <= 0 Then firstOuterRadius = lastOuterRadius
	If lastOuterRadius  <= 0 Then lastOuterRadius = firstOuterRadius
	If firstInnerRadius <= 0 Then firstInnerRadius = lastInnerRadius
	If lastInnerRadius  <= 0 Then lastInnerRadius = firstInnerRadius
	If firstInnerRadius <= 0 Then firstInnerRadius = 0.4!: lastInnerRadius = 0.4!
	If firstOuterRadius <= 0 Then firstOuterRadius = 0.5!: lastOuterRadius = 0.5!

	' Find 4 wedge points
	DonutWedgePoint_internal_c2d firstInner, center, firstAngle, firstInnerRadius
	DonutWedgePoint_internal_c2d lastInner, center, lastAngle, lastInnerRadius
	DonutWedgePoint_internal_c2d firstOuter, center, firstAngle, firstOuterRadius
	DonutWedgePoint_internal_c2d lastOuter, center, lastAngle, lastOuterRadius

	sink.BeginFigure( firstInner, %D2D1_FIGURE_BEGIN_FILLED )

	' Transition from starting inner to outer radius
	DonutWedgeChevron_internal_c2d sink, center, firstAngle, firstInnerRadius, firstOuterRadius, chevron, firstOuter

	' Draw outer arc/spiral
	ArcRadiansStroke_c2d sink, firstAngle, lastAngle, firstOuterRadius, lastOuterRadius, center

	' Transition to ending outer to inner radius
	DonutWedgeChevron_internal_c2d sink, center, lastAngle, lastOuterRadius, lastInnerRadius, chevron, lastInner

	' Draw inner arc/spiral
	ArcRadiansStroke_c2d sink, lastAngle, firstAngle, lastInnerRadius, firstInnerRadius, center

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Function = -1
End Function

Sub DonutWedgeChevron_internal_c2d( sink As ID2D1GeometrySink, ByVal center As D2D1_POINT_2F, ByVal angle As Single, ByVal r1 As Single, ByVal r2 As Single, ByVal chevron As Single, ByVal endPoint As D2D1_POINT_2F )
	Local midPoint As D2D1_POINT_2F
	Local radius As Single
	' Draw a line from current point to endPoint.  Add chevron if it isn't 0
	' The chevron is added if it's value <> 0
	If chevron <> 0! Then
		' Chevron on end
		radius = (r1+r2) / 2!  ' Center radius
		angle = angle + chevron / radius
		midPoint.x = center.x + Sin( angle + 1.570796326794897! ) * radius
		midPoint.y = center.y + Cos( angle + 1.570796326794897! ) * radius
		sink.AddLine( midPoint )
	End If
	sink.AddLine( endPoint )
End Sub

Sub DonutWedgePoint_internal_c2d( setPoint As D2D1_POINT_2F, center As D2D1_POINT_2F, angle As Single, radius As Single )
	setPoint.x = center.x + Sin( angle + 1.570796326794897! ) * radius
	setPoint.y = center.y + Cos( angle + 1.570796326794897! ) * radius
End Sub

Sub DatabaseFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .1009579 * fSize.width
	pa.y = center.y +  .4403438 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2960312 * fSize.width
	pa.y = center.y +  .4403438 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2960312 * fSize.width
	pa.y = center.y +  .47425 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  9.676561E-2 * fSize.width
	pa.y = center.y +  .47425 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  9.965318E-2 * fSize.width
	bez.point1.y = center.y +  .4653745 * fSize.height
	bez.point2.x = center.x +  .1012407 * fSize.width
	bez.point2.y = center.y +  .4559348 * fSize.height
	bez.point3.x = center.x +  .1012407 * fSize.width
	bez.point3.y = center.y +  .4461216 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1012407 * fSize.width
	bez.point1.y = center.y +  .4441681 * fSize.height
	bez.point2.x = center.x +  .1010798 * fSize.width
	bez.point2.y = center.y +  .4422598 * fSize.height
	bez.point3.x = center.x +  .1009579 * fSize.width
	bez.point3.y = center.y +  .4403438 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2959844 * fSize.width
	pa.y = center.y +  .4403438 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -8.015641E-2 * fSize.width
	pa.y = center.y +  .4403438 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -8.027831E-2 * fSize.width
	bez.point1.y = center.y +  .4422598 * fSize.height
	bez.point2.x = center.x + -8.043924E-2 * fSize.width
	bez.point2.y = center.y +  .4441681 * fSize.height
	bez.point3.x = center.x + -8.043924E-2 * fSize.width
	bez.point3.y = center.y +  .4461216 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -8.043924E-2 * fSize.width
	bez.point1.y = center.y +  .4559348 * fSize.height
	bez.point2.x = center.x + -7.881417E-2 * fSize.width
	bez.point2.y = center.y +  .4653745 * fSize.height
	bez.point3.x = center.x + -7.592189E-2 * fSize.width
	bez.point3.y = center.y +  .47425 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2959844 * fSize.width
	pa.y = center.y +  .47425 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y +  .0494375 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .3118036 * fSize.width
	pa.y = center.y +  .0494375 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3364237 * fSize.width
	bez.point1.y = center.y +  .0494375 * fSize.height
	bez.point2.x = center.x +  .3563594 * fSize.width
	bez.point2.y = center.y +  .069372 * fSize.height
	bez.point3.x = center.x +  .3563594 * fSize.width
	bez.point3.y = center.y +  9.394717E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3563594 * fSize.width
	pa.y = center.y +  .2243184 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3563594 * fSize.width
	bez.point1.y = center.y +  .2489014 * fSize.height
	bez.point2.x = center.x +  .3364237 * fSize.width
	bez.point2.y = center.y +  .268875 * fSize.height
	bez.point3.x = center.x +  .3118036 * fSize.width
	bez.point3.y = center.y +  .268875 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  3.959373E-2 * fSize.width
	pa.y = center.y +  .268875 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.959373E-2 * fSize.width
	pa.y = center.y +  .4008851 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  4.053003E-2 * fSize.width
	pa.y = center.y +  .4014536 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .0548714 * fSize.width
	bez.point1.y = center.y +  .4111372 * fSize.height
	bez.point2.x = center.x +  6.429687E-2 * fSize.width
	bez.point2.y = center.y +  .427534 * fSize.height
	bez.point3.x = center.x +  6.429687E-2 * fSize.width
	bez.point3.y = center.y +  .4461219 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  6.429687E-2 * fSize.width
	bez.point1.y = center.y +  .4758688 * fSize.height
	bez.point2.x = center.x +  4.016768E-2 * fSize.width
	bez.point2.y = center.y +  .5 * fSize.height
	bez.point3.x = center.x +  1.038045E-2 * fSize.width
	bez.point3.y = center.y +  .5 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -1.936302E-2 * fSize.width
	bez.point1.y = center.y +  .5 * fSize.height
	bez.point2.x = center.x + -.0435 * fSize.width
	bez.point2.y = center.y +  .4758688 * fSize.height
	bez.point3.x = center.x + -.0435 * fSize.width
	bez.point3.y = center.y +  .4461219 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.0435 * fSize.width
	bez.point1.y = center.y +  .4293928 * fSize.height
	bez.point2.x = center.x + -3.586292E-2 * fSize.width
	bez.point2.y = center.y +  .4144385 * fSize.height
	bez.point3.x = center.x + -2.388677E-2 * fSize.width
	bez.point3.y = center.y +  .4045556 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -2.014061E-2 * fSize.width
	pa.y = center.y +  .4017543 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.014061E-2 * fSize.width
	pa.y = center.y +  .268875 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y +  .268875 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3364202 * fSize.width
	bez.point1.y = center.y +  .268875 * fSize.height
	bez.point2.x = center.x + -.3563594 * fSize.width
	bez.point2.y = center.y +  .2489014 * fSize.height
	bez.point3.x = center.x + -.3563594 * fSize.width
	bez.point3.y = center.y +  .2243184 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3563594 * fSize.width
	pa.y = center.y +  9.394717E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3563594 * fSize.width
	bez.point1.y = center.y +  .069372 * fSize.height
	bez.point2.x = center.x + -.3364202 * fSize.width
	bez.point2.y = center.y +  .0494375 * fSize.height
	bez.point3.x = center.x + -.3118461 * fSize.width
	bez.point3.y = center.y +  .0494375 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y + -.22775 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .3118037 * fSize.width
	pa.y = center.y + -.22775 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3364237 * fSize.width
	bez.point1.y = center.y + -.22775 * fSize.height
	bez.point2.x = center.x +  .3563594 * fSize.width
	bez.point2.y = center.y + -.2078133 * fSize.height
	bez.point3.x = center.x +  .3563594 * fSize.width
	bez.point3.y = center.y + -.1831921 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3563594 * fSize.width
	pa.y = center.y + -5.285466E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3563594 * fSize.width
	bez.point1.y = center.y + -2.828038E-2 * fSize.height
	bez.point2.x = center.x +  .3364237 * fSize.width
	bez.point2.y = center.y + -8.343719E-3 * fSize.height
	bez.point3.x = center.x +  .3118037 * fSize.width
	bez.point3.y = center.y + -8.343719E-3 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y + -8.343719E-3 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3364202 * fSize.width
	bez.point1.y = center.y + -8.343719E-3 * fSize.height
	bez.point2.x = center.x + -.3563594 * fSize.width
	bez.point2.y = center.y + -2.828038E-2 * fSize.height
	bez.point3.x = center.x + -.3563594 * fSize.width
	bez.point3.y = center.y + -5.285466E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3563594 * fSize.width
	pa.y = center.y + -.1831921 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3563594 * fSize.width
	bez.point1.y = center.y + -.2078133 * fSize.height
	bez.point2.x = center.x + -.3364202 * fSize.width
	bez.point2.y = center.y + -.22775 * fSize.height
	bez.point3.x = center.x + -.3118461 * fSize.width
	bez.point3.y = center.y + -.22775 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2252119 * fSize.width
	pa.y = center.y + -.440875 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x + -.2530445 * fSize.width
	bez.point1.y = center.y + -.440875 * fSize.height
	bez.point2.x = center.x + -.27575 * fSize.width
	bez.point2.y = center.y + -.4182083 * fSize.height
	bez.point3.x = center.x + -.27575 * fSize.width
	bez.point3.y = center.y + -.3903005 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.27575 * fSize.width
	bez.point1.y = center.y + -.3623851 * fSize.height
	bez.point2.x = center.x + -.2530445 * fSize.width
	bez.point2.y = center.y + -.3397188 * fSize.height
	bez.point3.x = center.x + -.2252119 * fSize.width
	bez.point3.y = center.y + -.3397188 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.197299 * fSize.width
	bez.point1.y = center.y + -.3397188 * fSize.height
	bez.point2.x = center.x + -.1745938 * fSize.width
	bez.point2.y = center.y + -.3623851 * fSize.height
	bez.point3.x = center.x + -.1745938 * fSize.width
	bez.point3.y = center.y + -.3903005 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1745938 * fSize.width
	bez.point1.y = center.y + -.4182083 * fSize.height
	bez.point2.x = center.x + -.197299 * fSize.width
	bez.point2.y = center.y + -.440875 * fSize.height
	bez.point3.x = center.x + -.2252119 * fSize.width
	bez.point3.y = center.y + -.440875 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .3118036 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3364236 * fSize.width
	bez.point1.y = center.y + -.5 * fSize.height
	bez.point2.x = center.x +  .3563593 * fSize.width
	bez.point2.y = center.y + -.4800261 * fSize.height
	bez.point3.x = center.x +  .3563593 * fSize.width
	bez.point3.y = center.y + -.4554441 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3563593 * fSize.width
	pa.y = center.y + -.3250722 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3563593 * fSize.width
	bez.point1.y = center.y + -.300497 * fSize.height
	bez.point2.x = center.x +  .3364236 * fSize.width
	bez.point2.y = center.y + -.2805625 * fSize.height
	bez.point3.x = center.x +  .3118036 * fSize.width
	bez.point3.y = center.y + -.2805625 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3118461 * fSize.width
	pa.y = center.y + -.2805625 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3364202 * fSize.width
	bez.point1.y = center.y + -.2805625 * fSize.height
	bez.point2.x = center.x + -.3563594 * fSize.width
	bez.point2.y = center.y + -.300497 * fSize.height
	bez.point3.x = center.x + -.3563594 * fSize.width
	bez.point3.y = center.y + -.3250722 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3563594 * fSize.width
	pa.y = center.y + -.4554441 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3563594 * fSize.width
	bez.point1.y = center.y + -.4800261 * fSize.height
	bez.point2.x = center.x + -.3364202 * fSize.width
	bez.point2.y = center.y + -.5 * fSize.height
	bez.point3.x = center.x + -.3118461 * fSize.width
	bez.point3.y = center.y + -.5 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function DatabasePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	DatabaseFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub CoolFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

If fSize.width = 0! Then fSize.width = 1!
If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  1.918158E-5 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .1385166 * fSize.width
	bez.point1.y = center.y + -.5 * fSize.height
	bez.point2.x = center.x +  .2638005 * fSize.width
	bez.point2.y = center.y + -.4436837 * fSize.height
	bez.point3.x = center.x +  .3543593 * fSize.width
	bez.point3.y = center.y + -.3526828 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .3235358 * fSize.width
	bez.point1.y = center.y + -.3621547 * fSize.height
	bez.point2.x = center.x +  .2851304 * fSize.width
	bez.point2.y = center.y + -.3667711 * fSize.height
	bez.point3.x = center.x +  .243344 * fSize.width
	bez.point3.y = center.y + -.3667711 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1421381 * fSize.width
	bez.point1.y = center.y + -.3667711 * fSize.height
	bez.point2.x = center.x +  4.548849E-2 * fSize.width
	bez.point2.y = center.y + -.3341164 * fSize.height
	bez.point3.x = center.x +  4.548849E-2 * fSize.width
	bez.point3.y = center.y + -.2750537 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  4.548849E-2 * fSize.width
	bez.point1.y = center.y + -.2159118 * fSize.height
	bez.point2.x = center.x +  .164266 * fSize.width
	bez.point2.y = center.y + -5.729156E-2 * fSize.height
	bez.point3.x = center.x +  .2654719 * fSize.width
	bez.point3.y = center.y + -5.729156E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .3575435 * fSize.width
	bez.point1.y = center.y + -5.729156E-2 * fSize.height
	bez.point2.x = center.x +  .4152903 * fSize.width
	bez.point2.y = center.y + -.1934846 * fSize.height
	bez.point3.x = center.x +  .4249412 * fSize.width
	bez.point3.y = center.y + -.2625562 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .4722212 * fSize.width
	bez.point1.y = center.y + -.1861611 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y + -9.641432E-2 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y + -2.046036E-5 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y +  .2761279 * fSize.height
	bez.point2.x = center.x +  .2761164 * fSize.width
	bez.point2.y = center.y +  .5 * fSize.height
	bez.point3.x = center.x +  1.918158E-5 * fSize.width
	bez.point3.y = center.y +  .5 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.276078 * fSize.width
	bez.point1.y = center.y +  .5 * fSize.height
	bez.point2.x = center.x + -.5 * fSize.width
	bez.point2.y = center.y +  .2761279 * fSize.height
	bez.point3.x = center.x + -.5 * fSize.width
	bez.point3.y = center.y + -2.046036E-5 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.5 * fSize.width
	bez.point1.y = center.y + -9.641432E-2 * fSize.height
	bez.point2.x = center.x + -.4722212 * fSize.width
	bez.point2.y = center.y + -.1861611 * fSize.height
	bez.point3.x = center.x + -.4249212 * fSize.width
	bez.point3.y = center.y + -.2625562 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.4152706 * fSize.width
	bez.point1.y = center.y + -.1934246 * fSize.height
	bez.point2.x = center.x + -.3575435 * fSize.width
	bez.point2.y = center.y + -5.729156E-2 * fSize.height
	bez.point3.x = center.x + -.2654514 * fSize.width
	bez.point3.y = center.y + -5.729156E-2 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1642455 * fSize.width
	bez.point1.y = center.y + -5.729156E-2 * fSize.height
	bez.point2.x = center.x + -4.546931E-2 * fSize.width
	bez.point2.y = center.y + -.2159118 * fSize.height
	bez.point3.x = center.x + -4.546931E-2 * fSize.width
	bez.point3.y = center.y + -.2750537 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -4.546931E-2 * fSize.width
	bez.point1.y = center.y + -.3341164 * fSize.height
	bez.point2.x = center.x + -.1421189 * fSize.width
	bez.point2.y = center.y + -.3667711 * fSize.height
	bez.point3.x = center.x + -.2433248 * fSize.width
	bez.point3.y = center.y + -.3667711 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2851112 * fSize.width
	bez.point1.y = center.y + -.3667711 * fSize.height
	bez.point2.x = center.x + -.3235166 * fSize.width
	bez.point2.y = center.y + -.3621547 * fSize.height
	bez.point3.x = center.x + -.3543593 * fSize.width
	bez.point3.y = center.y + -.3526828 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.26378 * fSize.width
	bez.point1.y = center.y + -.4436837 * fSize.height
	bez.point2.x = center.x + -.1384757 * fSize.width
	bez.point2.y = center.y + -.5 * fSize.height
	bez.point3.x = center.x +  1.918158E-5 * fSize.width
	bez.point3.y = center.y + -.5 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function CoolPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	CoolFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub ClipboardFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

If fSize.width = 0! Then fSize.width = 1!
If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.214297 * fSize.width
	pa.y = center.y +  .2568596 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .1190318 * fSize.width
	pa.y = center.y +  .2568596 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1255006 * fSize.width
	bez.point1.y = center.y +  .2568596 * fSize.height
	bez.point2.x = center.x +  .1307506 * fSize.width
	bez.point2.y = center.y +  .2621097 * fSize.height
	bez.point3.x = center.x +  .1307506 * fSize.width
	bez.point3.y = center.y +  .2685472 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1307506 * fSize.width
	pa.y = center.y +  .2844222 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1307506 * fSize.width
	bez.point1.y = center.y +  .2908753 * fSize.height
	bez.point2.x = center.x +  .1255006 * fSize.width
	bez.point2.y = center.y +  .2961253 * fSize.height
	bez.point3.x = center.x +  .1190318 * fSize.width
	bez.point3.y = center.y +  .2961253 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.214297 * fSize.width
	pa.y = center.y +  .2961253 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2207502 * fSize.width
	bez.point1.y = center.y +  .2961253 * fSize.height
	bez.point2.x = center.x + -.2260002 * fSize.width
	bez.point2.y = center.y +  .2908753 * fSize.height
	bez.point3.x = center.x + -.2260002 * fSize.width
	bez.point3.y = center.y +  .2844222 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2260002 * fSize.width
	pa.y = center.y +  .2685472 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2260002 * fSize.width
	bez.point1.y = center.y +  .2621097 * fSize.height
	bez.point2.x = center.x + -.2207502 * fSize.width
	bez.point2.y = center.y +  .2568596 * fSize.height
	bez.point3.x = center.x + -.214297 * fSize.width
	bez.point3.y = center.y +  .2568596 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2142975 * fSize.width
	pa.y = center.y +  6.492192E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .1983914 * fSize.width
	pa.y = center.y +  6.492192E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .20486 * fSize.width
	bez.point1.y = center.y +  6.492192E-2 * fSize.height
	bez.point2.x = center.x +  .2101098 * fSize.width
	bez.point2.y = center.y +  7.016993E-2 * fSize.height
	bez.point3.x = center.x +  .2101098 * fSize.width
	bez.point3.y = center.y +  7.663624E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2101098 * fSize.width
	pa.y = center.y +  9.250524E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2100785 * fSize.width
	bez.point1.y = center.y +  9.895593E-2 * fSize.height
	bez.point2.x = center.x +  .2048287 * fSize.width
	bez.point2.y = center.y +  .104204 * fSize.height
	bez.point3.x = center.x +  .1983914 * fSize.width
	bez.point3.y = center.y +  .104204 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2142975 * fSize.width
	pa.y = center.y +  .104204 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2207504 * fSize.width
	bez.point1.y = center.y +  .104204 * fSize.height
	bez.point2.x = center.x + -.2260002 * fSize.width
	bez.point2.y = center.y +  9.895593E-2 * fSize.height
	bez.point3.x = center.x + -.2260002 * fSize.width
	bez.point3.y = center.y +  9.250524E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2260002 * fSize.width
	pa.y = center.y +  7.663624E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2260002 * fSize.width
	bez.point1.y = center.y +  7.016993E-2 * fSize.height
	bez.point2.x = center.x + -.2207504 * fSize.width
	bez.point2.y = center.y +  6.492192E-2 * fSize.height
	bez.point3.x = center.x + -.2142975 * fSize.width
	bez.point3.y = center.y +  6.492192E-2 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2142975 * fSize.width
	pa.y = center.y + -.1069372 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .1983914 * fSize.width
	pa.y = center.y + -.1069372 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .20486 * fSize.width
	bez.point1.y = center.y + -.1069372 * fSize.height
	bez.point2.x = center.x +  .2101098 * fSize.width
	bez.point2.y = center.y + -.1016872 * fSize.height
	bez.point3.x = center.x +  .2101098 * fSize.width
	bez.point3.y = center.y + -.0952341 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2101098 * fSize.width
	pa.y = center.y + -.0793591 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2100785 * fSize.width
	bez.point1.y = center.y + -7.292159E-2 * fSize.height
	bez.point2.x = center.x +  .2048287 * fSize.width
	bez.point2.y = center.y + -.0676716 * fSize.height
	bez.point3.x = center.x +  .1983914 * fSize.width
	bez.point3.y = center.y + -.0676716 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2142975 * fSize.width
	pa.y = center.y + -.0676716 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2207504 * fSize.width
	bez.point1.y = center.y + -.0676716 * fSize.height
	bez.point2.x = center.x + -.2260002 * fSize.width
	bez.point2.y = center.y + -7.292159E-2 * fSize.height
	bez.point3.x = center.x + -.2260002 * fSize.width
	bez.point3.y = center.y + -.0793591 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2260002 * fSize.width
	pa.y = center.y + -.0952341 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2260002 * fSize.width
	bez.point1.y = center.y + -.1016872 * fSize.height
	bez.point2.x = center.x + -.2207504 * fSize.width
	bez.point2.y = center.y + -.1069372 * fSize.height
	bez.point3.x = center.x + -.2142975 * fSize.width
	bez.point3.y = center.y + -.1069372 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2777818 * fSize.width
	pa.y = center.y + -.214282 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2777818 * fSize.width
	pa.y = center.y +  .4160938 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2747653 * fSize.width
	pa.y = center.y +  .4160938 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2747653 * fSize.width
	pa.y = center.y + -.214282 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3154854 * fSize.width
	pa.y = center.y + -.3888914 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.1803753 * fSize.width
	pa.y = center.y + -.3888914 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1814539 * fSize.width
	bez.point1.y = center.y + -.3836262 * fSize.height
	bez.point2.x = center.x + -.1820318 * fSize.width
	bez.point2.y = center.y + -.3781578 * fSize.height
	bez.point3.x = center.x + -.1820318 * fSize.width
	bez.point3.y = center.y + -.3725482 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1820318 * fSize.width
	bez.point1.y = center.y + -.3293134 * fSize.height
	bez.point2.x = center.x + -.1468908 * fSize.width
	bez.point2.y = center.y + -.2941571 * fSize.height
	bez.point3.x = center.x + -.1036569 * fSize.width
	bez.point3.y = center.y + -.2941571 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1036407 * fSize.width
	pa.y = center.y + -.2941571 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1468746 * fSize.width
	bez.point1.y = center.y + -.2941571 * fSize.height
	bez.point2.x = center.x +  .1820309 * fSize.width
	bez.point2.y = center.y + -.3293134 * fSize.height
	bez.point3.x = center.x +  .1820309 * fSize.width
	bez.point3.y = center.y + -.373501 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .1820309 * fSize.width
	bez.point1.y = center.y + -.3787662 * fSize.height
	bez.point2.x = center.x +  .1814844 * fSize.width
	bez.point2.y = center.y + -.3839075 * fSize.height
	bez.point3.x = center.x +  .180484 * fSize.width
	bez.point3.y = center.y + -.3888914 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3154692 * fSize.width
	pa.y = center.y + -.3888914 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3384842 * fSize.width
	bez.point1.y = center.y + -.3888914 * fSize.height
	bez.point2.x = center.x +  .357141 * fSize.width
	bez.point2.y = center.y + -.3702356 * fSize.height
	bez.point3.x = center.x +  .357141 * fSize.width
	bez.point3.y = center.y + -.3472196 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .357141 * fSize.width
	pa.y = center.y +  .4583435 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .357141 * fSize.width
	bez.point1.y = center.y +  .4813442 * fSize.height
	bez.point2.x = center.x +  .3384842 * fSize.width
	bez.point2.y = center.y +  .5 * fSize.height
	bez.point3.x = center.x +  .3154692 * fSize.width
	bez.point3.y = center.y +  .5 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3154854 * fSize.width
	pa.y = center.y +  .5 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3384852 * fSize.width
	bez.point1.y = center.y +  .5 * fSize.height
	bez.point2.x = center.x + -.357141 * fSize.width
	bez.point2.y = center.y +  .4813442 * fSize.height
	bez.point3.x = center.x + -.357141 * fSize.width
	bez.point3.y = center.y +  .4583435 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.357141 * fSize.width
	pa.y = center.y + -.3472196 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.357141 * fSize.width
	bez.point1.y = center.y + -.3702356 * fSize.height
	bez.point2.x = center.x + -.3384852 * fSize.width
	bez.point2.y = center.y + -.3888914 * fSize.height
	bez.point3.x = center.x + -.3154854 * fSize.width
	bez.point3.y = center.y + -.3888914 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -6.404436E-4 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  6.251826E-4 * fSize.width
	pa.y = center.y + -.5 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  3.096894E-2 * fSize.width
	bez.point1.y = center.y + -.5 * fSize.height
	bez.point2.x = center.x +  5.556275E-2 * fSize.width
	bez.point2.y = center.y + -.4754063 * fSize.height
	bez.point3.x = center.x +  5.556275E-2 * fSize.width
	bez.point3.y = center.y + -.4450782 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  5.556275E-2 * fSize.width
	pa.y = center.y + -.4442813 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  5.556275E-2 * fSize.width
	bez.point1.y = center.y + -.4312188 * fSize.height
	bez.point2.x = center.x +  6.614085E-2 * fSize.width
	bez.point2.y = center.y + -.4206406 * fSize.height
	bez.point3.x = center.x +  7.920337E-2 * fSize.width
	bez.point3.y = center.y + -.4206406 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1036565 * fSize.width
	pa.y = center.y + -.4206406 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1296878 * fSize.width
	bez.point1.y = center.y + -.4206406 * fSize.height
	bez.point2.x = center.x +  .1507972 * fSize.width
	bez.point2.y = center.y + -.3995313 * fSize.height
	bez.point3.x = center.x +  .1507972 * fSize.width
	bez.point3.y = center.y + -.3735 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1507972 * fSize.width
	pa.y = center.y + -.3725469 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1507972 * fSize.width
	bez.point1.y = center.y + -.3465 * fSize.height
	bez.point2.x = center.x +  .1296878 * fSize.width
	bez.point2.y = center.y + -.3254063 * fSize.height
	bez.point3.x = center.x +  .1036565 * fSize.width
	bez.point3.y = center.y + -.3254063 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1036562 * fSize.width
	pa.y = center.y + -.3254063 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1296874 * fSize.width
	bez.point1.y = center.y + -.3254063 * fSize.height
	bez.point2.x = center.x + -.1507968 * fSize.width
	bez.point2.y = center.y + -.3465 * fSize.height
	bez.point3.x = center.x + -.1507968 * fSize.width
	bez.point3.y = center.y + -.3725469 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1507968 * fSize.width
	pa.y = center.y + -.3735 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1507968 * fSize.width
	bez.point1.y = center.y + -.3995313 * fSize.height
	bez.point2.x = center.x + -.1296874 * fSize.width
	bez.point2.y = center.y + -.4206406 * fSize.height
	bez.point3.x = center.x + -.1036562 * fSize.width
	bez.point3.y = center.y + -.4206406 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.079203 * fSize.width
	pa.y = center.y + -.4206406 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -6.615613E-2 * fSize.width
	bez.point1.y = center.y + -.4206406 * fSize.height
	bez.point2.x = center.x + -5.554673E-2 * fSize.width
	bez.point2.y = center.y + -.4312188 * fSize.height
	bez.point3.x = center.x + -5.554673E-2 * fSize.width
	bez.point3.y = center.y + -.4442813 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -5.554673E-2 * fSize.width
	pa.y = center.y + -.4450782 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -5.554673E-2 * fSize.width
	bez.point1.y = center.y + -.4754063 * fSize.height
	bez.point2.x = center.x + -3.096858E-2 * fSize.width
	bez.point2.y = center.y + -.5 * fSize.height
	bez.point3.x = center.x + -6.404436E-4 * fSize.width
	bez.point3.y = center.y + -.5 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function ClipboardPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ClipboardFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub PaperClipFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

If fSize.width = 0! Then fSize.width = 1!
If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .2436696 * fSize.width
	pa.y = center.y + -8.830337E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .2436696 * fSize.width
	bez.point1.y = center.y + -8.830337E-2 * fSize.height
	bez.point2.x = center.x +  .2841396 * fSize.width
	bez.point2.y = center.y + -.1190856 * fSize.height
	bez.point3.x = center.x +  .2533574 * fSize.width
	bez.point3.y = center.y + -.1498054 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2225751 * fSize.width
	bez.point1.y = center.y + -.1805251 * fSize.height
	bez.point2.x = center.x +  .1925741 * fSize.width
	bez.point2.y = center.y + -.1408988 * fSize.height
	bez.point3.x = center.x +  .1925741 * fSize.width
	bez.point3.y = center.y + -.1408988 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1169671 * fSize.width
	pa.y = center.y +  .1686737 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1169671 * fSize.width
	bez.point1.y = center.y +  .1686737 * fSize.height
	bez.point2.x = center.x + -.1894695 * fSize.width
	bez.point2.y = center.y +  .262208 * fSize.height
	bez.point3.x = center.x + -.2444713 * fSize.width
	bez.point3.y = center.y +  .2056436 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.299473 * fSize.width
	bez.point1.y = center.y +  .1490324 * fSize.height
	bez.point2.x = center.x + -.2075951 * fSize.width
	bez.point2.y = center.y +  7.803015E-2 * fSize.height
	bez.point3.x = center.x + -.2075951 * fSize.width
	bez.point3.y = center.y +  7.803015E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1981993 * fSize.width
	pa.y = center.y + -.327733 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1981993 * fSize.width
	bez.point1.y = center.y + -.327733 * fSize.height
	bez.point2.x = center.x +  .2928899 * fSize.width
	bez.point2.y = center.y + -.4320645 * fSize.height
	bez.point3.x = center.x +  .3819553 * fSize.width
	bez.point3.y = center.y + -.3430929 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .4708644 * fSize.width
	bez.point1.y = center.y + -.2541056 * fSize.height
	bez.point2.x = center.x +  .3663298 * fSize.width
	bez.point2.y = center.y + -.159165 * fSize.height
	bez.point3.x = center.x +  .3663298 * fSize.width
	bez.point3.y = center.y + -.159165 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -8.977876E-2 * fSize.width
	pa.y = center.y +  .296756 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -8.977876E-2 * fSize.width
	bez.point1.y = center.y +  .296756 * fSize.height
	bez.point2.x = center.x + -.2355647 * fSize.width
	bez.point2.y = center.y +  .4652927 * fSize.height
	bez.point3.x = center.x + -.3705691 * fSize.width
	bez.point3.y = center.y +  .3301789 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.5055735 * fSize.width
	bez.point1.y = center.y +  .1951277 * fSize.height
	bez.point2.x = center.x + -.3354117 * fSize.width
	bez.point2.y = center.y +  5.090427E-2 * fSize.height
	bez.point3.x = center.x + -.3354117 * fSize.width
	bez.point3.y = center.y +  5.090427E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  1.069325E-2 * fSize.width
	pa.y = center.y + -.2953882 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  1.069325E-2 * fSize.width
	bez.point1.y = center.y + -.2953882 * fSize.height
	bez.point2.x = center.x +  .0494445 * fSize.width
	bez.point2.y = center.y + -.327733 * fSize.height
	bez.point3.x = center.x +  2.038106E-2 * fSize.width
	bez.point3.y = center.y + -.3568433 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -8.682379E-3 * fSize.width
	bez.point1.y = center.y + -.3859536 * fSize.height
	bez.point2.x = center.x + -4.102718E-2 * fSize.width
	bez.point2.y = center.y + -.3471399 * fSize.height
	bez.point3.x = center.x + -4.102718E-2 * fSize.width
	bez.point3.y = center.y + -.3471399 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.4382276 * fSize.width
	pa.y = center.y +  5.007612E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.4382276 * fSize.width
	bez.point1.y = center.y +  5.007612E-2 * fSize.height
	bez.point2.x = center.x + -.5882324 * fSize.width
	bez.point2.y = center.y +  .2145189 * fSize.height
	bez.point3.x = center.x + -.420727 * fSize.width
	bez.point3.y = center.y +  .381915 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2533778 * fSize.width
	bez.point1.y = center.y +  .5494048 * fSize.height
	bez.point2.x = center.x + -8.884123E-2 * fSize.width
	bez.point2.y = center.y +  .3994781 * fSize.height
	bez.point3.x = center.x + -8.884123E-2 * fSize.width
	bez.point3.y = center.y +  .3994781 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .457114 * fSize.width
	pa.y = center.y + -.146524 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .457114 * fSize.width
	bez.point1.y = center.y + -.146524 * fSize.height
	bez.point2.x = center.x +  .5663363 * fSize.width
	bez.point2.y = center.y + -.2669498 * fSize.height
	bez.point3.x = center.x +  .4361758 * fSize.width
	bez.point3.y = center.y + -.3972665 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .305859 * fSize.width
	bez.point1.y = center.y + -.5275676 * fSize.height
	bez.point2.x = center.x +  .1853864 * fSize.width
	bez.point2.y = center.y + -.4183453 * fSize.height
	bez.point3.x = center.x +  .1853864 * fSize.width
	bez.point3.y = center.y + -.4183453 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2843163 * fSize.width
	pa.y = center.y +  5.132616E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2843163 * fSize.width
	bez.point1.y = center.y +  5.132616E-2 * fSize.height
	bez.point2.x = center.x + -.4046327 * fSize.width
	bez.point2.y = center.y +  .14922 * fSize.height
	bez.point3.x = center.x + -.2955667 * fSize.width
	bez.point3.y = center.y +  .2583016 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1863444 * fSize.width
	bez.point1.y = center.y +  .3675552 * fSize.height
	bez.point2.x = center.x + -9.024753E-2 * fSize.width
	bez.point2.y = center.y +  .2454887 * fSize.height
	bez.point3.x = center.x + -9.024753E-2 * fSize.width
	bez.point3.y = center.y +  .2454887 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2436696 * fSize.width
	pa.y = center.y + -8.830337E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function PaperClipPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PaperClipFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub CircleFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal radius As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long )
	Local pa As D2D1_POINT_2F
	Local dot As D2D1_ARC_SEGMENT
	Local angle As Single

	' Radius if ommitted is assumed to be .5
	' Center if o

	If radius = 0 Then radius = .5!
	angle = 0
	pa.x = center.x + Sin( angle ) * radius
	pa.y = center.y + Cos( angle ) * radius
	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If
	angle = .001
	dot.point.x          = center.x + Sin( angle ) * radius
	dot.point.y          = center.y + Cos( angle ) * radius
	dot.size.width       = radius
	dot.size.height      = radius
	dot.rotationAngle    = 0
	dot.sweepDirection   = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	dot.arcSize          = %D2D1_ARC_SIZE_LARGE
	sink.AddArc( dot )
	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub ChartSymbol_XFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	pa.x = -.5 + xValues( params.i1, params.j ) - params.size / 2!
	pa.y = params.zero - yValues( params.i1, params.j ) - params.size / 2!
	pb.x = pa.x + params.size
	pb.y = pa.y + params.size
	LineFigureAdd_c2d sink, pa, pb

	pa.x = -.5 + xValues( params.i1, params.j ) + params.size / 2!
	pa.y = params.zero - yValues( params.i1, params.j ) - params.size / 2!
	pb.x = pa.x - params.size
	pb.y = pa.y + params.size
	LineFigureAdd_c2d sink, pa, pb
End Sub

Sub ChartSymbol_TickFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	pa.x = -.5 + xValues( params.i1, params.j )
	pa.y = params.zero - yValues( params.i1, params.j ) - params.size / 2!
	pb.x = pa.x
	pb.y = pa.y + params.size
	LineFigureAdd_c2d sink, pa, pb
End Sub

Sub ChartSymbol_DashFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	pa.x = -.5 + xValues( params.i1, params.j ) - params.size / 2!
	pa.y = params.zero - yValues( params.i1, params.j )
	pb.x = pa.x + params.size
	pb.y = pa.y
	LineFigureAdd_c2d sink, pa, pb
End Sub

Sub ChartSymbol_BarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea
	Local center As D2D1_POINT_2F
	Local boxSize As D2D1_SIZE_F
	Local z As Single
	If params.vLayout<>%ChartVLayoutType.Normal Then
		If params.j = params.lb2 Then
			z = 0
		Else
			z = yValues( params.i1, params.j-1 )
		End If
		boxSize.height = yValues( params.i1, params.j ) - z
		center.y = params.zero - (z + yValues( params.i1, params.j )) / 2!
	Else
		boxSize.height = yValues( params.i1, params.j )
		center.y = params.zero - boxSize.height / 2!
	End If
	If params.ub2=params.lb2 Or params.vLayout<>%ChartVLayoutType.Normal Then z = Max(params.barPadding, params.groupPadding) Else z=params.barPadding
	boxSize.width = Max(params.width - z, .001)
	center.x = -.5 + xValues( params.i1, params.j )
	BoxFigureAdd_c2d sink, 2! / params.display.width, 2! / params.display.height, center, boxSize
End Sub

Sub ChartSymbol_HLineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	Local boxSize As D2D1_SIZE_F
	Local w, z As Single
	If params.isArea Then
		If params.vLayout<>%ChartVLayoutType.Normal Then
			If params.j=params.lb2 Then
				z = 0
			Else
				z = yValues( params.i1, params.j-1 )
			End If
			pa.x = -.5 + xValues( params.i1, params.j )
			boxSize.width = params.width
			boxSize.height = yValues( params.i1, params.j ) - z
			pa.y = params.zero - z - boxSize.height/2!
			BoxFigureAdd_c2d sink, 0, 0, pa, boxSize
		Else
			pa.x = -.5 + xValues( params.i1, params.j )
			boxSize.width = params.width
			boxSize.height = yValues( params.i1, params.j )
			pa.y = params.zero - boxSize.height / 2!
			BoxFigureAdd_c2d sink, 0, 0, pa, boxSize
		End If
	Else
		w = params.width / 2!
		pa.x = -.5 + xValues( params.i1, params.j )
		pa.y = params.zero - yValues( params.i1, params.j )
		pa.x -= params.width / 2!
		pb.x = pa.x + params.width
		pb.y = pa.y
		LineFigureAdd_c2d sink, pa, pb
	End If
End Sub

Sub ChartSymbol_PointFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	CircleFigureAdd_c2d sink, params.size/2, center
End Sub

Sub ChartSymbol_StepFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	Local boxSize As D2D1_SIZE_F
	Local w, z As Single
	If params.isArea Then
		ChartSymbol_HLineFigureAdd_c2d sink, xValues(), yValues(), params
	Else
		w = params.width / 2!
		pa.x = -.5 + xValues( params.i1, params.j )
		pa.y = params.zero - yValues( params.i1, params.j )
		pa.x -= params.width / 2!
		pb.x = pa.x + params.width
		pb.y = pa.y
		LineFigureAdd_c2d sink, pa, pb
		If params.i1 < params.ub1 Then
			pa.x = -.5 + xValues( params.i1+1 ) - params.width/2
			pa.y = params.zero - yValues( params.i1+1, params.j )
			LineFigureAdd_c2d sink, pb, pa
		End If
	End If
End Sub

Sub ChartSymbol_LineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Drawing two lines Low y intercept to center, center to High y intercept
	Local pa, pb, pc, pLeft, pRight As D2D1_POINT_2F
	Local m, b, dx As Single
	pb.x = -.5 + xValues( params.i1, params.j )
	pb.y = params.zero - yValues( params.i1, params.j )
	If params.i1=params.lb1 Then
		pa.x = -.5 - xValues( params.lb1, params.j )
		pa.y = params.zero - yValues( params.ub1, params.j )
	Else
		pa.x = -.5 + xValues( params.i1-1, params.j )
		pa.y = params.zero - yValues( params.i1-1, params.j )
	End If
	If params.i1>=params.ub1 Then
		pc.x = .5 + xValues( params.lb1, params.j )
		pc.y = params.zero - yValues( params.lb1, params.j )
	Else
		pc.x = -.5 + xValues( params.i1+1, params.j )
		pc.y = params.zero - yValues( params.i1+1, params.j )
	End If

	pLeft.x = (pa.x+pb.x)/2!
	pLeft.y = (pa.y+pb.y)/2!
	pRight.x = (pc.x+pb.x)/2!
	pRight.y = (pc.y+pb.y)/2!

	If params.isArea Then
		sink.BeginFigure( pLeft, %D2D1_FIGURE_BEGIN_FILLED )
	Else
		sink.BeginFigure( pLeft, %D2D1_FIGURE_BEGIN_HOLLOW )
	End If

	sink.AddLine( pb )
	sink.AddLine( pRight )

	If params.isArea Then
		If  params.vLayout <> %ChartVLayoutType.Normal And params.j>params.lb2 Then
			pb.y = params.zero - yValues( params.i1, params.j-1 )
			If params.i1=params.lb1 Then
				pa.y = params.zero - yValues( params.ub1, params.j-1 )
			Else
				pa.y = params.zero - yValues( params.i1-1, params.j-1 )
			End If
			If params.i1>=params.ub1 Then
				pc.y = params.zero - yValues( params.lb1, params.j-1 )
			Else
				pc.y = params.zero - yValues( params.i1+1, params.j-1 )
			End If
			pLeft.y = (pa.y+pb.y)/2!
			pRight.y = (pc.y+pb.y)/2!
			sink.AddLine pRight
			sink.AddLine pb
			sink.AddLine pLeft
		Else
			pRight.y = params.zero
			sink.AddLine( pRight )
			pLeft.y = params.zero
			sink.AddLine( pLeft )
		End If
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Else
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If
End Sub

Sub ChartSymbol_SplineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local pa As D2D1_POINT_2F
	Local i As Long

	pa.x = -.5 + xValues(params.i1, params.j )
	pa.y = params.zero - yValues(params.i1, params.j )
	If params.isArea Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	End If

	For i=params.i1+1 To params.i2
		pa.x = -.5 + xValues( i, params.j  )
		pa.y = params.zero - yValues( i, params.j  )
		sink.AddLine( pa )
	Next

	If params.isArea Then
		If params.j = params.lb2 Then
			pa.y = params.zero
			sink.AddLine( pa )
			pa.x = -.5 + xValues( params.i1, params.j  )
			sink.AddLine( pa )
		Else
			For i=params.i2 To params.i1 Step -1
				pa.x = -.5 + xValues( i, params.j  )
				pa.y = params.zero - yValues( i, params.j-1  )
				sink.AddLine( pa )
			Next
		End If
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Else
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If
End Sub

Sub ChartSymbol_PlusFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	ChartSymbol_TickFigureAdd_c2d sink, xValues(), yValues(), params
	ChartSymbol_DashFigureAdd_c2d sink, xValues(), yValues(), params
End Sub

Sub ChartSymbol_DiamondFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 0, 0, center, params.size / 2!
End Sub

Sub ChartSymbol_SquareFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 45, 0, center, params.size / 2!
End Sub

Sub ChartSymbol_StarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F

	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner

	StarFigureAdd_c2d sink, 5, center, radius, 90, 0
End Sub

Sub ChartSymbol_PentagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 5, 90, 0, center, params.size / 2!
End Sub

Sub ChartSymbol_HexagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 6, 0, 0, center, params.size / 2!
End Sub

Sub ChartSymbol_PillFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PillFigureAdd_c2d sink, .5, params.size*.8, center
End Sub

Sub ChartSymbol_TriangleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 3, 90, 0, center, params.size / 2!
End Sub

Sub ChartSymbol_TombstoneFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	TombstoneFigureAdd_c2d sink, 0, params.size, center
End Sub

Sub ChartSymbol_HollowDiamondFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 0, 0, center, params.size / 2!, 1
End Sub

Sub ChartSymbol_HollowSquareFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 45, 0, center, params.size / 2!, 1
End Sub

Sub ChartSymbol_HollowStarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F

	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner

	StarFigureAdd_c2d sink, 5, center, radius, 90, 0, 1
End Sub

Sub ChartSymbol_HollowPentagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 5, 90, 0, center, params.size / 2!, 1
End Sub

Sub ChartSymbol_HollowHexagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 6, 0, 0, center, params.size / 2!, 1
End Sub

Sub ChartSymbol_HollowPillFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PillFigureAdd_c2d sink, 0, params.size*.8, center, 1
End Sub

Sub ChartSymbol_HollowTriangleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 3, 90, 0, center, params.size / 2!, 1
End Sub

Sub ChartSymbol_HollowTombstoneFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	TombstoneFigureAdd_c2d sink, 0, params.size, center, 1
End Sub


Sub ChartSymbol_CircleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	CircleFigureAdd_c2d sink, params.size/2, center, 1
End Sub


Sub ChartSymbol_Star4FigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner
	StarFigureAdd_c2d sink, 4, center, radius, 90, 0
End Sub

Sub ChartSymbol_HollowStar4FigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F
	center.x = -.5 + xValues( params.i1, params.j )
	center.y = params.zero - yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner
	StarFigureAdd_c2d sink, 4, center, radius, 90, 0, 1
End Sub


Sub ChartSymbol_SpikeFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	' Ignores isArea
	Local center As D2D1_POINT_2F
	Local boxSize As D2D1_SIZE_F
	Local z As Single
	If params.vLayout<>%ChartVLayoutType.Normal Then
		If params.j = params.lb2 Then
			z = 0
		Else
			z = yValues( params.i1, params.j-1 )
		End If
		boxSize.height = yValues( params.i1, params.j ) - z
		center.y = params.zero - (z + yValues( params.i1, params.j )) / 2!
	Else
		boxSize.height = yValues( params.i1, params.j )
		center.y = params.zero - boxSize.height / 2!
	End If
	If params.ub2=params.lb2 Or params.vLayout<>%ChartVLayoutType.Normal Then z = Max(params.barPadding, params.groupPadding) Else z=params.barPadding
	boxSize.width = 2! / params.display.width 'params.width - z
	center.x = -.5 + xValues( params.i1, params.j )
	BoxFigureAdd_c2d sink, 0, 0, center, boxSize
End Sub

Declare Sub ChartSymbolRender_internal( ByRef sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
Declare Function ChartSymbolCallback_internal( ByVal i As Long, params As ChartSymbolParams ) As Long

Sub ChartSymbolFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, params As ChartSymbolParams )
	Local p As ChartSymbolParams
	Local i, skipRender As Long
	p = params
	If p.symbolCallback Then
		' Allow user to modify pretty much anything in params. (Changing size could create "bubbles")
		If p.xCount>1 Then
			i = p.i1 / p.xCount
		Else
			i = p.i1
		End If
		Call Dword p.symbolCallback Using ChartSymbolCallback_internal( i, p ) To skipRender
		If params.symbolRender = CodePtr( ChartSymbol_SplineFigureAdd_c2d ) And p.symbolRender <> CodePtr( ChartSymbol_SplineFigureAdd_c2d ) Then
			p.i1 = (params.i1+params.i2)/2
		End If
		If params.symbolRender = CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d ) And p.symbolRender <> CodePtr( ChartRadarSymbol_SplineFigureAdd_c2d ) Then
			p.i1 = (params.i1+params.i2)/2
		End If
	End If

	' Add one symbol
	If p.symbolRender And skipRender=0 Then
		Call Dword p.symbolRender Using ChartSymbolRender_internal( sink, xValues(), yValues(), p )
	Else
		' Default symbol is point if none specified
		Call ChartSymbol_PointFigureAdd_c2d( sink, xValues(), yValues(), p )
	End If
End Sub

Sub ChartSpiderGridFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal groups As Long, ByVal lineSeparation As Single, Optional ByVal rotationDegrees As Single )
	Local pa, pb As D2D1_POINT_2F
	Local angle, angleStep, first, last As Single
	Local s As Single

	groups = Max( 1, groups )

	angleStep = DegreesToRadians( 360! / CSng( groups ) )
	first = DegreesToRadians( rotationDegrees+90 )
	last = first + PI2() - .001

	If groups > 1 Then
		' Draw rays
		For angle = first To last Step angleStep
			sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
			pb.x = Sin( angle ) * .5!
			pb.y = Cos( angle ) * .5!
			sink.AddLine( pb )
			sink.EndFigure( %D2D1_FIGURE_END_OPEN )
		Next
	End If

	For s = lineSeparation To .5001 Step lineSeparation
		For angle = first To last Step angleStep
			pa.x = Sin( angle ) * s
			pa.y = Cos( angle ) * s

			pb.x = Sin( angle + angleStep ) * s
			pb.y = Cos( angle + angleStep ) * s

			sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
			sink.AddLine( pb )
			sink.EndFigure( %D2D1_FIGURE_END_OPEN )
		Next
	Next
End Sub

Sub ChartRadarSymbol_SplineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center, pa As D2D1_POINT_2F
	Local i, j, i2 As Long

	pa.x = xValues( params.i1, params.j )
	pa.y = yValues( params.i1, params.j )

	If params.isArea Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	End If

	' Draw actual curve
	For i=params.i1+1 To params.i2
		If i>params.ub1 Then i2 = params.lb1 Else i2 = i
		pa.x = xValues( i2, params.j )
		pa.y = yValues( i2, params.j )
		sink.AddLine( pa )
	Next

	If params.isArea Then
		If params.j > params.lb2 Then
			' Drop to inner curve
			If params.i2>params.ub1 Then
				i2 = params.lb1
			Else
				i2 = params.i2
			End If
			pa.x = xValues( i2, params.j-1 )
			pa.y = yValues( i2, params.j-1 )
			sink.AddLine pa
			If i2=params.lb1 Then i2=params.ub1 Else i2-=1
			' Draw inner curve
			For i = i2 To params.i1 Step -1
				pa.x = xValues( i, params.j-1 )
				pa.y = yValues( i, params.j-1 )
				sink.AddLine( pa )
			Next
			' Close will snap back to start
		Else
			' Curvy pie slice
			sink.AddLine center
			' Close will snap back to start
		End If
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Else
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If
End Sub

Sub ChartRadarSymbol_PointFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	CircleFigureAdd_c2d sink, params.size/2, center
End Sub

Sub ChartRadarSymbol_CircleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	CircleFigureAdd_c2d sink, params.size/2, center, 1
End Sub


Sub ChartRadarSymbol_HollowStar4FigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner
	StarFigureAdd_c2d sink, 4, center, radius, 90, 0, 1
End Sub

Sub ChartRadarSymbol_Star4FigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner
	StarFigureAdd_c2d sink, 4, center, radius, 90, 0
End Sub

Sub ChartRadarSymbol_DiamondFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 0, 0, center, params.size / 2!
End Sub

Sub ChartRadarSymbol_SquareFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 45, 0, center, params.size / 2!
End Sub

Sub ChartRadarSymbol_StarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F

	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner

	StarFigureAdd_c2d sink, 5, center, radius, 90, 0
End Sub

Sub ChartRadarSymbol_PentagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 5, 90, 0, center, params.size / 2!
End Sub

Sub ChartRadarSymbol_HexagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 6, 0, 0, center, params.size / 2!
End Sub

Sub ChartRadarSymbol_PillFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PillFigureAdd_c2d sink, .5, params.size*.8, center
End Sub

Sub ChartRadarSymbol_TriangleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 3, 90, 0, center, params.size / 2!
End Sub

Sub ChartRadarSymbol_TombstoneFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	TombstoneFigureAdd_c2d sink, 0, params.size, center
End Sub

Sub ChartRadarSymbol_HollowDiamondFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 0, 0, center, params.size / 2!, 1
End Sub

Sub ChartRadarSymbol_HollowSquareFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 4, 45, 0, center, params.size / 2!, 1
End Sub

Sub ChartRadarSymbol_HollowStarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea / isStacked
	Local center As D2D1_POINT_2F
	Local radius As RadiusRange_F

	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	radius.outer = params.size / 2!  ' Use default for inner

	StarFigureAdd_c2d sink, 5, center, radius, 90, 0, 1
End Sub

Sub ChartRadarSymbol_HollowPentagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 5, 90, 0, center, params.size / 2!, 1
End Sub

Sub ChartRadarSymbol_HollowHexagonFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 6, 0, 0, center, params.size / 2!, 1
End Sub

Sub ChartRadarSymbol_HollowPillFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PillFigureAdd_c2d sink, 0, params.size*.8, center, 1
End Sub

Sub ChartRadarSymbol_HollowTriangleFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	PolygonFigureAdd_c2d sink, 3, 90, 0, center, params.size / 2!, 1
End Sub

Sub ChartRadarSymbol_HollowTombstoneFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local center As D2D1_POINT_2F
	center.x = xValues( params.i1, params.j )
	center.y = yValues( params.i1, params.j )
	TombstoneFigureAdd_c2d sink, 0, params.size, center, 1
End Sub

Sub ChartRadarSymbol_PlusFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	ChartRadarSymbol_TickFigureAdd_c2d sink, xValues(), yValues(), radius(), params
	ChartRadarSymbol_DashFigureAdd_c2d sink, xValues(), yValues(), radius(), params
End Sub

Sub ChartRadarSymbol_XFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	pa.x = xValues( params.i1, params.j ) - params.size / 2!
	pa.y = yValues( params.i1, params.j ) - params.size / 2!
	pb.x = pa.x + params.size
	pb.y = pa.y + params.size
	LineFigureAdd_c2d sink, pa, pb

	pa.x = xValues( params.i1, params.j ) + params.size / 2!
	pa.y = yValues( params.i1, params.j ) - params.size / 2!
	pb.x = pa.x - params.size
	pb.y = pa.y + params.size
	LineFigureAdd_c2d sink, pa, pb
End Sub

Sub ChartRadarSymbol_TickFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	Local r As Single
	r = params.radius + params.size / 2!
	pa.x = Sin( params.angle+1.570796326794897! ) * r
	pa.y = Cos( params.angle+1.570796326794897! ) * r
	r = params.radius - params.size / 2!
	pb.x = Sin( params.angle+1.570796326794897! ) * r
	pb.y = Cos( params.angle+1.570796326794897! ) * r
	LineFigureAdd_c2d sink, pa, pb
End Sub

Sub ChartRadarSymbol_DashFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	Local a, c As Single
	c = params.size / 2! / params.radius

	ArcRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius
End Sub

Sub ChartRadarSymbol_HLineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local c As Single
	Local wedgeParams As DonutPathParams
	c = params.width / 2!
	If params.isArea Then
		If params.vLayout<>%ChartVLayoutType.Normal Then
			If params.j=params.lb2 Then
				PieRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius
			Else
				'params.center.x           =
				'params.center.y           =
				wedgeParams.firstRadius.inner  = params.innerRadius
				wedgeParams.lastRadius.inner   = params.innerRadius

				wedgeParams.firstRadius.outer  = params.radius
				wedgeParams.lastRadius.outer   = params.radius

				wedgeParams.sweepDegrees.first = params.angle-c
				wedgeParams.sweepDegrees.last  = params.angle+c

				'params.chevronAmount      =

				DonutWedgeRadianFigureAdd_c2d sink, wedgeParams
			End If
		Else
			PieRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius
		End If
	Else
		ArcRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius
	End If
End Sub

Sub ChartRadarSymbol_StepFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local pa, pb As D2D1_POINT_2F
	Local r As Single
	Local c As Single

	If params.isArea Then
		ChartRadarSymbol_HLineFigureAdd_c2d sink, xValues(), yValues(), radius(), params
	Else
		c = params.width / 2!
		ArcRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius

		r = params.radius
		pa.x = Sin( params.angle+c+1.570796326794897! ) * r
		pa.y = Cos( params.angle+c+1.570796326794897! ) * r

		If params.i1 < params.ub1 Then
			r = radius( params.i1 + 1, params.j )
		Else
			r = radius( params.lb1, params.j )
		End If
		pb.x = Sin( params.angle+c+1.570796326794897! ) * r
		pb.y = Cos( params.angle+c+1.570796326794897! ) * r
		LineFigureAdd_c2d sink, pa, pb
	End If
End Sub

Sub ChartRadarSymbol_BarFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea
	Local c As Single
	Local wedgeParams As DonutPathParams

	c = params.size / 2!
	If params.vLayout = %ChartVLayoutType.Normal Or params.lb2 = params.j Then
		PieRadianFigureAdd_c2d sink, params.angle-c, params.angle+c, params.radius, params.radius
	Else
		'params.center.x           =
		'params.center.y           =
		wedgeParams.firstRadius.inner  = params.innerRadius
		wedgeParams.lastRadius.inner   = params.innerRadius

		wedgeParams.firstRadius.outer  = params.radius
		wedgeParams.lastRadius.outer   = params.radius

		wedgeParams.sweepDegrees.first = params.angle-c
		wedgeParams.sweepDegrees.last  = params.angle+c

		'params.chevronAmount      =

		DonutWedgeRadianFigureAdd_c2d sink, wedgeParams
	End If
End Sub

Sub ChartRadarSymbol_SpikeFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Ignores isArea
	Local c As Single
	Local wedgeParams As DonutPathParams
	Local p1, p2 As D2D1_POINT_2F

	c = params.size / 2!
	If Not (params.vLayout = %ChartVLayoutType.Normal Or params.lb2 = params.j) Then
		p1.x = Sin( (params.angle+90)*0.0174532925199433! ) * params.innerRadius
		p1.y = Cos( (params.angle+90)*0.0174532925199433! ) * params.innerRadius
	End If

	p2.x = Sin( (params.angle+90)*0.0174532925199433! ) * params.radius
	p2.y = Cos( (params.angle+90)*0.0174532925199433! ) * params.radius

	LineFigureAdd_c2d sink, p1, p2
End Sub


Sub ChartRadarSymbol_LineFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	' Drawing two lines Low y intercept to center, center to High y intercept
	Local p(), pa, pb As D2D1_POINT_2F
	Local i, j As Long
	If params.isArea Then
		If params.j = params.lb1 Then
			ReDim p(3)
		Else
			ReDim p(5)
		End If
	Else
		ReDim p(2)
	End If

	pb.x = xValues( params.i1, params.j )
	pb.y = yValues( params.i1, params.j )

	If params.i1=params.lb1 Then
		pa.x = xValues( params.ub1, params.j )
		pa.y = yValues( params.ub1, params.j )
	Else
		pa.x = xValues( params.i1-1, params.j )
		pa.y = yValues( params.i1-1, params.j )
	End If
	pa.x = (pa.x + pb.x)/2!
	pa.y = (pa.y + pb.y)/2!
	p(0) = pa
	p(1) = pb

	If params.i1>=params.ub1 Then
		pa.x = xValues( params.lb1, params.j )
		pa.y = yValues( params.lb1, params.j )
	Else
		pa.x = xValues( params.i1+1, params.j )
		pa.y = yValues( params.i1+1, params.j )
	End If

	pa.x = (pa.x + pb.x)/2!
	pa.y = (pa.y + pb.y)/2!
	p(2) = pa

	If params.isArea Then
		If params.j = params.lb2 Then
			p(3).x = 0
			p(3).y = 0
		Else
			pb.x = xValues( params.i1, params.j-1 )
			pb.y = yValues( params.i1, params.j-1 )

			If params.i1=params.ub1 Then
				pa.x = xValues( params.lb1, params.j-1 )
				pa.y = yValues( params.lb1, params.j-1 )
			Else
				pa.x = xValues( params.i1+1, params.j-1 )
				pa.y = yValues( params.i1+1, params.j-1 )
			End If
			pa.x = (pa.x + pb.x)/2!
			pa.y = (pa.y + pb.y)/2!
			p(3) = pa
			p(4) = pb

			If params.i1=params.lb1 Then
				pa.x = xValues( params.ub1, params.j-1 )
				pa.y = yValues( params.ub1, params.j-1 )
			Else
				pa.x = xValues( params.i1-1, params.j-1 )
				pa.y = yValues( params.i1-1, params.j-1 )
			End If
			pa.x = (pa.x + pb.x)/2!
			pa.y = (pa.y + pb.y)/2!
			p(5) = pa
		End If
	End If

	If params.isArea Then
		sink.BeginFigure( p(0), %D2D1_FIGURE_BEGIN_FILLED )
	Else
		sink.BeginFigure( p(0), %D2D1_FIGURE_BEGIN_HOLLOW )
	End If
	For i=1 To UBound( p() )
		sink.AddLine( p(i) )
	Next

	If params.isArea Then
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Else
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If
End Sub

Declare Sub ChartRadarSymbolRender_internal( ByRef sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
Declare Function ChartRadarSymbolCallback_internal( ByVal i As Long, params As ChartSymbolParams ) As Long

Sub ChartRadarSymbolFigureAdd_c2d( sink As ID2D1GeometrySink, xValues() As Single, yValues() As Single, radius() As Single, params As ChartSymbolParams )
	Local i, skipRender As Long
	If params.symbolCallback Then
		' Allow user to modify pretty much anything in params. (Changing size could create "bubbles")
		If params.xCount>1 Then
			i = params.i1 / params.xCount
		Else
			i = params.i1
		End If
		Call Dword params.symbolCallback Using ChartRadarSymbolCallback_internal( i, params ) To skipRender
	End If

	' Add one symbol
	If params.symbolRender And skipRender=0 Then
		Call Dword params.symbolRender Using ChartRadarSymbolRender_internal( sink, xValues(), yValues(), radius(), params )
	Else
		' Default symbol is point if none specified
		Call ChartRadarSymbol_PointFigureAdd_c2d( sink, xValues(), yValues(), radius(), params )
	End If
End Sub

Sub ChartRadarGridFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal groups As Long, ByVal lineSeparation As Single, Optional ByVal rotationDegrees As Single )
	Local pa, pb As D2D1_POINT_2F
	Local angle, angleStep, first, last As Single
	Local s As Single

	groups = Max( 1, groups )

	If groups > 1 Then
		' Draw rays
		angleStep = DegreesToRadians( 360! / CSng( groups ) )
		first = DegreesToRadians( rotationDegrees+90 )
		last = first + PI2() - .001
		For angle = first To last Step angleStep
			sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
			pb.x = Sin( angle ) * .5!
			pb.y = Cos( angle ) * .5!
			sink.AddLine( pb )
			sink.EndFigure( %D2D1_FIGURE_END_OPEN )
		Next
	End If

	For s = lineSeparation To .5001 Step lineSeparation
		pa.x = Sin( 1.570796326794897! ) * s
		pa.y = Cos( 1.570796326794897! ) * s
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		ArcRadiansStroke_c2d sink, 0, PI2(), s
		sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	Next
End Sub

Sub ChartGridFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal drawZero As Long, ByVal zeroOffset As Single, ByVal divisions As Single )
	Local pa As D2D1_POINT_2F
	Local y, zero, first, last, lineSeparation As Single

	' Draws horizontal grid lines in a unit square
	' Rotate -90 for Vertical lines

	zeroOffset = Max( 0!, Min( 1!, zeroOffset ) )

	zero = .5 - zeroOffset

	If drawZero Then
		pa.x = -.5
		pa.y = zero
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		pa.x = .5
		sink.AddLine( pa )
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If

	If divisions > 0 Then
		If zeroOffset <.5 Then
			lineSeparation = (1 - zeroOffset) / divisions
		Else
			lineSeparation = zeroOffset / divisions
		End If
		first = zero - Fix( (zero + .5) / lineSeparation) * lineSeparation
		last = zero + Fix( (.5 - zero) / lineSeparation ) * lineSeparation
		For y = first To last+.001 Step lineSeparation
			If y <> zero Then
				pa.x = -.5
				pa.y = y
				sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
				pa.x = .5
				sink.AddLine( pa )
				sink.EndFigure( %D2D1_FIGURE_END_OPEN )
			End If
		Next
		pa.x = -.5
		pa.y = -.5
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		pa.x = .5
		sink.AddLine( pa )
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )

		pa.x = -.5
		pa.y = .5
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
		pa.x = .5
		sink.AddLine( pa )
		sink.EndFigure( %D2D1_FIGURE_END_OPEN )
	End If
End Sub

Sub CalendarFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.1926772 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -1.861409E-2 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.861409E-2 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1926772 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y +  .25832 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y +  .351577 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y +  6.488892E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y +  .2168638 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .375652 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2549625 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2135063 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  2.282651E-2 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.1926772 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -1.861409E-2 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -1.861409E-2 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1926772 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y + -7.847606E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2341333 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3860047 * fSize.width
	pa.y = center.y +  2.343274E-2 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.4274556 * fSize.width
	pa.y = center.y + -.1199307 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.4274556 * fSize.width
	pa.y = center.y +  .3930254 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4171032 * fSize.width
	pa.y = center.y +  .3930254 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .4171032 * fSize.width
	pa.y = center.y + -.1199307 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.5 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x + -.3066778 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.3066778 * fSize.width
	pa.y = center.y + -.2579456 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3066778 * fSize.width
	bez.point1.y = center.y + -.2064704 * fSize.height
	bez.point2.x = center.x + -.264861 * fSize.width
	bez.point2.y = center.y + -.16462 * fSize.height
	bez.point3.x = center.x + -.2134519 * fSize.width
	bez.point3.y = center.y + -.16462 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1620024 * fSize.width
	bez.point1.y = center.y + -.16462 * fSize.height
	bez.point2.x = center.x + -.1201483 * fSize.width
	bez.point2.y = center.y + -.2064704 * fSize.height
	bez.point3.x = center.x + -.1201483 * fSize.width
	bez.point3.y = center.y + -.2579456 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1201483 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1409463 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1409463 * fSize.width
	pa.y = center.y + -.2579456 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1409463 * fSize.width
	bez.point1.y = center.y + -.2064704 * fSize.height
	bez.point2.x = center.x +  .1828022 * fSize.width
	bez.point2.y = center.y + -.16462 * fSize.height
	bez.point3.x = center.x +  .2342538 * fSize.width
	bez.point3.y = center.y + -.16462 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2856868 * fSize.width
	bez.point1.y = center.y + -.16462 * fSize.height
	bez.point2.x = center.x +  .3275224 * fSize.width
	bez.point2.y = center.y + -.2064704 * fSize.height
	bez.point3.x = center.x +  .3275224 * fSize.width
	bez.point3.y = center.y + -.2579456 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .3275224 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y + -.3281131 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y +  .456865 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.5 * fSize.width
	pa.y = center.y +  .456865 * fSize.height
	sink.AddLine pa

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x +  .2342616 * fSize.width
	pa.y = center.y + -.4568651 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .2572052 * fSize.width
	bez.point1.y = center.y + -.4568651 * fSize.height
	bez.point2.x = center.x +  .2757139 * fSize.width
	bez.point2.y = center.y + -.4383314 * fSize.height
	bez.point3.x = center.x +  .2757139 * fSize.width
	bez.point3.y = center.y + -.4154565 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2757139 * fSize.width
	pa.y = center.y + -.2579435 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2757139 * fSize.width
	bez.point1.y = center.y + -.2349688 * fSize.height
	bez.point2.x = center.x +  .2572052 * fSize.width
	bez.point2.y = center.y + -.2164286 * fSize.height
	bez.point3.x = center.x +  .2342616 * fSize.width
	bez.point3.y = center.y + -.2164286 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2113616 * fSize.width
	bez.point1.y = center.y + -.2164286 * fSize.height
	bez.point2.x = center.x +  .1927704 * fSize.width
	bez.point2.y = center.y + -.2349688 * fSize.height
	bez.point3.x = center.x +  .1927704 * fSize.width
	bez.point3.y = center.y + -.2579435 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1927704 * fSize.width
	pa.y = center.y + -.4154565 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .1927704 * fSize.width
	bez.point1.y = center.y + -.4383314 * fSize.height
	bez.point2.x = center.x +  .2113616 * fSize.width
	bez.point2.y = center.y + -.4568651 * fSize.height
	bez.point3.x = center.x +  .2342616 * fSize.width
	bez.point3.y = center.y + -.4568651 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2134449 * fSize.width
	pa.y = center.y + -.4568651 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x + -.1905263 * fSize.width
	bez.point1.y = center.y + -.4568651 * fSize.height
	bez.point2.x = center.x + -.1719568 * fSize.width
	bez.point2.y = center.y + -.4383314 * fSize.height
	bez.point3.x = center.x + -.1719568 * fSize.width
	bez.point3.y = center.y + -.4154565 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1719568 * fSize.width
	pa.y = center.y + -.2579435 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1719568 * fSize.width
	bez.point1.y = center.y + -.2349688 * fSize.height
	bez.point2.x = center.x + -.1905263 * fSize.width
	bez.point2.y = center.y + -.2164286 * fSize.height
	bez.point3.x = center.x + -.2134449 * fSize.width
	bez.point3.y = center.y + -.2164286 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2362841 * fSize.width
	bez.point1.y = center.y + -.2164286 * fSize.height
	bez.point2.x = center.x + -.2548537 * fSize.width
	bez.point2.y = center.y + -.2349688 * fSize.height
	bez.point3.x = center.x + -.2548537 * fSize.width
	bez.point3.y = center.y + -.2579435 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2548537 * fSize.width
	pa.y = center.y + -.4154565 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2548537 * fSize.width
	bez.point1.y = center.y + -.4383314 * fSize.height
	bez.point2.x = center.x + -.2362841 * fSize.width
	bez.point2.y = center.y + -.4568651 * fSize.height
	bez.point3.x = center.x + -.2134449 * fSize.width
	bez.point3.y = center.y + -.4568651 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function CalendarPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	CalendarFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function


Sub BubbleFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x + -.2025357 * fSize.width
	pa.y = center.y + -.257925 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x + -.2394014 * fSize.width
	bez.point1.y = center.y + -.257925 * fSize.height
	bez.point2.x = center.x + -.2694311 * fSize.width
	bez.point2.y = center.y + -.2278953 * fSize.height
	bez.point3.x = center.x + -.2694311 * fSize.width
	bez.point3.y = center.y + -.1910109 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2694311 * fSize.width
	pa.y = center.y +  .2146093 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2694311 * fSize.width
	bez.point1.y = center.y +  .2514937 * fSize.height
	bez.point2.x = center.x + -.2394014 * fSize.width
	bez.point2.y = center.y +  .2815234 * fSize.height
	bez.point3.x = center.x + -.2025357 * fSize.width
	bez.point3.y = center.y +  .2815234 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  7.629298E-2 * fSize.width
	pa.y = center.y +  .2815234 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1675634 * fSize.width
	pa.y = center.y +  .3797687 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .2658293 * fSize.width
	pa.y = center.y +  .2815234 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3661716 * fSize.width
	pa.y = center.y +  .2815234 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .4030748 * fSize.width
	bez.point1.y = center.y +  .2815234 * fSize.height
	bez.point2.x = center.x +  .4330858 * fSize.width
	bez.point2.y = center.y +  .2514937 * fSize.height
	bez.point3.x = center.x +  .4330858 * fSize.width
	bez.point3.y = center.y +  .2146093 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .4330858 * fSize.width
	pa.y = center.y + -.1910109 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .4330858 * fSize.width
	bez.point1.y = center.y + -.2278953 * fSize.height
	bez.point2.x = center.x +  .4030748 * fSize.width
	bez.point2.y = center.y + -.257925 * fSize.height
	bez.point3.x = center.x +  .3661716 * fSize.width
	bez.point3.y = center.y + -.257925 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.2025357 * fSize.width
	pa.y = center.y + -.3248203 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .3661716 * fSize.width
	pa.y = center.y + -.3248203 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .4400843 * fSize.width
	bez.point1.y = center.y + -.3248203 * fSize.height
	bez.point2.x = center.x +  .5 * fSize.width
	bez.point2.y = center.y + -.264925 * fSize.height
	bez.point3.x = center.x +  .5 * fSize.width
	bez.point3.y = center.y + -.1910109 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y +  .2146093 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .5 * fSize.width
	bez.point1.y = center.y +  .2885218 * fSize.height
	bez.point2.x = center.x +  .4400843 * fSize.width
	bez.point2.y = center.y +  .3484187 * fSize.height
	bez.point3.x = center.x +  .3661716 * fSize.width
	bez.point3.y = center.y +  .3484187 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .312134 * fSize.width
	pa.y = center.y +  .3484187 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .173826 * fSize.width
	pa.y = center.y +  .4884922 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  3.558198E-2 * fSize.width
	pa.y = center.y +  .3484187 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.2025357 * fSize.width
	pa.y = center.y +  .3484187 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.2764311 * fSize.width
	bez.point1.y = center.y +  .3484187 * fSize.height
	bez.point2.x = center.x + -.3363437 * fSize.width
	bez.point2.y = center.y +  .2885218 * fSize.height
	bez.point3.x = center.x + -.3363437 * fSize.width
	bez.point3.y = center.y +  .2146093 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3363437 * fSize.width
	pa.y = center.y + -.1910109 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.3363437 * fSize.width
	bez.point1.y = center.y + -.264925 * fSize.height
	bez.point2.x = center.x + -.2764311 * fSize.width
	bez.point2.y = center.y + -.3248203 * fSize.height
	bez.point3.x = center.x + -.2025357 * fSize.width
	bez.point3.y = center.y + -.3248203 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
	pa.x = center.x + -.3661924 * fSize.width
	pa.y = center.y + -.4884922 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	pa.x = center.x +  .2080661 * fSize.width
	pa.y = center.y + -.4884922 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .2598643 * fSize.width
	bez.point1.y = center.y + -.4884922 * fSize.height
	bez.point2.x = center.x +  .3046642 * fSize.width
	bez.point2.y = center.y + -.459033 * fSize.height
	bez.point3.x = center.x +  .3269219 * fSize.width
	bez.point3.y = center.y + -.4160223 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3578291 * fSize.width
	pa.y = center.y + -.4160223 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.399394 * fSize.width
	bez.point1.y = center.y + -.4160223 * fSize.height
	bez.point2.x = center.x + -.4330853 * fSize.width
	bez.point2.y = center.y + -.3823308 * fSize.height
	bez.point3.x = center.x + -.4330853 * fSize.width
	bez.point3.y = center.y + -.3407239 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.4330853 * fSize.width
	pa.y = center.y +  .1680859 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.4730616 * fSize.width
	bez.point1.y = center.y +  .1449546 * fSize.height
	bez.point2.x = center.x + -.5 * fSize.width
	bez.point2.y = center.y +  .101842 * fSize.height
	bez.point3.x = center.x + -.5 * fSize.width
	bez.point3.y = center.y +  .0523419 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.5 * fSize.width
	pa.y = center.y + -.3546819 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.5 * fSize.width
	bez.point1.y = center.y + -.4285745 * fSize.height
	bez.point2.x = center.x + -.4401043 * fSize.width
	bez.point2.y = center.y + -.4884922 * fSize.height
	bez.point3.x = center.x + -.3661924 * fSize.width
	bez.point3.y = center.y + -.4884922 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function BubblePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	BubbleFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub BoxFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal roundRadiusX As Single, Optional ByVal roundRadiusY As Single, Optional center As D2D1_POINT_2F, Optional boxSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local pa As D2D1_POINT_2F
	Local w, h, x, y, rrx, rry As Single

	If roundRadiusX = 0! And roundRadiusY <> 0! Then roundRadiusX = roundRadiusY
	If roundRadiusY = 0! And roundRadiusX <> 0! Then roundRadiusY = roundRadiusX

	w = 1!
	h = 1!
	x = 0
	y = 0
	If Not IsMissing( center ) Then
		x = center.x
		y = center.y
	End If
	If Not IsMissing( boxSize ) Then
		w = boxSize.width
		h = boxSize.height
	End If

	If h<0 Then     h = -h
	rrx *= .5!
	rrx = Min( Max( 0!, roundRadiusX ), w*.5! )
	rry *= .5!
	rry = Min( Max( 0!, roundRadiusY ), h*.5! )
	' top / left (down around radius if any)
	pa.x = x - w/2!
	pa.y = y - h/2! + rry
	If isHollow Then
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	Else
		sink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
	End If

	If rrx > 0! Or rry > 0! Then
		' round upper left corner
		pa.x += rrx
		pa.y -= rry
		BoxArc_internal_c2d( sink, pa, rrx, rry )
	End If
	' line to upper right
	pa.x += w - rrx*2
	sink.AddLine( pa )
	If rrx > 0! Or rry > 0! Then
		' round upper right corner
		pa.x += rrx
		pa.y += rry
		BoxArc_internal_c2d( sink, pa, rrx, rry )
	End If
	' Right edge
	pa.y += h - rry*2
	sink.AddLine( pa )
	If rrx > 0! Or rry >0! Then
		' round bottom right corner
		pa.x -= rrx
		pa.y += rry
		BoxArc_internal_c2d( sink, pa, rrx, rry )
	End If

	' Bottom edge
	pa.x -= (w - rrx*2)
	sink.AddLine( pa )

	If rrx > 0! Or rry > 0! Then
		' round bottom right corner
		pa.x -= rrx
		pa.y -= rry
		BoxArc_internal_c2d( sink, pa, rrx, rry )
	End If

	' and back to start
	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Sub BoxArc_internal_c2d( sink As ID2D1GeometrySink, pt As D2D1_POINT_2F, ByVal rrx As Single, ByVal rry As Single )
	Local dot As D2D1_ARC_SEGMENT
	dot.point            = pt
	dot.size.width       = rrx
	dot.size.height      = rry
	dot.rotationAngle    = 0
	dot.sweepDirection   = %D2D1_SWEEP_DIRECTION_CLOCKWISE
	dot.arcSize          = %D2D1_ARC_SIZE_SMALL
	sink.AddArc( dot )
End Sub

Sub AttachmentFigureAdd_c2d( sink As ID2D1GeometrySink, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long )
	Local darc As D2D1_ARC_SEGMENT
	Local bez As D2D1_BEZIER_SEGMENT
	Local qbez As D2D1_QUADRATIC_BEZIER_SEGMENT
	Local pa As D2D1_POINT_2F

	If fSize.width = 0! Then fSize.width = 1!
	If fSize.height = 0! Then fSize.height = 1!
	pa.x = center.x +  .2362851 * fSize.width
	pa.y = center.y + -.4359553 * fSize.height
	If isHollow Then
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW
	Else
		sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_FILLED
	End If

	bez.point1.x = center.x +  .2923838 * fSize.width
	bez.point1.y = center.y + -.4352625 * fSize.height
	bez.point2.x = center.x +  .3463084 * fSize.width
	bez.point2.y = center.y + -.4201025 * fSize.height
	bez.point3.x = center.x +  .3877786 * fSize.width
	bez.point3.y = center.y + -.3898578 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .4826773 * fSize.width
	bez.point1.y = center.y + -.3207759 * fSize.height
	bez.point2.x = center.x +  .4766888 * fSize.width
	bez.point2.y = center.y + -.1988962 * fSize.height
	bez.point3.x = center.x +  .3745745 * fSize.width
	bez.point3.y = center.y + -.1177898 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .2637442 * fSize.width
	pa.y = center.y + -2.981056E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .264011 * fSize.width
	pa.y = center.y + -2.949446E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -2.030762E-2 * fSize.width
	pa.y = center.y +  .1962727 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -6.965355E-2 * fSize.width
	bez.point1.y = center.y +  .2354208 * fSize.height
	bez.point2.x = center.x + -.1468561 * fSize.width
	bez.point2.y = center.y +  .2402463 * fSize.height
	bez.point3.x = center.x + -.1927823 * fSize.width
	bez.point3.y = center.y +  .2068653 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.2385991 * fSize.width
	bez.point1.y = center.y +  .173495 * fSize.height
	bez.point2.x = center.x + -.2358196 * fSize.width
	bez.point2.y = center.y +  .1145234 * fSize.height
	bez.point3.x = center.x + -.1863643 * fSize.width
	bez.point3.y = center.y +  7.530329E-2 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .098061 * fSize.width
	pa.y = center.y + -.1505746 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1667089 * fSize.width
	pa.y = center.y + -.1003857 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.1176644 * fSize.width
	pa.y = center.y +  .1254321 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.1229034 * fSize.width
	bez.point1.y = center.y +  .1295334 * fSize.height
	bez.point2.x = center.x + -.1241317 * fSize.width
	bez.point2.y = center.y +  .1341148 * fSize.height
	bez.point3.x = center.x + -.1243465 * fSize.width
	bez.point3.y = center.y +  .1370957 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.1245612 * fSize.width
	bez.point1.y = center.y +  .1401247 * fSize.height
	bez.point2.x = center.x + -.1236529 * fSize.width
	bez.point2.y = center.y +  .14449 * fSize.height
	bez.point3.x = center.x + -.1187341 * fSize.width
	bez.point3.y = center.y +  .1480551 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x + -.110929 * fSize.width
	bez.point1.y = center.y +  .1538036 * fSize.height
	bez.point2.x = center.x + -9.750883E-2 * fSize.width
	bez.point2.y = center.y +  .1529526 * fSize.height
	bez.point3.x = center.x + -8.906222E-2 * fSize.width
	bez.point3.y = center.y +  .1462479 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .1796449 * fSize.width
	pa.y = center.y + -.0672288 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .1793795 * fSize.width
	pa.y = center.y + -6.738751E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .3057132 * fSize.width
	pa.y = center.y + -.1678159 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  .3670362 * fSize.width
	bez.point1.y = center.y + -.2164643 * fSize.height
	bez.point2.x = center.x +  .3706706 * fSize.width
	bez.point2.y = center.y + -.2896949 * fSize.height
	bez.point3.x = center.x +  .3137864 * fSize.width
	bez.point3.y = center.y + -.3310479 * fSize.height
	sink.AddBezier bez

	bez.point1.x = center.x +  .2569008 * fSize.width
	bez.point1.y = center.y + -.37256 * fSize.height
	bez.point2.x = center.x +  .1609351 * fSize.width
	bez.point2.y = center.y + -.366764 * fSize.height
	bez.point3.x = center.x +  .0997175 * fSize.width
	bez.point3.y = center.y + -.3180617 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.3508725 * fSize.width
	pa.y = center.y +  4.400294E-2 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.4106981 * fSize.width
	bez.point1.y = center.y +  9.164168E-2 * fSize.height
	bez.point2.x = center.x + -.4149745 * fSize.width
	bez.point2.y = center.y +  .1624796 * fSize.height
	bez.point3.x = center.x + -.3621 * fSize.width
	bez.point3.y = center.y +  .2043605 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.1930477 * fSize.width
	pa.y = center.y +  .3335218 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.135894 * fSize.width
	bez.point1.y = center.y +  .3722685 * fSize.height
	bez.point2.x = center.x + -4.265587E-2 * fSize.width
	bez.point2.y = center.y +  .3659758 * fSize.height
	bez.point3.x = center.x +  1.738271E-2 * fSize.width
	bez.point3.y = center.y +  .3183158 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  .4327432 * fSize.width
	pa.y = center.y + -1.262257E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  .5 * fSize.width
	pa.y = center.y +  3.868663E-2 * fSize.height
	sink.AddLine pa

	pa.x = center.x +  8.608396E-2 * fSize.width
	pa.y = center.y +  .36851 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.0144258 * fSize.width
	bez.point1.y = center.y +  .4481746 * fSize.height
	bez.point2.x = center.x + -.1701126 * fSize.width
	bez.point2.y = center.y +  .4584325 * fSize.height
	bez.point3.x = center.x + -.2654901 * fSize.width
	bez.point3.y = center.y +  .393199 * fSize.height
	sink.AddBezier bez

	pa.x = center.x + -.2661864 * fSize.width
	pa.y = center.y +  .3936057 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4379649 * fSize.width
	pa.y = center.y +  .2623185 * fSize.height
	sink.AddLine pa

	pa.x = center.x + -.4374297 * fSize.width
	pa.y = center.y +  .261949 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x + -.5269283 * fSize.width
	bez.point1.y = center.y +  .1922795 * fSize.height
	bez.point2.x = center.x + -.519924 * fSize.width
	bez.point2.y = center.y +  .0735961 * fSize.height
	bez.point3.x = center.x + -.4195722 * fSize.width
	bez.point3.y = center.y + -6.07655E-3 * fSize.height
	sink.AddBezier bez

	pa.x = center.x +  3.096557E-2 * fSize.width
	pa.y = center.y + -.3681944 * fSize.height
	sink.AddLine pa

	bez.point1.x = center.x +  8.843402E-2 * fSize.width
	bez.point1.y = center.y + -.4138216 * fSize.height
	bez.point2.x = center.x +  .1641574 * fSize.width
	bez.point2.y = center.y + -.4368461 * fSize.height
	bez.point3.x = center.x +  .2362851 * fSize.width
	bez.point3.y = center.y + -.4359553 * fSize.height
	sink.AddBezier bez

	sink.EndFigure( %D2D1_FIGURE_END_CLOSED )
End Sub

Function AttachmentPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal center As D2D1_POINT_2F, Optional ByVal fSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	AttachmentFigureAdd_c2d sink, center, fSize, isHollow

	sink.Close
	Function = -1
End Function

Sub ArcFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	startAngle = DegreesToRadians( startAngle )
	endAngle = DegreesToRadians( endAngle )
	ArcRadianFigureAdd_c2d sink, startAngle, endAngle, startRadius, endRadius, center
End Sub

Sub ArcRadianFigureAdd_c2d( sink As ID2D1GeometrySink, ByVal startAngle As Single, ByVal endAngle As Single, Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F )
	Local pa As D2D1_POINT_2F
	Local sr As Single

	sr = startRadius

	If sr = 0! Then sr = .5!
	If endRadius = 0! Then endRadius = sr

	pa.x = center.x + Sin( ( startAngle + 1.570796326794897! ) ) * sr
	pa.y = center.y + Cos( ( startAngle + 1.570796326794897! ) ) * sr
	sink.BeginFigure pa, %D2D1_FIGURE_BEGIN_HOLLOW

	ArcRadiansStroke_c2d sink, startAngle, endAngle, startRadius, endRadius, center
	sink.EndFigure( %D2D1_FIGURE_END_OPEN )
End Sub

Function TombstonePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal thickness As Single, Optional ByVal scaleTombstone As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	TombstoneFigureAdd_c2d sink, thickness, scaleTombstone, center, isHollow

	sink.Close
	Function = -1
End Function

Function StarPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, pointCount As Long, Optional ByVal center As D2D1_POINT_2F, _
													Optional ByVal radius As RadiusRange_F, Optional ByVal rotation As Single, Optional ByVal roundness As Single, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	StarFigureAdd_c2d sink, pointCount, center, radius, rotation, roundness, isHollow

	sink.Close
	Function = -1
End Function

Function ReticleArcPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, params As ReticleArcSinkParams ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ReticleArcFigureAdd_c2d sink, params

	sink.Close
	Function = -1
End Function

Function ReticlePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, params As ReticleSinkParams ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ReticleFigureAdd_c2d sink, params

	sink.Close
	Function = -1
End Function

Type PuzzleSidesParams_internal
	leftOut As Long
	topOut As Long
	rightOut As Long
	bottomOut As Long
End Type

Sub PuzzlePiecePathNew_c2d( obj As ID2D1PathGeometry, factory As ID2D1Factory, sides As Long, Optional ByVal isHollow As Long, Optional ByVal center As D2D1_POINT_2F, Optional ByVal sideSize As D2D1_SIZE_F )
	' Make a puzzle piece.  for sides, bit 0=top, 1=right, 2=bottom, 3=left (start with top, move clockwise)
	Local hr As Long
	Local a,b,c,d As Long
	Local sink As ID2D1GeometrySink

	obj = Nothing
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Sub
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Sub

	a = Bit(sides, 0 )
	b = Bit(sides, 1 )
	c = Bit(sides, 2 )
	d = Bit(sides, 3 )
	PuzzlePieceFigureAdd_c2d sink, d, a, b, c, isHollow, center, sideSize
	sink.Close
End Sub

Sub PuzzlePathNew_c2d( obj As ID2D1PathGeometry, factory As ID2D1Factory, ByVal gridSize As Long, Optional ByVal isHollow As Long )
	' Creates a single path with all pieces, useful if just a visual
	Dim sd(gridSize-1,gridSize-1) As Local PuzzleSidesParams_internal
	Local i, j, hr As Long
	Local sw, sh As Single
	Local sink As ID2D1GeometrySink
	Local center As D2D1_POINT_2F
	Local sideSize As D2D1_SIZE_F

	obj = Nothing
	gridSize = Max( 1, gridSize )
	Randomize

	' Generate random sides
	For i=0 To gridSize-1
		For j=0 To gridSize-1
			sd(i,j).leftOut=Rnd(0,1)
			sd(i,j).topOut=Rnd(0,1)
			sd(i,j).rightOut=Rnd(0,1)
			sd(i,j).bottomOut =Rnd(0,1)
		Next
	Next

	' Set edges match similar sides
	For i = 0 To gridSize-1
		' y
		For j = 0 To gridSize-1
			' x
			If IsFalse i Then
				' Top Edge
				sd(i,j).topOut=-1
			Else
				' Top matches bottom above
				sd(i,j).topOut = -(sd(i-1,j).bottomOut-1)
			End If
			If i=gridSize-1 Then
				' Bottom Edge
				sd(i,j).bottomOut=-1
			End If
			If IsFalse j Then
				' Left edge
				sd(i,j).leftOut=-1
			Else
				' Left edge matches right side of piece to the left
				sd(i,j).leftOut = -(sd(i,j-1).rightOut-1)
			End If
			If j=gridSize-1 Then
				' Right edge
				sd(i,j).rightOut=-1
			End If
		Next
	Next

	sw = 1! / CSng(gridSize)
	sh = 1! / CSng(gridSize)
	sideSize.width = sw
	sideSize.height = sh

	Local ps As PuzzleSidesParams_internal
	' Add puzzle pieces
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Sub
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Sub
	For i=0 To gridSize-1
		' y
		For j=0 To gridSize-1
			' x
			ps = sd(i,j)
			ps.leftOut = ps.LeftOut
			ps.topOut = ps.TopOut
			ps.rightOut = ps.RightOut
			ps.bottomOut = ps.bottomOut
			center.x = -.5 + (j+.5)*sw
			center.y = -.5 + (i+.5)*sh
			PuzzlePieceFigureAdd_c2d sink, sd(i,j).leftOut, sd(i,j).topOut, sd(i,j).rightOut, sd(i,j).bottomOut, isHollow, center, sideSize
		Next
	Next
	sink.Close
End Sub

Function PolygonPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal sides As Long, Optional ByVal rotationDegrees As Single, Optional ByVal roundness As Single, _
			Optional ByVal center As D2D1_POINT_2F, Optional ByVal radius As Single, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PolygonFigureAdd_c2d sink, sides, rotationDegrees, roundness, center, radius, isHollow

	sink.Close
	Function = -1
End Function

Function PlusPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal scaleFigure As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PlusFigureAdd_c2d sink, scaleFigure, center, isHollow

	sink.Close
	Function = -1
End Function

Function PillPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, Optional ByVal thickness As Single, Optional ByVal scalePill As Single, Optional ByVal center As D2D1_POINT_2F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PillFigureAdd_c2d sink, thickness, scalePill, center, isHollow

	sink.Close
	Function = -1
End Function

Function PiePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal startAngle As Single, ByVal endAngle As Single, _
												Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	PieFigureAdd_c2d sink, startAngle, endAngle, startRadius, endRadius, center

	sink.Close
	Function = -1
End Function

Function NeedleThinPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	NeedleThinFigureAdd_c2d sink, angle, baseRadius, isSoft

	sink.Close
	Function = -1
End Function

Function NeedleMidPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	NeedleMidFigureAdd_c2d sink, angle, baseRadius, isSoft

	sink.Close
	Function = -1
End Function

Function NeedleThickPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal angle As Single, Optional ByVal baseRadius As Single, Optional ByVal isSoft As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	NeedleThickFigureAdd_c2d sink, angle, baseRadius, isSoft

	sink.Close
	Function = -1
End Function

Function NeedlePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, params As NeedlePathParams ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	NeedleFigureAdd_c2d sink, params

	sink.Close
	Function = -1
End Function

Type MazeCells_internal
	bottomWall As Long
	rightWall As Long
	visited As Long
End Type


Function MazePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, param As MazePathParams ) As Long
	'ByVal helper As ID2D1Helper,
	Local hr, x, y, s As Long
	Local l, t, r, b As Single
	'Local xl, yl As Single
	Local cells() As MazeCells_internal
	Local localSink As ID2D1GeometrySink

	Local pa, pb As D2D1_POINT_2F

	obj = Nothing
	If param.size.width = 0! Then param.size.width = 1!
	If param.size.height = 0! Then param.size.height = 1!

	Randomize
	ReDim cells( param.cellsX, param.cellsY )

	' Clear maze
	For y=0 To param.cellsY-1
		For x=0 To param.cellsX-1
			cells(x,y).rightWall  = -1
			cells(x,y).bottomWall = -1
			cells(x,y).visited    =  0
		Next
	Next

	Call MazeGenerate_internal_c2d( cells(), 0, 0, param.cellsX, param.cellsY )

	' Draw maze
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function

	hr = factory.CreatePathGeometry( obj )
	If FAILED( hr ) Then Exit Function

	hr = obj.Open( localSink )
	If FAILED( hr ) Then Exit Function

	Local dx, dy As Single
	dx = param.size.width / param.cellsX
	dy = param.size.height / param.cellsY

	' Draw outside box
	pa.x = param.size.width - param.size.width*.5!
	pa.y = 0 - param.size.height*.5!
	'pa = helper.Point2F( param.w, 0 )
	localSink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
	pa.x = 0 - param.size.width*.5!
	'pa = helper.Point2F( 0, 0 )
	localSink.AddLine( pa )
	pa.y = param.size.height - param.size.height*.5!
	'pa = helper.Point2F( 0, param.h )
	localSink.AddLine( pa )
	pa.x = param.size.width - param.size.width*.5!
	'pa = helper.Point2F( param.w, param.h )
	localSink.AddLine( pa )
	pa.y = 0 - param.size.height*.5!
	'pa = helper.Point2F( param.w, 0 )
	localSink.AddLine( pa )
	localSink.EndFigure( %D2D1_FIGURE_END_OPEN )

	For y = 0 To param.cellsY-1
		For x = 0 To param.cellsX - 1

			l = x * dx - param.size.width*.5!
			t = y * dy - param.size.height*.5!
			r = l + dx
			b = t + dy

			If cells(x,y).rightWall Then
				pa.x = r
				pa.y = t
				'pa = helper.Point2F( r, t )
				localSink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
				pa.x = r
				pa.y = b
				'pa = helper.Point2F( r, b )
				localSink.AddLine( pa )
				localSink.EndFigure( %D2D1_FIGURE_END_OPEN )
			End If

			If cells(x,y).bottomWall Then
				pa.x = l
				pa.y = b
				'pa = helper.Point2F( l, b )
				localSink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_HOLLOW )
				pa.x = r
				pa.y = b
				'pa = helper.Point2F( r, b )
				localSink.AddLine( pa )
				localSink.EndFigure( %D2D1_FIGURE_END_OPEN )
			End If
		Next x
	Next y
	localSink.Close
	Function = -1
End Function

Sub MazeGenerate_internal_c2d( ByRef cells() As MazeCells_internal, ByVal x As Long, ByVal y As Long, ByVal mazeRows As Long, ByVal mazeCols As Long )
	Dim list(3) As Long
	Local neighbor As Long
	Local nx As Long
	Local ny As Long
	Local i As Long
	Local j As Long
	Local found As Long

	cells(x, y).visited = -1
	For i = 0 To 3
		Do
			nx = Rnd(1, 4)
			found = 0
			For j=0 To i-1
				If nx=list(j) Then found=-1: Exit For
			Next
		Loop While found
		list(i) = nx
	Next
	For i = 0 To 3
		neighbor = list(i)
		nx = x
		ny = y
		Select Case neighbor
			Case 1 : Decr nx
			Case 2 : Incr nx
			Case 3 : Decr ny
			Case 4 : Incr ny
		End Select
		If nx >= 0 And nx < mazeCols And ny >= 0 And ny < mazeRows And Not cells(nx, ny).visited Then
			Select Case neighbor
				Case 1 : cells(nx, ny).rightWall = 0
				Case 2 : cells(x, y).rightWall = 0
				Case 3 : cells(nx, ny).bottomWall = 0
				Case 4 : cells(x, y).bottomWall = 0
			End Select
			Call MazeGenerate_internal_c2d( cells(), nx, ny, mazeRows, mazeCols )
		End If
	Next
End Sub

Function LinePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal p1 As D2D1_POINT_2F, ByVal p2 As D2D1_POINT_2F ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	LineFigureAdd_c2d sink, p1, p2

	sink.Close
	Function = -1
End Function

Macro LED5x7SPACING = .3!

Function Led5x7Width_c2d( ByVal value As WString, ByVal characterWidth As Single ) As Single
	Local l As Long
	l = Len(value)
	Function = l * characterWidth + (l-1) * characterWidth*LED5x7SPACING
End Function

Sub Led5x7CenteredPathNew_c2d( onPath As ID2D1PathGeometry, offPath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	y -= characterHeight / 2!
	x -= Led5x7Width_c2d( value, characterWidth ) / 2!
	Led5x7PathNew_c2d onPath, offPath, factory, value, x, y, characterWidth, characterHeight
End Sub

Sub Led5x7PathNew_c2d( ByRef onPath As ID2D1PathGeometry, ByRef offPath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	Local bt, hr, i, j, c As Long
	Local radius, dotW, dotH As Single
	'Local sz As Long
	Local b As Byte
	Local onSink, offSink, activeSink As ID2D1GeometrySink
	Local pa As D2D1_POINT_2F
	Local dot As D2D1_ARC_SEGMENT
	Local f5b7() As Byte
	onPath = Nothing
	offPath = Nothing

	Dim f5b7(479) As Byte
	Array Assign f5b7() = _
		&h00, &h00, &h00, &h00, &h00, _
		&h00, &h00, &h5F, &h00, &h00, _
		&h00, &h07, &h00, &h07, &h00, _
		&h14, &h7F, &h14, &h7F, &h14, _
		&h24, &h2A, &h7F, &h2A, &h12, _
		&h23, &h13, &h08, &h64, &h62, _
		&h36, &h49, &h55, &h22, &h50, _
		&h00, &h05, &h03, &h00, &h00, _
		&h00, &h1C, &h22, &h41, &h00, _
		&h00, &h41, &h22, &h1C, &h00, _
		&h08, &h2A, &h1C, &h2A, &h08, _
		&h08, &h08, &h3E, &h08, &h08, _
		&h00, &h50, &h30, &h00, &h00, _
		&h08, &h08, &h08, &h08, &h08, _
		&h00, &h60, &h60, &h00, &h00, _
		&h20, &h10, &h08, &h04, &h02, _
		&h3E, &h51, &h49, &h45, &h3E, _
		&h00, &h42, &h7F, &h40, &h00, _
		&h42, &h61, &h51, &h49, &h46, _
		&h21, &h41, &h45, &h4B, &h31, _
		&h18, &h14, &h12, &h7F, &h10, _
		&h27, &h45, &h45, &h45, &h39, _
		&h3C, &h4A, &h49, &h49, &h30, _
		&h01, &h71, &h09, &h05, &h03, _
		&h36, &h49, &h49, &h49, &h36, _
		&h06, &h49, &h49, &h29, &h1E, _
		&h00, &h36, &h36, &h00, &h00, _
		&h00, &h56, &h36, &h00, &h00, _
		&h00, &h08, &h14, &h22, &h41, _
		&h14, &h14, &h14, &h14, &h14, _
		&h41, &h22, &h14, &h08, &h00, _
		&h02, &h01, &h51, &h09, &h06, _
		&h32, &h49, &h79, &h41, &h3E, _
		&h7E, &h11, &h11, &h11, &h7E, _
		&h7F, &h49, &h49, &h49, &h36, _
		&h3E, &h41, &h41, &h41, &h22, _
		&h7F, &h41, &h41, &h22, &h1C, _
		&h7F, &h49, &h49, &h49, &h41, _
		&h7F, &h09, &h09, &h01, &h01, _
		&h3E, &h41, &h41, &h51, &h32, _
		&h7F, &h08, &h08, &h08, &h7F, _
		&h00, &h41, &h7F, &h41, &h00, _
		&h20, &h40, &h41, &h3F, &h01, _
		&h7F, &h08, &h14, &h22, &h41, _
		&h7F, &h40, &h40, &h40, &h40, _
		&h7F, &h02, &h04, &h02, &h7F, _
		&h7F, &h04, &h08, &h10, &h7F, _
		&h3E, &h41, &h41, &h41, &h3E, _
		&h7F, &h09, &h09, &h09, &h06, _
		&h3E, &h41, &h51, &h21, &h5E, _
		&h7F, &h09, &h19, &h29, &h46, _
		&h46, &h49, &h49, &h49, &h31, _
		&h01, &h01, &h7F, &h01, &h01, _
		&h3F, &h40, &h40, &h40, &h3F, _
		&h1F, &h20, &h40, &h20, &h1F, _
		&h7F, &h20, &h18, &h20, &h7F, _
		&h63, &h14, &h08, &h14, &h63, _
		&h03, &h04, &h78, &h04, &h03, _
		&h61, &h51, &h49, &h45, &h43, _
		&h00, &h00, &h7F, &h41, &h41, _
		&h02, &h04, &h08, &h10, &h20, _
		&h41, &h41, &h7F, &h00, &h00, _
		&h04, &h02, &h01, &h02, &h04, _
		&h40, &h40, &h40, &h40, &h40, _
		&h00, &h01, &h02, &h04, &h00, _
		&h20, &h54, &h54, &h54, &h78, _
		&h7F, &h48, &h44, &h44, &h38, _
		&h38, &h44, &h44, &h44, &h20, _
		&h38, &h44, &h44, &h48, &h7F, _
		&h38, &h54, &h54, &h54, &h18, _
		&h08, &h7E, &h09, &h01, &h02, _
		&h08, &h14, &h54, &h54, &h3C, _
		&h7F, &h08, &h04, &h04, &h78, _
		&h00, &h44, &h7D, &h40, &h00, _
		&h20, &h40, &h44, &h3D, &h00, _
		&h00, &h7F, &h10, &h28, &h44, _
		&h00, &h41, &h7F, &h40, &h00, _
		&h7C, &h04, &h18, &h04, &h78, _
		&h7C, &h08, &h04, &h04, &h78, _
		&h38, &h44, &h44, &h44, &h38, _
		&h7C, &h14, &h14, &h14, &h08, _
		&h08, &h14, &h14, &h18, &h7C, _
		&h7C, &h08, &h04, &h04, &h08, _
		&h48, &h54, &h54, &h54, &h20, _
		&h04, &h3F, &h44, &h40, &h20, _
		&h3C, &h40, &h40, &h20, &h7C, _
		&h1C, &h20, &h40, &h20, &h1C, _
		&h3C, &h40, &h30, &h40, &h3C, _
		&h44, &h28, &h10, &h28, &h44, _
		&h0C, &h50, &h50, &h50, &h3C, _
		&h44, &h64, &h54, &h4C, &h44, _
		&h00, &h08, &h36, &h41, &h00, _
		&h00, &h00, &h7F, &h00, &h00, _
		&h00, &h41, &h36, &h08, &h00, _
		&h08, &h08, &h2A, &h1C, &h08, _
		&h08, &h1C, &h2A, &h08, &h08 '

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Sub

	hr = factory.CreatePathGeometry( onPath )
	If FAILED( hr ) Then Exit Sub

	hr = onPath.Open( onSink )
	If FAILED( hr ) Then Exit Sub

	hr = factory.CreatePathGeometry( offPath )
	If FAILED( hr ) Then Exit Sub

	hr = offPath.Open( offSink )
	If FAILED( hr ) Then Exit Sub

	dotW = characterWidth / 5
	dotH = characterHeight / 7
	radius = Max( Min( dotW, dotH ), 1 ) / 2
	x -= characterWidth * (1+LED5x7SPACING)

	For j = 1 To Len(value)
		c = Asc( Mid$( value, j, 1 ) )
		If c>=32 And c<127 Then
			x += characterWidth * (1+LED5x7SPACING)
			c -= 32
			c *= 5

			For i = c To c+4
				b = f5b7(i)
				For bt=0 To 6
					If Bit(b,bt)=1 Then activeSink = onSink Else activeSink = offSink
					pa.x = x + (i-c)*dotW + dotW/2
					pa.y = y + bt*(dotH) + dotH/2
					CircleFigureAdd_c2d activeSink, radius, pa
				Next
			Next
		End If
	Next
	onSink.Close
	offSink.Close
End Sub

Macro LCD16SPACING = 0.3!

Function Lcd16Width_c2d( ByVal value As WString, ByVal characterWidth As Single ) As Single
	Local l As Long
	' .'s are a special case.  You can't have two "." together, you can't have leading .'s
	While Left$( value, 1 )="."
		value = Mid$( value, 2 )
	Wend
	Replace ".." With "." In value
	Replace ".." With "." In value
	Replace ".." With "." In value
	l = Len(value) - (ParseCount( value, "." )-1)
	Function = l * characterWidth + (l-1) * characterWidth*LCD16SPACING
End Function

Sub Lcd16CenteredPathNew_c2d( onPath As ID2D1PathGeometry, offPath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	y -= characterHeight / 2!
	x -= Lcd16Width_c2d( value, characterWidth ) / 2!
	Lcd16PathNew_c2d onPath, offPath, factory, value, x, y, characterWidth, characterHeight
End Sub

Sub Lcd16PathNew_c2d( onPath As ID2D1PathGeometry, offPath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	Local charVCenter, charHCenter, characterSpacing, segmentThickness, segOfs, segOfs2, segOfs4 As Single
	Local charLeft, charTop, charRight, charBottom, charWidth, charHeight, halfWidth, halfHeight, x1, y1 As Single
	Local onSink, offSink, activeSink As ID2D1GeometrySink
	Local pa As D2D1_POINT_2F
	Local i, c, hr As Long

	Local clr As Dword
	Local v As Dword
	Local seg16() As Dword

	onPath = Nothing
	offPath = Nothing

	Dim seg16(63) As Local Dword
	Array Assign seg16() = _
			&b00000000000000000000000000000000, _
			&b00000000000000000000001100000000, _
			&b00000000000000000000000110000000, _
			&b00000000000001111111111111111111, _
			&b00000000000000000000111110111011, _
			&b00000000000000001010111110011001, _
			&b00000000000000001010001100111010, _
			&b00000000000000000010000000000000, _
			&b00000000000000000000000011100001, _
			&b00000000000000000000000000011110, _
			&b00000000000000001111111100000000, _
			&b00000000000000000000111100000000, _
			&b00000000000000001000000000000000, _
			&b00000000000000000000100000000000, _
			&b00000000000000010000000000000000, _
			&b00000000000000001010000000000000, _
			&b00000000000000001010000011111111, _
			&b00000000000000000000000000001100, _
			&b00000000000000000000110001110111, _
			&b00000000000000000000100000111111, _
			&b00000000000000000000110010001100, _
			&b00000000000000000100010010110011, _
			&b00000000000000000000110011111011, _
			&b00000000000000000000000000001111, _
			&b00000000000000000000110011111111, _
			&b00000000000000000000110010111111, _
			&b00000000000000000000001100000000, _
			&b00000000000000001000000100000000, _
			&b00000000000000000110000000000000, _
			&b00000000000000000000000000110011, _
			&b00000000000000001001000000000000, _
			&b00000000000000000000101000000110, _
			&b00000000000000000000100111110111, _
			&b00000000000000000000110011001111, _
			&b00000000000000000000101100111111, _
			&b00000000000000000000000011110011, _
			&b00000000000000000000001100111111, _
			&b00000000000000000000110011110011, _
			&b00000000000000000000010011000011, _
			&b00000000000000000000100011111011, _
			&b00000000000000000000110011001100, _
			&b00000000000000000000001100000000, _
			&b00000000000000000000000001111100, _
			&b00000000000000000110010011000000, _
			&b00000000000000000000000011110000, _
			&b00000000000000000011000011001100, _
			&b00000000000000000101000011001100, _
			&b00000000000000000000000011111111, _
			&b00000000000000000000110011000111, _
			&b00000000000000000100000011111111, _
			&b00000000000000000100110011000111, _
			&b00000000000000000000110010111011, _
			&b00000000000000000000001100000011, _
			&b00000000000000000000000011111100, _
			&b00000000000000001010000011000000, _
			&b00000000000000001100000011001100, _
			&b00000000000000001111000000000000, _
			&b00000000000000000011001000000000, _
			&b00000000000000001010000000110011, _
			&b00000000000000000000001100010010, _
			&b00000000000000001010000000000000, _
			&b00000000000000000000001100100001, _
			&b00000000000000000000000000000000, _
			&b00000000000000000000000000110000

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Sub

	While Left$( value, 1 )="."
		value = Mid$( value, 2 )
	Wend
	Replace ".." With "." In value
	Replace ".." With "." In value
	Replace ".." With "." In value

	hr = factory.CreatePathGeometry( onPath )
	If FAILED( hr ) Then Exit Sub

	hr = onPath.Open( onSink )
	If FAILED( hr ) Then Exit Sub

	hr = factory.CreatePathGeometry( offPath )
	If FAILED( hr ) Then Exit Sub

	hr = offPath.Open( offSink )
	If FAILED( hr ) Then Exit Sub

	value = UCase$(value)

	charWidth   = characterWidth
	charHeight  = characterHeight
	characterSpacing = charWidth *(1+LCD16SPACING)
	charTop     = y
	charLeft    = x - characterSpacing
	charVCenter = charTop  + charHeight/2!
	charBottom  = charTop  + charHeight

	segmentThickness = Min( charHeight/7!, charWidth/7!)
	segOfs = segmentThickness / 4!
	segOfs2 = segOfs * 2
	segOfs4 = segOfs2 * 2
	halfWidth = charWidth / 2!
	halfHeight = charHeight / 2!

	i = 0
	Do While i<=Len(value)
		i += 1
		c = Asc( Mid$( value, i, 1 ) )

		c -= 32
		If c<0 Or c>63 Then Iterate Do: ' Out of range...
		v = seg16(c)

		charLeft   += characterSpacing
		charHCenter = charLeft + charWidth/2!
		charRight   = charLeft + charWidth

		If Bit(v,0)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charLeft+1, charTop, halfWidth-2, segmentThickness, segmentThickness ):                'Horiz Top / Left

		If Bit(v,1)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charHCenter+1, charTop, halfWidth-2, segmentThickness, segmentThickness ):                       'Horiz Top / Right

		If Bit(v,10)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charLeft+1, charVCenter, halfWidth-2, segmentThickness, segmentThickness  ):           'Horizontal Middle / Left

		If Bit(v,11)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charHCenter+1, charVCenter, halfWidth-2, segmentThickness, segmentThickness  ):                  'Horizontal Middle / Right

		If Bit(v,5)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charLeft+1, charBottom, halfWidth-2, segmentThickness, segmentThickness ):            'Horizontal Bottom / Left

		If Bit(v,4)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16HSegmentFigureAdd_c2d( activeSink, charHCenter+1, charBottom, halfWidth-2, segmentThickness, segmentThickness ):                    'Horizontal Bottom / Right



		If Bit(v,7)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charLeft-segOfs2, charTop+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness ):                   'Vertical Top / Left

		If Bit(v,6)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charLeft-segOfs2, charVCenter+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness ):                         'Vertical Bottom / Left

		If Bit(v,8)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charHCenter-segOfs2, charTop+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness  ):             'Vertical Top / Center

		If Bit(v,9)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charHCenter-segOfs2, charVCenter+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness  ):                    'Vertical Bottom / Center

		If Bit(v,2)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charRight-segOfs2, charTop+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness ):               'Vertical Top / Right

		If Bit(v,3)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16VSegmentFigureAdd_c2d( activeSink, charRight-segOfs2, charVCenter+segOfs2+1, segmentThickness, halfHeight-2, segmentThickness  ):                     'Vertical Bottom / Right


		If  Bit(v,12)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16LeftRightTopSegmentFigureAdd_c2d( activeSink, charLeft+segOfs2+1, charTop+segOfs4+1, halfWidth-segOfs4-2, halfHeight-segOfs4-2, segmentThickness ):   'Diagonal Top / Left

		If Bit(v,13)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16RightLeftTopSegmentFigureAdd_c2d( activeSink, charHCenter+1+segOfs*.6, charTop+segOfs*2.6+1, halfWidth-segOfs2-2, halfHeight-segOfs2-2, segmentThickness ):        'Diagonal Top / Right

		If Bit(v,14)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16LeftRightBottomSegmentFigureAdd_c2d( activeSink, charHCenter+1+segOfs2, charVCenter+segOfs4+1, halfWidth-segOfs4-2, halfHeight-segOfs4-2, segmentThickness ):             'Diagonal Bottom / Right

		If Bit(v,15)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd16RightLeftBottomSegmentFigureAdd_c2d( activeSink, charLeft+1+segOfs*.6, charVCenter+segOfs*2.6+1, halfWidth-segOfs2-2, halfHeight-segOfs2-2, segmentThickness ):        'Diagonal Bottom / Left


		If i >= Len( value ) Then Iterate Do
		c = Asc( Mid$( value, i+1, 1 ) )
		If c <> 46 Then Iterate Do: ' not a .
		c -= 32
		If c<0 Or c>63 Then Iterate Do: ' Out of range...
		v = seg16(c)
		 'period (.)
		If Bit(v,16)=1 Then activeSink = onSink Else activeSink = offSink
		x = charRight + segmentThickness
		y = charBottom
		x1 = x + segmentThickness
		y1 = y + segmentThickness
		pa.x = x: pa.y = y
		activeSink.BeginFigure( pa, %D2D1_FIGURE_BEGIN_FILLED )
		pa.x = x1
		activeSink.AddLine( pa )
		pa.y = y1
		activeSink.AddLine( pa )
		pa.x = x
		activeSink.AddLine( pa )
		activeSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
		i += 1
	Loop
	onSink.Close
	offSink.Close
End Sub

Macro LCD7SPACING = .2!

Function Lcd7Width_c2d( ByVal value As WString, ByVal characterWidth As Single ) As Single
	Local l As Long
	' .'s are a special case.  You can't have two "." together, you can't have leading .'s
	While Left$( value, 1 )="."
		value = Mid$( value, 2 )
	Wend
	Replace ".." With "." In value
	Replace ".." With "." In value
	Replace ".." With "." In value
	l = Len(value) - (ParseCount( value, "." )-1)
	Function = l * characterWidth + (l-1) * characterWidth*LCD7SPACING
End Function

Sub Lcd7CenteredPathNew_c2d( ByRef onPath As ID2D1PathGeometry, ByRef offPath As ID2D1PathGeometry, _
														ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	y -= characterHeight / 2!
	x -= Lcd7Width_c2d( value, characterWidth ) / 2!
	Lcd7PathNew_c2d onPath, offPath, factory, value, x, y, characterWidth, characterHeight
End Sub

Sub Lcd7PathNew_c2d( ByRef onPath As ID2D1PathGeometry, ByRef offPath As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal value As WString, ByVal x As Single, ByVal y As Single, ByVal characterWidth As Single, ByVal characterHeight As Single )
	Local charLeft, charTop, charRight, charBottom, segThickness As Single
	Local charVCenter, x1, y1, x2, y2 As Single
	Local hSegWidth, vSegHeight As Single
	Local ofsSeg, ofsSeg2 As Single
	Local tx, ty, tx2, ty2 As Single
	Local i, j, hr, v, c, characterSpacing As Long
	Local onSink, offSink, activeSink As ID2D1GeometrySink
	Local pa, pnts() As D2D1_POINT_2F
	Local seg7() As Word

	onPath = Nothing
	offPath = Nothing

	ReDim seg7(38) As Word
	Array Assign seg7() = _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0011111111111111, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000111001, _
								&b0000000000001111, _
								&b0000000000000000, _
								&b0000000100000000, _
								&b0000000000000000, _
								&b0000000010000000, _
								&b0000001000000000, _
								&b0000000000000000, _
								&b0000000000111111, _
								&b0000000000000110, _
								&b0000000001011011, _
								&b0000000001001111, _
								&b0000000001100110, _
								&b0000000001101101, _
								&b0000000001111100, _
								&b0000000000000111, _
								&b0000000001111111, _
								&b0000000001100111, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000000000000, _
								&b0000000001110111, _
								&b0000000001111100, _
								&b0000000000111001, _
								&b0000000001011110, _
								&b0000000001111001, _
								&b0000000001110001

	While Left$( value, 1 )="."
		value = Mid$( value, 2 )
	Wend
	Replace ".." With "." In value
	Replace ".." With "." In value
	Replace ".." With "." In value

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Sub

	hr = factory.CreatePathGeometry( onPath )
	If FAILED( hr ) Then Exit Sub

	hr = onPath.Open( onSink )
	If FAILED( hr ) Then Exit Sub

	hr = factory.CreatePathGeometry( offPath )
	If FAILED( hr ) Then Exit Sub

	hr = offPath.Open( offSink )
	If FAILED( hr ) Then Exit Sub

	characterSpacing = characterWidth * (1! + LCD7SPACING)
	charLeft = x - characterSpacing
	charTop  = y
	segThickness = Min( characterWidth, characterHeight ) / 7!
	charBottom = charTop + characterHeight - segThickness
	charVCenter = charTop + (charBottom-charTop+segThickness)/2! - segThickness / 2
	hSegWidth = characterWidth - segThickness*2
	vSegHeight = (characterHeight - segThickness*3) / 2
	i = 0
	Do While i < Len(value)
		i+=1
		c = Asc( Mid$( value, i, 1 ) )
		' space = 32, F = 70
		If InStr("#()0123456789ABCDEF.+-", Chr$(c))=0 Then Iterate Do
		c -= 32
		v = seg7(c)

		charLeft  += characterSpacing
		charRight  = charLeft + characterWidth - segThickness

		If Bit(v,0)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7HSegmentFigureAdd_c2d( activeSink, charLeft+segThickness, charTop, hSegWidth, segThickness, segThickness ): 'Top

		If Bit(v,6)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7HSegmentFigureAdd_c2d( activeSink, charLeft+segThickness, charVCenter, hSegWidth, segThickness, segThickness ): ' Horizontal Middle

		If Bit(v,3)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7HSegmentFigureAdd_c2d( activeSink, charLeft+segThickness, charBottom, hSegWidth, segThickness, segThickness ): 'Bottom


		If Bit(v,5)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7VSegmentFigureAdd_c2d( activeSink, charLeft, charTop +segThickness, segthickness, vSegHeight, segThickness ): ' VerticalTop Left

		If Bit(v,4)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7VSegmentFigureAdd_c2d( activeSink, charLeft, charVCenter+segThickness, segthickness, vSegHeight, segThickness ): ' Vertical Bottom Left

		If Bit(v,1)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7VSegmentFigureAdd_c2d( activeSink, charRight, charTop+segThickness, segthickness, vSegHeight, segThickness ): ' Vertical Top Right

		If Bit(v,2)=1 Then activeSink = onSink Else activeSink = offSink
		Lcd7VSegmentFigureAdd_c2d( activeSink, charRight, charVCenter+segThickness, segthickness, vSegHeight, segThickness ): ' Vertical Bottom Right

		If Bit(v,7)=1 Then
			' Minus
			tx =  charRight - characterWidth/2
			ty = charVCenter
			tx2 = charRight
			ty2 = ty + segThickness
			ReDim pnts(3)
			pnts(0).x = tx : pnts(0).y = ty
			pnts(1).x = tx2: pnts(1).y = ty
			pnts(2).x = tx2: pnts(2).y = ty2
			pnts(3).x = tx : pnts(3).y = ty2
			onSink.BeginFigure( pnts(0), %D2D1_FIGURE_BEGIN_FILLED )
			onSink.AddLines( pnts(1), 3 )
			onSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
		End If
		If Bit(v,8)=1 Then
			' Plus
			ReDim Pnts(11)
			pnts( 0).x =  0: pnts( 0).y = .1
			pnts( 1).x = .1: pnts( 1).y = .1
			pnts( 2).x = .1: pnts( 2).y =  0
			pnts( 3).x = .2: pnts( 3).y =  0
			pnts( 4).x = .2: pnts( 4).y = .1
			pnts( 5).x = .3: pnts( 5).y = .1
			pnts( 6).x = .3: pnts( 6).y = .2
			pnts( 7).x = .2: pnts( 7).y = .2
			pnts( 8).x = .2: pnts( 8).y = .3
			pnts( 9).x = .1: pnts( 9).y = .3
			pnts(10).x = .1: pnts(10).y = .2
			pnts(11).x =  0: pnts(11).y = .2

			For j=0 To 11
				pnts(j).x *= characterWidth / 2 * 2.8
				pnts(j).y *= characterWidth / 2 * 2.8
				pnts(j).x += charRight -  characterWidth*.4
				pnts(j).y += charVCenter-segThickness
			Next
			onSink.BeginFigure( pnts(0), %D2D1_FIGURE_BEGIN_FILLED )
			onSink.AddLines( pnts(1), 11 )
			onSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
		End If

		If i>=Len(value) Then Iterate Do
		c = Asc( Mid$( value, i+1, 1 ) )
		If c<>46 Then Iterate Do: ' Not a .
		' space = 32, F = 70
		c -= 32
		v = seg7(c)

		If Bit(v,9)<>1 Then Iterate Do
		' Period
		ReDim pnts(3)
		x1 = charRight + segThickness: y1 = charBottom
		x2 = x1 + segThickness: y2 = charBottom+segThickness
		pnts(0).x = x1: pnts(0).y = y1
		pnts(1).x = x2: pnts(1).y = y1
		pnts(2).x = x2: pnts(2).y = y2
		pnts(3).x = x1: pnts(3).y = y2
		onSink.BeginFigure( pnts(0), %D2D1_FIGURE_BEGIN_FILLED )
		onSink.AddLines( pnts(1), 3 )
		onSink.EndFigure( %D2D1_FIGURE_END_CLOSED )
		i += 1
	Loop
	onSink.Close
	offSink.Close
End Sub

Function DonutWedgePathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, params As DonutPathParams ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	DonutWedgeFigureAdd_c2d sink, params

	sink.Close
	Function = -1
End Function

Function CirclePathNew_c2d( ByRef obj As ID2D1Geometry, ByVal factory As ID2D1Factory, ByVal helper As ID2D1Helper, Optional ByVal center As D2D1_POINT_2F, Optional ByVal radius As Single ) As Long
	Local ellipseParam As D2D1_ELLIPSE

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	If Not IsInterface( helper, ID2D1Helper ) Then Exit Function
	If radius = 0! Then radius = 0.5!

	ellipseParam.point   = center
	ellipseParam.radiusX = radius
	ellipseParam.radiusY = radius

	factory.CreateEllipseGeometry ellipseParam, obj
	Function = -1
End Function

Function ChartSymbolPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws a single symbol in a single path
	' Expects i1, i2, and j to be set already
	'   Already called ChartSetup
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ChartSymbolFigureAdd_c2d sink, xPct(), yPct(), params

	sink.Close
	Function = -1
End Function

Function ChartSymbolSeriesPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws all symbols for a series in a single path (which means a single outline or fill per series)
	' This would be fairly common for where the entire series was drawn in a single style.
	' Expects j to already be set, sets i1 and i2
	'   Already called ChartSetup
	Local sink As ID2D1GeometrySink
	Local xStep As Single
	Local i, hr, lb, ub As Long

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	Local oCount, cCount, iStep As Long
	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = UBound( xPct(), 1 ) - LBound( xPct(), 1 ) + 1
	iStep = cCount / oCount

	For i = params.lb1 To params.ub1 Step iStep
		params.i1 = i
		params.i2 = Min(i + iStep, params.ub1)
		ChartSymbolFigureAdd_c2d sink, xPct(), yPct(), params
	Next

	sink.Close
	Function = -1
End Function


Function ChartSymbolGroupPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws all symbols for a group in a single path  (which means a single outline or fill per group)
	' Expects i1 and i2 to be set already, sets j
	'   Already called ChartSetup
	Local sink As ID2D1GeometrySink
	Local hr, j, xValues As Long

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	For j = params.lb2 To params.ub2
		params.j = j
		ChartSymbolFigureAdd_c2d sink, xPct(), yPct(), params
	Next

	sink.Close
	Function = -1
End Function

Function ChartSymbolAllPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws all symbols in a single path (which means a single outline or fill)
	' Sets i1, i2, and j
	Local sink As ID2D1GeometrySink
	Local i, j, hr As Long
	Local oCount, cCount, iStep As Long

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = UBound( xPct(), 1 ) - LBound( xPct(), 1 ) + 1
	iStep = cCount / oCount

	For j = params.lb2 To params.ub2
		params.j = j
		For i = params.lb1 To params.ub1 Step iStep
			params.i1 = i
			params.i2 = Min(i + iStep, params.ub1)
			ChartSymbolFigureAdd_c2d sink, xPct(), yPct(), params
		Next
	Next

	sink.Close
	Function = -1
End Function

Function ChartStep_c2d( params As ChartSymbolParams ) As Long
	If params.xCount=0 Then Function=1: Exit Function
	Function = (params.ub1 - params.lb1 + 1) / params.xCount
End Function


Function ChartOriginalIndex_c2d( ByVal i As Long, params As ChartSymbolParams ) As Long
	' For splines with n points per value, returns the original index
	Function =  (i-params.lb1) / ChartStep_c2d(params)
End Function

Sub ChartBoundsSet_c2d( values() As Single, params As ChartSymbolParams )
	If params.ub1=0 And params.ub2=0 Then
		params.lb1 = LBound(values(), 1)
		params.ub1 = UBound(values(), 1)
		params.lb2 = LBound(values(), 2)
		params.ub2 = UBound(values(), 2)
	End If
End Sub

Sub ChartParamsSet_c2d( values() As Single, params As ChartSymbolParams )
	Local spread As Single

	If params.ub1=0 And params.ub2=0 Then ChartBoundsSet_c2d values(), params
	If params.xCount=0 Then
		params.xCount = params.ub1 - params.lb1 + 1: If params.xCount = 0 Then params.xCount = 1
	End If
	If params.zero = 0! Then
		spread = params.ybounds.vmax - params.ybounds.vmin
		params.zero = .5 - ( -params.yBounds.vmin / spread )
	End If

	If params.width = 0! Then
		params.width = 1! / ( params.ub1 - params.lb1 + 1! )
	End If

	If params.size = 0! Then params.size = 1! / params.display.width
End Sub

Function ChartSpiderPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal groups As Long, ByVal lineSeparation As Single, Optional ByVal rotationDegrees As Single ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ChartSpiderGridFigureAdd_c2d sink, groups, lineSeparation, rotationDegrees

	sink.Close
	Function = -1
End Function

Function ChartRadarSymbolPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
		angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws a single symbol in a single path
	' Expects i1, i2, and j to be set already
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local sink As ID2D1GeometrySink
	Local hr As Dword
'  Local iStep As Long
'  Local angle(), radius() As Single

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	'ChartRadarSetup_c2d xValues(), xPct(), yPct(), angle(), radius(), iStep, params

	params.angle = angle( params.i1, params.j )
	params.radius = radius( params.i1, params.j )
	If params.j>params.lb2 Then params.innerRadius = radius( params.i1, params.j-1 )
	ChartRadarSymbolFigureAdd_c2d sink, xPct(), yPct(), radius(), params

	sink.Close
	Function = -1
End Function

Function ChartRadarSymbolSeriesPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
		angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws all symbols for a series in a single path (which means a single outline or fill per series)
	' This would be fairly common for where the entire series was drawn in a single style.
	' Expects j to already be set, sets i1 and i2
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local sink As ID2D1GeometrySink
	Local xStep As Single
	Local i As Long
	Local hr, lb, ub As Long
'  Local angle(), radius() As Single

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	'ChartRadarSetup_c2d xValues(), xPct(), yPct(), angle(), radius(), iStep, params

	For i = params.lb1 To params.ub1 Step iStep
		params.i1 = i
		params.i2 = i + iStep
		params.angle = angle( i, params.j)
		params.radius = radius( i, params.j)
		If params.j>params.lb2 Then params.innerRadius = radius( i, params.j-1 )
		ChartRadarSymbolFigureAdd_c2d sink, xPct(), yPct(), radius(), params
	Next

	sink.Close
	Function = -1
End Function


Function ChartRadarSymbolGroupPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
		angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws all symbols for a group in a single path  (which means a single outline or fill per group)
	' Expects i1 and i2 to be set already, sets j
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local sink As ID2D1GeometrySink
	Local hr, xValues As Long
	Local j As Long
'  Local angle(), radius() As Single

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	'ChartRadarSetup_c2d xValues(), xPct(), yPct(), angle(), radius(), iStep, params

	For j = params.lb2 To params.ub2
		params.j = j
		params.angle = angle( params.i1, j )
		params.radius = radius( params.i1, j )
		If j>params.lb2 Then params.innerRadius = radius( params.i1, j-1 )
		ChartRadarSymbolFigureAdd_c2d sink, xPct(), yPct(), radius(), params
	Next

	sink.Close
	Function = -1
End Function

Function ChartRadarSymbolAllPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
		angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws all symbols in a single path (which means a single outline or fill)
	' Sets i1, i2, and j
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local sink As ID2D1GeometrySink
	Local i, j, hr As Long
'  Local angle(), radius() As Single

	obj = Nothing

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	'ChartRadarSetup_c2d xValues(), xPct(), yPct(), angle(), radius(), iStep, params

	For j = params.lb2 To params.ub2
		params.j = j
		For i = params.lb1 To params.ub1 Step iStep
			params.i1 = i
			params.i2 = i + iStep
			params.angle = angle( i, j )
			params.radius = radius( i, j )
			If j>params.lb2 Then params.innerRadius = radius( i, j-1 )
			ChartRadarSymbolFigureAdd_c2d sink, xPct(), yPct(), radius(), params
		Next
	Next

	sink.Close
	Function = -1
End Function


Sub ChartRadarSetup_c2d( xValues() As Single, xPct() As Single, yPct() As Single, angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams )
	Local oCount, cCount As Long
	Local i, j As Long
	Local x, y, r, a, pad, apg, apb, b As Single

	' Undo Normalization
	params.barPadding *= params.display.width
	params.barPadding -= 2!
	params.groupPadding *= params.display.width

	apg = 6.283185307179586! / CSng(params.ub1 - params.lb1 + 1!)
	If params.vLayout = %ChartVLayoutType.Normal And params.ub2<>params.ub1 Then
		apb = ( apg - (params.groupPadding*0.0174532925199433!) ) / CSng( params.ub2 - params.lb2 + 1! )
		pad = params.barPadding
		b = apb
	Else
		apb = apg
		pad = Max( params.barPadding, params.groupPadding )
		b = 0
	End If

	If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
		params.size = apb - pad*0.0174532925199433!
	End If

	ReDim angle(params.lb1 To params.ub1, params.lb2 To params.ub2 )
	ReDim radius(params.lb1 To params.ub1, params.lb2 To params.ub2 )

	For j = params.lb2 To params.ub2
		For i = params.lb1 To params.ub1
			If params.symbolRender = CodePtr( ChartRadarSymbol_BarFigureAdd_c2d ) Then
				a = (i-params.lb1)*apg + params.groupPadding* 0.0174532925199433!/2! + (j-params.lb2)*b
			Else
				a = xPct( i, j ) * 6.283185307! + 1.570796327!
			End If
			r = ( -params.ybounds.vmin + yPct( i, j ) ) * .5  ' -1 <= (n) -> (m) <= 1 s/b 0 -> .5
			angle(i,j) = a
			radius(i,j) = r
			xPct( i, j ) = Sin( a ) * r
			yPct( i, j ) = Cos( a ) * r
		Next
	Next

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = UBound( xPct(), 1 ) - LBound( xPct(), 1 ) + 1
	iStep = cCount / oCount
End Sub

Function ChartRadarPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal groups As Long, ByVal lineSeparation As Single, Optional ByVal rotationDegrees As Single ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ChartRadarGridFigureAdd_c2d sink, groups, lineSeparation, rotationDegrees

	sink.Close
	Function = -1
End Function

Function ChartGridPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal drawZero As Long, ByVal zeroOffset As Single, ByVal divisions As Single ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ChartGridFigureAdd_c2d sink, drawZero, zeroOffset, divisions

	sink.Close
	Function = -1
End Function

Function ChartXYGridPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal drawZero As Long, ByVal zeroOffsetX As Single, ByVal zeroOffsetY As Single, _
																ByVal divisionsX As Single, ByVal divisionsY As Single, ByVal isHorizontal As Long  ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword
	Local x, y As ID2D1PathGeometry

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function

	' Create X grid (bars drawn vertically)
	hr = factory.CreatePathGeometry( x ): If FAILED( hr ) Then Exit Function
	hr = x.Open( sink ):                  If FAILED( hr ) Then Exit Function
	ChartGridFigureAdd_c2d sink, drawZero, zeroOffsetX, divisionsX
	sink.Close

	' Create Y grid (bars drawn horizontally)
	hr = factory.CreatePathGeometry( y ): If FAILED( hr ) Then Exit Function
	hr = y.Open( sink ):                  If FAILED( hr ) Then Exit Function
	ChartGridFigureAdd_c2d sink, drawZero, zeroOffsetY, divisionsY
	sink.Close
	' Y already has horizontal lines going vertically, it's fine
	' X needs vertical bars, need to rotate
	TransformPath_c2d x, factory, 0,0, 1,1, 90 ' Rotate into place

	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function
	x.CombineWithGeometry  y, %D2D1_COMBINE_MODE_UNION, ByVal 0, 0, sink
	sink.Close

	If isHorizontal Then ChartToHorizontal_c2d obj, factory
	Function = -1
End Function

Sub ChartToHorizontal_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory )
	Local m As D2D1_MATRIX_3X2_F
	TransformPath_c2d obj, factory, 0,0, 1, 1, 90
	MatrixReflectY_c2d m
	factory.CreateTransformedGeometry obj, m, obj
End Sub

Function BoxPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, _
												Optional ByVal roundRadiusX As Single, Optional ByVal roundRadiusY As Single, Optional center As D2D1_POINT_2F, Optional boxSize As D2D1_SIZE_F, Optional ByVal isHollow As Long ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	BoxFigureAdd_c2d sink, roundRadiusX, roundRadiusY, center, boxSize, isHollow

	sink.Close
	Function = -1
End Function

Function ArcPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal startAngle As Single, ByVal endAngle As Single, _
												Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ArcFigureAdd_c2d sink, startAngle, endAngle, startRadius, endRadius, center
	sink.Close
	Function = -1
End Function

Function RadianArcPathNew_c2d( ByRef obj As ID2D1PathGeometry, ByVal factory As ID2D1Factory, ByVal startAngle As Single, ByVal endAngle As Single, _
												Optional ByVal startRadius As Single, Optional ByVal endRadius As Single, Optional ByVal center As D2D1_POINT_2F ) As Long
	Local sink As ID2D1GeometrySink
	Local hr As Dword

	obj = Nothing
	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function
	hr = factory.CreatePathGeometry( obj ): If FAILED( hr ) Then Exit Function
	hr = obj.Open( sink ):                  If FAILED( hr ) Then Exit Function

	ArcRadianFigureAdd_c2d sink, startAngle, endAngle, startRadius, endRadius, center

	sink.Close
	Function = -1
End Function

Declare Function ReticleArcExplosion_internal( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single

Function ReticleArcPathsNew_c2d( ByRef slices() As ID2D1PathGeometry, ByVal factory As ID2D1Factory, values() As Single, params As ReticleArcPathsParams ) As Long
	Local p As ReticleArcSinkParams
	Local total, midAngle As Single
	Local i, j, c, shouldExplode As Long
	Local sweep, a, d  As Single
	Local obj As ID2D1PathGeometry
	Local center As D2D1_POINT_2F
	Local startAngle, endAngle, startRadius, endRadius As Single
	Local changePerDegree, radians As Single

	For i = LBound( slices(), 1) To UBound( slices(), 1 )
		For j = LBound( slices(), 2 ) To UBound( slices(), 2 )
			slices( i, j ) = Nothing
		Next
	Next

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function

	c = UBound( values() )

	total = 0!
	For i=0 To c
		total += values(i)
	Next

	ReDim slices( c )
	If params.sweepDegrees.first = 0 And params.sweepDegrees.last = 0 Then params.sweepDegrees.last = 360
	If params.radius.first = 0 Then params.radius.first = .5!
	If params.radius.last = 0 Then params.radius.last = params.radius.first

	changePerdegree = (params.radius.last-params.radius.first) / (params.sweepDegrees.last - params.sweepDegrees.first)

	endRadius   = params.radius.first
	sweep       = params.sweepDegrees.last - params.sweepDegrees.first
	a           = params.sweepDegrees.first

	For i=0 To c
		center = params.center
		startAngle = a
		endAngle   = a + sweep * (values(i) / total) - params.gapDegrees
		startRadius = endRadius
		endRadius += (sweep * (values(i) / total)) * changePerDegree
		If params.explodeFunction Then
			Call Dword params.explodeFunction Using ReticleArcExplosion_internal( values(i), i, params.explodeDistance, params.explodeIndex ) To d
			midAngle = (endAngle + startAngle) / 2!
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * d
			center.y += Cos( radians ) * d
		ElseIf params.explodeDistance And params.explodeIndex=i Then
			midAngle = (endAngle + startAngle) / 2
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * params.explodeDistance
			center.y += Cos( radians ) * params.explodeDistance
		End If

		p.center              = center
		p.sweepDegrees.first  = startAngle
		p.sweepDegrees.last   = endAngle
		p.radius.first        = startRadius
		p.radius.last         = endRadius
		p.baseDegrees         = params.baseDegrees
		p.markSide            = params.markSide
		p.markSize            = params.markSize
		p.markDegrees         = params.markDegrees
		p.hideLine            = params.hideLine

		' Allow spiraling
		ReticleArcPathNew_c2d slices(i), factory, p
		a = endAngle + params.gapDegrees
	Next
End Function

Sub PuzzlePathsNew_c2d( obj() As ID2D1PathGeometry, factory As ID2D1Factory, ByVal gridSize As Long, Optional ByVal isHollow As Long )
	' Creates a single path with all pieces, useful if just a visual
	Dim sd(gridSize-1,gridSize-1) As Local PuzzleSidesParams_internal
	Local i, j, hr As Long
	Local sw, sh As Single
	Local sink As ID2D1GeometrySink
	Local center As D2D1_POINT_2F
	Local sideSize As D2D1_SIZE_F

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	gridSize = Max( 1, gridSize )
	Randomize

	' Generate random sides
	For i=0 To gridSize-1
		For j=0 To gridSize-1
			sd(i,j).leftOut=Rnd(0,1)
			sd(i,j).topOut=Rnd(0,1)
			sd(i,j).rightOut=Rnd(0,1)
			sd(i,j).bottomOut =Rnd(0,1)
		Next
	Next

	' Set edges match similar sides
	For i = 0 To gridSize-1
		' y
		For j = 0 To gridSize-1
			' x
			If IsFalse i Then
				' Top Edge
				sd(i,j).topOut=-1
			Else
				' Top matches bottom above
				sd(i,j).topOut = -(sd(i-1,j).bottomOut-1)
			End If
			If i=gridSize-1 Then
				' Bottom Edge
				sd(i,j).bottomOut=-1
			End If
			If IsFalse j Then
				' Left edge
				sd(i,j).leftOut=-1
			Else
				' Left edge matches right side of piece to the left
				sd(i,j).leftOut = -(sd(i,j-1).rightOut-1)
			End If
			If j=gridSize-1 Then
				' Right edge
				sd(i,j).rightOut=-1
			End If
		Next
	Next

	sw = 1! / CSng(gridSize)
	sh = 1! / CSng(gridSize)
	sideSize.width = sw
	sideSize.height = sh

	ReDim obj( gridSize-1, gridSize-1 )

	Local ps As PuzzleSidesParams_internal
	' Add puzzle pieces
	For i=0 To gridSize-1
		' y
		For j=0 To gridSize-1
			' x
			hr = factory.CreatePathGeometry( obj(i,j) ): If FAILED( hr ) Then Exit Sub
			hr = obj(i,j).Open( sink ):                  If FAILED( hr ) Then Exit Sub
			ps = sd(i,j)
			ps.leftOut = ps.LeftOut
			ps.topOut = ps.TopOut
			ps.rightOut = ps.RightOut
			ps.bottomOut = ps.bottomOut
			center.x = -.5 + (j+.5)*sw
			center.y = -.5 + (i+.5)*sh
			PuzzlePieceFigureAdd_c2d sink, sd(i,j).leftOut, sd(i,j).topOut, sd(i,j).rightOut, sd(i,j).bottomOut, isHollow, center, sideSize
			sink.Close
		Next
	Next
End Sub

Declare Function PieExplosion_internal( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single

Function PiePathsNew_c2d( ByRef slices() As ID2D1PathGeometry, ByVal factory As ID2D1Factory, values() As Single, params As PiePathsParams ) As Long
	Local total, midAngle As Single
	Local i, j, c, shouldExplode As Long
	Local sweep, a, d  As Single
	Local obj As ID2D1PathGeometry
	Local center As D2D1_POINT_2F
	Local startAngle, endAngle, startRadius, endRadius As Single
	Local changePerDegree, radians As Single

	For i = LBound( slices(), 1) To UBound( slices(), 1 )
		For j = LBound( slices(), 2 ) To UBound( slices(), 2 )
			slices( i, j ) = Nothing
		Next
	Next

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function

	c = UBound( values() )

	total = 0!
	For i=0 To c
		total += values(i)
	Next

	ReDim slices( c )
	If params.sweepDegrees.first = 0 And params.sweepDegrees.last = 0 Then params.sweepDegrees.last = 360
	If params.radius.first = 0 Then params.radius.first = .5!
	If params.radius.last = 0 Then params.radius.last = params.radius.first

	changePerdegree = (params.radius.last-params.radius.first) / (params.sweepDegrees.last - params.sweepDegrees.first)

	endRadius   = params.radius.first
	sweep       = params.sweepDegrees.last - params.sweepDegrees.first
	a           = params.sweepDegrees.first

	For i=0 To c
		center = params.center
		startAngle = a
		endAngle   = a + sweep * (values(i) / total) - params.gapDegrees
		startRadius = endRadius
		endRadius += (sweep * (values(i) / total)) * changePerDegree
		If params.explodeFunction Then
			Call Dword params.explodeFunction Using PieExplosion_internal( values(i), i, params.explodeDistance, params.explodeIndex ) To d
			midAngle = (endAngle + startAngle) / 2!
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * d
			center.y += Cos( radians ) * d
		ElseIf params.explodeDistance And params.explodeIndex=i Then
			midAngle = (endAngle + startAngle) / 2
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * params.explodeDistance
			center.y += Cos( radians ) * params.explodeDistance
		End If

		' Allow spiraling
		PiePathNew_c2d slices(i), factory, startAngle, endAngle, startRadius, endRadius, center
		a = endAngle + params.gapDegrees
	Next
End Function

Declare Function DonutExplosion_internal( value As Single, valueIndex As Long, refValue As Single, refIndex As Long ) As Single

Function DonutPathsNew_c2d( ByRef slices() As ID2D1PathGeometry, ByVal factory As ID2D1Factory, values() As Single, params As DonutPathsParams ) As Long
	Local p As DonutPathParams
	Local total, midAngle As Single
	Local i, j, c, shouldExplode As Long
	Local sweep, a, d  As Single
	Local obj As ID2D1PathGeometry
	Local center As D2D1_POINT_2F
	Local startAngle, endAngle, outerStartRadius, outerEndRadius, innerStartRadius, innerEndRadius  As Single
	Local outerChangePerDegree, innerChangePerDegree, radians As Single

	For i = LBound( slices(), 1) To UBound( slices(), 1 )
		For j = LBound( slices(), 2 ) To UBound( slices(), 2 )
			slices( i, j ) = Nothing
		Next
	Next

	If Not IsInterface( factory, ID2D1Factory ) Then Exit Function

	c = UBound( values() )

	total = 0!
	For i=0 To c
		total += values(i)
	Next

	ReDim slices( c )
	If params.sweepDegrees.first = 0 And params.sweepDegrees.last = 0 Then params.sweepDegrees.last = 360
	If params.firstRadius.outer = 0 Then params.firstRadius.outer = .5
	If params.firstRadius.inner = 0 Then params.firstRadius.inner = params.firstRadius.outer * .8!
	If params.lastRadius.outer = 0  Then params.lastRadius.outer  = params.firstRadius.outer
	If params.lastRadius.inner = 0  Then params.lastRadius.inner  = params.firstRadius.inner

	outerChangePerdegree = (params.lastRadius.outer-params.firstRadius.outer) / (params.sweepDegrees.last - params.sweepDegrees.first)
	innerChangePerdegree = (params.lastRadius.inner-params.firstRadius.inner) / (params.sweepDegrees.last - params.sweepDegrees.first)

	outerEndRadius = params.firstRadius.outer
	innerEndRadius = params.firstRadius.inner
	sweep          = params.sweepDegrees.last - params.sweepDegrees.first
	a              = params.sweepDegrees.first

	For i=0 To c
		center = params.center
		startAngle = a
		endAngle   = a + sweep * (values(i) / total) - params.gapDegrees

		innerStartRadius = innerEndRadius
		innerEndRadius += (sweep * (values(i) / total)) * innerChangePerDegree

		outerStartRadius = outerEndRadius
		outerEndRadius += (sweep * (values(i) / total)) * outerChangePerDegree
		If params.explodeFunction Then
			Call Dword params.explodeFunction Using DonutExplosion_internal( values(i), i, params.explodeDistance, params.explodeIndex ) To d
			midAngle = (endAngle + startAngle) / 2!
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * d
			center.y += Cos( radians ) * d
		ElseIf params.explodeDistance And params.explodeIndex=i Then
			midAngle = (endAngle + startAngle) / 2
			radians = midAngle * 0.0174532925! + 1.570796326794897!
			center.x += Sin( radians ) * params.explodeDistance
			center.y += Cos( radians ) * params.explodeDistance
		End If

		p.center              = center
		p.firstRadius.outer   = outerStartRadius
		p.firstRadius.inner   = innerStartRadius
		p.lastRadius.outer    = outerEndRadius
		p.lastRadius.inner    = innerEndRadius
		p.sweepDegrees.first  = startAngle
		p.sweepDegrees.last   = endAngle
		p.chevronAmount       = params.chevronAmount

		' Allow spiraling
		DonutWedgePathNew_c2d slices(i), factory, p
		a = endAngle + params.gapDegrees
	Next
End Function

Function ChartSymbolPathsNew_c2d( ByRef obj() As ID2D1PathGeometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws each symbol as a separate path
	Local i, j, h, hr As Long
	Local oCount, cCount, iStep As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local lbv1, ubv1, lbv2, ubv2 As Long

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next
	If LBound( obj(), 1 )>-1 Then Erase obj()

	lbv1 = LBound( xValues(), 1 )
	ubv1 = UBound( xValues(), 1 )
	lbv2 = LBound( xValues(), 2 )
	ubv2 = UBound( xValues(), 2 )

	lb1 = LBound( xPct(), 1 )
	ub1 = UBound( xPct(), 1 )
	lb2 = LBound( xPct(), 2 )
	ub2 = UBound( xPct(), 2 )
	ReDim obj( lbv1 To ubv1, lbv2 To ubv2 )

	oCount = ubv1 - lbv1 + 1
	cCount = ub1 - lb1 + 1
	iStep = cCount / oCount

	For j = lb2 To ub2
		params.j = j
		i = lbv1
		For h = lb1 To ub1 Step iStep
			params.i1 = h
			params.i2 = Min( h + iStep, params.ub1 )
			ChartSymbolPathNew_c2d obj( i, j ), factory, xValues(), yValues(), xPct(), yPct(), params
			Incr i
		Next
	Next
	Function = -1
End Function

Function ChartSymbolSeriesPathsNew_c2d( ByRef obj() As ID2D1Geometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws all symbols for a series in a single path (which means a single outline or fill style per series)
	Local i, j, k, hr As Long
	Local oCount, cCount, iStep As Long
	Local lb1, ub1, lb2, ub2 As Long

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	lb1 = LBound( xPct(), 1 )
	ub1 = UBound( xPct(), 1 )
	lb2 = LBound( xPct(), 2 )
	ub2 = UBound( xPct(), 2 )
	ReDim obj( lb2 To ub2 )

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = ub1 - lb1 + 1
	iStep = cCount / oCount

	For j = lb2 To ub2
		params.j = j
		ChartSymbolSeriesPathNew_c2d obj( j ), factory, xValues(), yValues(), xPct(), yPct(), params
	Next
	Function = -1
End Function

Function ChartSymbolGroupPathsNew_c2d( ByRef obj() As ID2D1Geometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, params As ChartSymbolParams ) As Long
	' Draws all symbols for a group in a single path  (which means a single outline or fill style for the group)
	Local i, j, k, hr As Long
	Local oCount, cCount, iStep As Long
	Local lb1, ub1, lbp1, ubp1 As Long
	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	lb1 = LBound( xValues(), 1 )
	ub1 = UBound( xValues(), 1 )
	lbp1 = LBound( xPct(), 1 )
	ubp1 = UBound( xPct(), 1 )
	ReDim obj( lb1 To ub1 )

	oCount = ub1 - lb1 + 1
	cCount = ubp1 - lbp1 + 1
	iStep = cCount / oCount

	k = lb1
	For i = lbp1 To ubp1 Step iStep
		params.i1 = i
		params.i2 = Min(i + iStep, params.ub1)
		ChartSymbolGroupPathNew_c2d obj( i ), factory, xValues(), yValues(), xPct(), yPct(), params
		Incr k
	Next
	Function = -1
End Function

Function ChartRadarSymbolPathsNew_c2d( ByRef obj() As ID2D1Geometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
	angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws each symbol as a separate path
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local i, j, k, hr As Long
	Local oCount, cCount  As Long
	Local lb1, ub1, lb2, ub2 As Long
	Local lbv1, ubv1, lbv2, ubv2 As Long

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	lbv1 = LBound( xValues(), 1 )
	ubv1 = UBound( xValues(), 1 )
	lbv2 = LBound( xValues(), 2 )
	ubv2 = UBound( xValues(), 2 )

	lb1 = LBound( xPct(), 1 )
	ub1 = UBound( xPct(), 1 )
	lb2 = LBound( xPct(), 2 )
	ub2 = UBound( xPct(), 2 )

	ReDim obj( lbv1 To ubv1, lbv2 To ubv2 )

	oCount = ubv1 - lbv1 + 1
	cCount = ub1 - lb1 + 1
	iStep = cCount / oCount

	For j = lb2 To ub2
		params.j = j
		k = lbv1
		For i = lb1 To ub1 Step iStep
			params.i1 = i
			params.i2 = Min(i + iStep, params.ub1)
			ChartRadarSymbolPathNew_c2d obj( k, j ), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params
			Incr k
		Next
	Next

	Function = -1
End Function

Function ChartRadarSymbolSeriesPathsNew_c2d( ByRef obj() As ID2D1Geometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
	angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws all symbols for a series in a single path (which means a single outline or fill style per series)
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local i, j, k, hr As Long
	Local oCount, cCount As Long
	Local lb1, ub1, lb2, ub2 As Long

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	lb1 = LBound( xPct(), 1 )
	ub1 = UBound( xPct(), 1 )
	lb2 = LBound( xPct(), 2 )
	ub2 = UBound( xPct(), 2 )
	ReDim obj( lb2 To ub2 )

	oCount = UBound( xValues(), 1 ) - LBound( xValues(), 1 ) + 1
	cCount = ub1 - lb1 + 1
	iStep = cCount / oCount

	For j = lb2 To ub2
		params.j = j
		ChartRadarSymbolSeriesPathNew_c2d obj( j ), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params
	Next

	Function = -1
End Function

Function ChartRadarSymbolGroupPathsNew_c2d( ByRef obj() As ID2D1Geometry, ByVal factory As ID2D1Factory, xValues() As Single, yValues() As Single, xPct() As Single, yPct() As Single, _
	angle() As Single, radius() As Single, iStep As Long, params As ChartSymbolParams ) As Long
	' Draws all symbols for a group in a single path  (which means a single outline or fill style for the group)
	'   Expects ChartSetup, ChartRadarSetup_c2d to have been called
	Local i, j, k, hr As Long
	Local oCount, cCount As Long
	Local lb1, ub1, lbp1, ubp1 As Long

	For i = LBound( obj(), 1) To UBound( obj(), 1 )
		For j = LBound( obj(), 2 ) To UBound( obj(), 2 )
			obj( i, j ) = Nothing
		Next
	Next

	lb1 = LBound( xValues(), 1 )
	ub1 = UBound( xValues(), 1 )
	lbp1 = LBound( xPct(), 1 )
	ubp1 = UBound( xPct(), 1 )
	ReDim obj( lb1 To ub1 )


	oCount = ub1 - lb1 + 1
	cCount = ubp1 - lbp1 + 1
	iStep = cCount / oCount

	k = lb1
	For i = lbp1 To ubp1 Step iStep
		params.i1 = i
		params.i2 = Min(i + iStep, params.ub1)
		ChartRadarSymbolGroupPathNew_c2d obj( k ), factory, xValues(), yValues(), xPct(), yPct(), angle(), radius(), iStep, params
		Incr k
	Next

	Function = -1
End Function

Sub SingleColorPaletteNew_c2d( obj As iPalette_c2d, helper As ID2D1Helper, factory As ID2D1Factory, argb As ARGBUnion )
	Local colors() As ARGBUnion
	ReDim colors(0)
	colors(0).value = argb.value

	Call PaletteWithColorsNew_c2d( obj, colors(), helper, factory )
End Sub

Sub ParsePaletteColorString_c2d( ByVal value As WString, colors() As ARGBUnion )
	Local i, j, ff, lineCount, realCount As Long
	Local values(), pieces() As WString
	Local c As ARGBUnion
	Local b() As Byte
	Dim b(3) At VarPtr(c)

	Erase colors()
	lineCount = ParseCount( value, $CrLf )
	ReDim values(lineCount-1)
	Parse value, values(), $CrLf
	realCount = 0
	For i=0 To lineCount-1
		If ParseCount( values(i), "," ) = 4 Then realCount+=1
	Next
	ReDim colors( realCount-1 )
	ReDim pieces(3)
	For i=0 To lineCount-1
		If ParseCount( values(i), "," ) = 4 Then
			Parse values(i), pieces(), ","
			For j=0 To 3
				b(3-j) = Val( Trim$( pieces(j) ) )
			Next
			colors(i).value = c.value
		End If
	Next
End Sub

#If Not %Def( $$PALETTE_DIRECTORY )
$$PALETTE_DIRECTORY = "palettes"
#EndIf

Sub PaletteNamesGet_c2d( names() As WString )
	Local i, capacity, current As Long
	Local fileName As WString

	filename = Dir$( $$PALETTE_DIRECTORY + "\*.palette")
	While filename<>""
		If current>=capacity Then
			capacity += 200
			ReDim Preserve names( capacity-1 )
		End If
		filename = Remove$( filename, ".palette")
		names( current ) = filename
		current += 1
		filename = Dir$
	Wend
	Dir$ Close
	ReDim Preserve names( current-1 )
End Sub

Sub PaletteFromRCDataNew_c2d( obj As iPalette_c2d, helper As ID2D1Helper, factory As ID2D1Factory, ByVal paletteName As WString, ByVal resourceId As Long, Optional ByVal alpha As Byte )
	Local colors() As ARGBUnion
	Local i As Long
	Local value As String

	value = Resource$( RcData, resourceId )
	ParsePaletteColorString_c2d value, colors()
	If alpha<>0 Then
		For i=0 To UBound( colors )
			colors(i).parts.A = alpha
		Next
	End If
	PaletteWithColorsNew_c2d obj, colors(), helper, factory
	obj.Name = paletteName
End Sub

Sub PaletteFromFileNew_c2d( obj As iPalette_c2d, helper As ID2D1Helper, factory As ID2D1Factory, filename As WString, Optional alpha As Byte )
	Local colors() As ARGBUnion
	Local i As Long

	PaletteColorsFromFileLoad_c2d filename, colors()
	If alpha<>0 Then
		For i=0 To UBound( colors )
			colors(i).parts.A = alpha
		Next
	End If
	PaletteWithColorsNew_c2d obj, colors(), helper, factory
	obj.Name = filename
End Sub

Sub PaletteNew( obj As iPalette_c2d, helper As ID2D1Helper, factory As ID2D1Factory )
	obj = Nothing
	obj = Class "cPalette_c2d"
	obj.Initialize( helper, factory )
End Sub

Sub PaletteWithColorsNew_c2d( obj As iPalette_c2d, colors() As ARGBUnion, helper As ID2D1Helper, factory As ID2D1Factory )
	obj = Nothing
	obj = Class "cPalette_c2d"
	obj.Initialize( helper, factory )
	Call PaletteColorsSet_c2d( obj, colors() )
End Sub

Sub PaletteColorsSet_c2d( obj As iPalette_c2d, colors() As ARGBUnion )
	If IsObject(obj) Then obj.SetColors( VarPtr( colors(0) ), UBound( colors() )+1 )
End Sub

Class cPalette_c2d
	Instance colors_() As ARGBUnion
	Instance colorPalette() As ID2D1SolidColorBrush
	Instance grayPalette() As ID2D1SolidColorBrush
	Instance renderTarget_ As ID2D1HwndRenderTarget
	Instance helper_ As ID2D1Helper
	Instance factory_ As ID2D1Factory
	Instance isGray_ As Long
	Instance name_ As WString

	Class Method CreateBrush( ByRef brush As ID2D1SolidColorBrush, ByVal a As Long, ByVal r As Long, ByVal g As Long, ByVal b As Long, Optional ByVal asGray As Long )
		Local brushProperties As D2D1_BRUSH_PROPERTIES
		Local gray As Single
		Local rs, gs, bs, alpha As Single
		rs = r / 255.0!
		gs = g / 255.0!
		bs = b / 255.0!
		alpha = a / 255.0!

		If asGray Then
			gray = 0.21 *rs + 0.72 * gs + 0.07 * bs
			rs = gray
			gs = gray
			bs = gray
		End If

		brushProperties.opacity = alpha
		MatrixIdentity_c2d( brushProperties.transform )
		renderTarget_.CreateSolidColorBrush( helper_.ColorF( rs, gs, bs, alpha ), _
																				brushProperties, _
																				brush )
	End Method

	Class Method CreateBrushes()
		Local i, c As Long
		Local clr As ARGBUnion
		c = UBound( colors_() )

		If Not IsObject( helper_ ) Then Exit Method
		If Not IsObject( renderTarget_ ) Then Exit Method

		ReDim colorPalette(c)
		ReDim grayPalette(c)

		For i=0 To c
			clr.value = colors_(i).value
			Call Me.CreateBrush( colorPalette( i ), clr.parts.A, clr.parts.R,  clr.parts.G, clr.parts.B )
			Call Me.CreateBrush( grayPalette( i ),  clr.parts.A, clr.parts.R,  clr.parts.G, clr.parts.B, 1 )
		Next
	End Method

	Class Method DiscardBrushes()
		Local i As Long
		For i=0 To UBound( colorPalette() )
			colorPalette(i) = Nothing
			grayPalette(i) = Nothing
		Next
	End Method

	Interface iPalette_c2d
		Inherit IUnknown
		Property Get Name() As WString
			Property = name_
		End Property
		Property Set Name( value As WString )
			name_ = value
		End Property
		Method SetColors( ByVal colorAddr As Dword, ByVal colorCount As Long )
			Local i As Long
			Local colors() As Dword
			Dim colors(colorCount-1) At colorAddr
			ReDim colors_( colorCount - 1 )
			For i=0 To colorCount-1
				colors_(i).value = colors(i)
			Next
		End Method

		Method Initialize( helper As ID2D1Helper, factory As ID2D1Factory )
			helper_ = helper
			factory_ = factory
		End Method
		Method AdjustR( value As Byte )
			Local i As Long

			For i=0 To UBound( colors_() )
				colors_(i).parts.R = CByt( Max(255, Min(0, CDwd(value)+CDwd(colors_(i).parts.R))) )
			Next
			If IsObject( renderTarget_ ) Then
				Call Me.DiscardBrushes()
				Call Me.CreateBrushes()
			End If
		End Method
		Method AdjustG( value As Byte )
			Local i As Long

			For i=0 To UBound( colors_() )
				colors_(i).parts.G = CByt( Max(255, Min(0, CDwd(value)+CDwd(colors_(i).parts.G))) )
			Next
			If IsObject( renderTarget_ ) Then
				Call Me.DiscardBrushes()
				Call Me.CreateBrushes()
			End If
		End Method
		Method AdjustB( value As Byte )
			Local i As Long

			For i=0 To UBound( colors_() )
				colors_(i).parts.B = CByt( Max(255, Min(0, CDwd(value)+CDwd(colors_(i).parts.B))) )
			Next
			If IsObject( renderTarget_ ) Then
				Call Me.DiscardBrushes()
				Call Me.CreateBrushes()
			End If
		End Method
		Method SetAlpha( value As Byte )
			Local i As Long

			For i=0 To UBound( colors_() )
				colors_(i).parts.A = value
			Next
			If IsObject( renderTarget_ ) Then
				Call Me.DiscardBrushes()
				Call Me.CreateBrushes()
			End If
		End Method

		Property Get IsGray() As Long
			Property = isGray_
		End Property
		Property Set IsGray( value As Long )
			isGray_ = value
		End Property

		Property Get Count() As Long
			Property = UBound( colorPalette() ) + 1
		End Property

		Method GetBrush( ByVal i As Long, ByRef brush As ID2D1SolidColorBrush, Optional pGetGray As Long )
			Local c, getGray As Long
			c = UBound(colorPalette())
			brush = Nothing
			If IsMissing( pGetGray ) Then
				getGray = isGray_
			Else
				getGray = pGetGray
			End If
			If c>=0 Then
				i Mod= (c+1)
				If getGray Then
					brush = grayPalette(i)
				Else
					brush = colorPalette(i)
				End If
			End If
		End Method
	End Interface

	Interface iDirectRender
		Inherit IUnknown

		Method CreateDeviceResources( ByRef renderTarget As ID2D1HwndRenderTarget )
			renderTarget_ = renderTarget
			Call Me.CreateBrushes()
		End Method

		Method DiscardDeviceResources()
			Call Me.DiscardBrushes()
		End Method

		Method IsHit( x As Single, y As Single, trans As D2D1_MATRIX_3X2_F ) As Long
		End Method

		Method Render( ByVal hWnd As Dword )
		End Method
	End Interface
End Class

Sub PaletteColorsFromFileLoad_c2d( filename As WString, colors() As ARGBUnion )
	Local ff As Long
	Local value As WString

	Erase colors()
	If Dir$( $$PALETTE_DIRECTORY + "\" + filename + ".palette" ) = "" Then Exit Sub

	ff = FreeFile
	Open $$PALETTE_DIRECTORY + "\" + filename + ".palette" For Binary As #ff
	Get$ #ff, Lof(#ff), value
	Close #ff
	ParsePaletteColorString_c2d value, colors()
End Sub

Sub PalettesAllFromFileLoad_c2d( obj() As iPalette_c2d, helper As ID2D1Helper, factory As ID2D1Factory, filenames() As WString )
	Local colors() As ARGBUnion
	Local i, s, e, c As Long
	s = LBound( filenames() )
	e = UBound( filenames() )
	c = e-s
	ReDim obj( c )
	For i=s To e
		PaletteColorsFromFileLoad_c2d filenames(i), colors()
		PaletteWithColorsNew_c2d obj(i), colors(), helper, factory
		obj(i).Name = filenames(i)
	Next
End Sub

Function PaletteIndexFind_c2d( palettes() As iPalette_c2d, paletteName As WString ) As Long
	Local i As Long
	For i=LBound( palettes() ) To UBound( palettes() )
		If IsObject( palettes(i) ) And UCase$( palettes(i).Name ) = UCase$( paletteName ) Then
			Function = i
			Exit Function
		End If
	Next
	Function = -1
End Function

Sub BrushSolidColorNew_c2d( brush As ID2D1Brush, renderTarget As ID2D1HwndRenderTarget, helper As ID2D1Helper, A As Byte, R As Byte, G As Byte, B As Byte )
	Local brushProperties As D2D1_BRUSH_PROPERTIES

	brush = Nothing
	brushProperties.opacity = CSng(A) / 255!
	MatrixIdentity_c2d brushProperties.transform

	renderTarget.CreateSolidColorBrush( helper.ColorF( CSng(R)/255!, CSng(G)/255!, CSng(B)/255!, CSng(A)/255! ), _
																						brushProperties, _
																						brush )
End Sub

Sub BrushSolidColor2New_c2d( brush As ID2D1Brush, renderTarget As ID2D1HwndRenderTarget, helper As ID2D1Helper, clr As Dword )
	Local brushProperties As D2D1_BRUSH_PROPERTIES
	Local c As argbUnion

	brush = Nothing

	c.value = clr

	brushProperties.opacity = 1! 'CSng(c.parts.a) / 255!
	MatrixIdentity_c2d brushProperties.transform

	renderTarget.CreateSolidColorBrush( helper.ColorF( CSng(c.parts.r)/255!, CSng(c.parts.g)/255!, CSng(c.parts.b)/255!, CSng(c.parts.a)/255! ), _
																						brushProperties, _
																						brush )
End Sub

Sub TextUnderlineSet_c2d( textLayout As IDWriteTextLayout, value As String, Optional ByVal startIndex As Long, Optional ByVal length As Long )
	Local textRange As DWRITE_TEXT_RANGE
	If length = 0 Then
		length = Len(value)
	End If
	If startIndex>0 Then Decr startIndex
	textRange.startPosition = startIndex
	textRange.length = length
	textLayout.SetUnderline( -1, textRange )
End Sub

Function TextLayoutNew_c2d( textLayout As IDWriteTextLayout, writeFactory As IDWriteFactory, textFormat As IDWriteTextFormat, value As WStringZ, Optional drawWidth As Long, Optional drawHeight As Long ) As Long
	Local hr, w, h As Long

	textLayout = Nothing
	If IsMissing( drawWidth ) Then
		w = 99999
	Else
		w = drawWidth
	End If
	If IsMissing( drawHeight ) Then
		h = 99999
	Else
		h = drawHeight
	End If
	hr = writeFactory.CreateTextLayout( value, Len(value), _
										textFormat, _
										w, _
										h, _
										textLayout )
	If hr <> %S_Ok Then Exit Function
	Function = -1
End Function

Function TextFormatNew_c2d( textFormat As IDWriteTextFormat, writeFactory As IDWriteFactory, familyName As WStringZ, ByVal fontSize As Single, Optional fontWeight As Dword, Optional fontStyle As Dword ) As Long
	Local hr As Dword
	Local localeName As WStringZ * 260
	Local w,s As Dword

	textFormat = Nothing

	If IsMissing( fontWeight ) Then
		w = %DWRITE_FONT_WEIGHT_NORMAL
	Else
		w = fontWeight
	End If
	If IsMissing( fontStyle ) Then
		s = %DWRITE_FONT_STYLE_NORMAL
	Else
		s = fontStyle
	End If

	If Not IsInterface( writeFactory, IDWriteFactory ) Then Exit Function

	hr = writeFactory.CreateTextFormat( familyName, _
																					Nothing, _
																					w, _
																					s, _
																					%DWRITE_FONT_STRETCH_NORMAL, _
																					fontSize, _
																					localeName, _
																					textFormat )
	If hr <> %S_Ok Then Exit Function
	Function = -1
End Function

Sub TextLayoutRender_c2d( renderTarget As ID2D1HwndRenderTarget, textLayout As IDWriteTextLayout, brush As ID2D1Brush, Optional ByVal center As D2D1_POINT_2F )
	renderTarget.DrawTextLayout( center, textLayout, brush, %D2D1_DRAW_TEXT_OPTIONS_NONE )
End Sub

Sub TextFormatRender_c2d( renderTarget As ID2D1HwndRenderTarget, value As WStringZ, textFormat As IDWriteTextFormat, brush As ID2D1Brush, Optional rc As D2D1_RECT_F )
	Local renderTargetSize As D2D1_SIZE_F
	Local renderSize As D2D1_RECT_F
	If IsMissing( rc ) Then
		renderTargetSize = renderTarget.GetSize(): ' Retrieve the size of the render target.
		renderSize.right = renderTargetSize.width
		renderSize.bottom = renderTargetSize.height
	Else
		renderSize = rc
	End If

	renderTarget.DrawText( value, _
													Len( value ), _
													textFormat, _
													renderSize, _
													brush, _
													%D2D1_DRAW_TEXT_OPTIONS_NONE, _
													%DWRITE_MEASURING_MODE_NATURAL )

End Sub

Function TextPathGet_c2d( figure As ID2D1PathGeometry, factory As ID2D1Factory, ByVal value As WString, familyName As WStringZ, ByVal fontSize As Single, ByVal fontWeight As Dword, ByVal fontStyle As Dword, writeFactory As IDWriteFactory ) As Long
	Local fontCollection As IDWriteFontCollection
	Local fontFamily As IDWriteFontFamily
	Local index, hr As Dword
	Local i, exists As Long
	Local ffont As IDWriteFont
	Local fontFace As IDWriteFontFace
	Local codePoints() As Dword
	Local glyphIndices() As Word
	Local sink As ID2D1GeometrySink

	writeFactory.GetSystemFontCollection( fontCollection, 0 )

	fontCollection.FindFamilyName( familyName, index, exists )
	If IsFalse exists Then Exit Function

	hr = fontCollection.GetFontFamily( index, fontFamily )
	If hr <> %S_Ok Then Exit Function

	hr = fontFamily.GetFirstMatchingFont( fontWeight, _
																	 %DWRITE_FONT_STRETCH_NORMAL, _
																	 fontStyle, _
																	 ffont )
	If hr <> %S_Ok Then Exit Function

	 'METHOD GetMetrics ( _                                ' VTable offset = 44
	 '  BYREF fontMetrics AS DWRITE_FONT_METRICS _         ' __out DWRITE_FONT_METRICS* fontMetrics
	 ')                                                    ' void

	hr = ffont.CreateFontFace( fontFace )
	If hr <> %S_Ok Then Exit Function

	ReDim codePoints( Len(value) )
	ReDim glyphIndices( Len(value) )
	For i=1 To Len(value)
		codePoints(i-1) = Asc( value, i )
	Next
	hr = fontFace.GetGlyphIndices( codePoints(0), Len(value), glyphIndices(0) )
	If hr <> %S_Ok Then Exit Function

	hr = factory.CreatePathGeometry( figure )
	If hr <> %S_Ok Then Exit Function

	hr = figure.Open( sink )
	If hr <> %S_Ok Then Exit Function

	hr = fontFace.GetGlyphRunOutline( fontSize, glyphIndices(0), ByVal 0, ByVal 0, Len(value), 0,0, sink )
	If hr <> %S_Ok Then Exit Function

	sink.Close()
	Function = -1
End Function

Sub ClippingStart_c2d( renderTarget As ID2D1HwndRenderTarget, factory As ID2D1Factory, helper As ID2D1Helper, layer As ID2D1Layer, bounds As ID2D1Geometry )
	' Call renderTarget.PopLayer when done
	renderTarget.CreateLayer( ByVal 0, layer )
	renderTarget.PushLayer( helper.LayerParameters( helper.InfiniteRect, bounds ), layer )
End Sub

Sub Clipping2Start_c2d( layer As ID2D1Layer, renderTarget As ID2D1HwndRenderTarget, factory As ID2D1Factory, helper As ID2D1Helper, l As Long, t As Long, r As Long, b As Long )
	Local clipBounds As D2D1_RECT_F
	Local clipTo As ID2D1Geometry

	clipBounds.Left   = l
	clipBounds.Top    = t
	clipBounds.Right  = r
	clipBounds.Bottom = b

	factory.CreateRectangleGeometry clipBounds, clipTo

	renderTarget.CreateLayer( ByVal 0, layer )
	renderTarget.PushLayer( helper.LayerParameters( helper.InfiniteRect, clipTo ), layer )
End Sub

Sub ClippingStop_c2d( renderTarget As ID2D1HwndRenderTarget )
	renderTarget.PopLayer
End Sub
